/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Drives one brushed DC motor with up to 28V and 5A (peak)
 */
public class BrickDC extends Device {
	public final static int DEVICE_IDENTIFIER = 11;
	public final static String DEVICE_DISPLAY_NAME = "DC Brick";

	public final static byte FUNCTION_SET_VELOCITY = (byte)1;
	public final static byte FUNCTION_GET_VELOCITY = (byte)2;
	public final static byte FUNCTION_GET_CURRENT_VELOCITY = (byte)3;
	public final static byte FUNCTION_SET_ACCELERATION = (byte)4;
	public final static byte FUNCTION_GET_ACCELERATION = (byte)5;
	public final static byte FUNCTION_SET_PWM_FREQUENCY = (byte)6;
	public final static byte FUNCTION_GET_PWM_FREQUENCY = (byte)7;
	public final static byte FUNCTION_FULL_BRAKE = (byte)8;
	public final static byte FUNCTION_GET_STACK_INPUT_VOLTAGE = (byte)9;
	public final static byte FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = (byte)10;
	public final static byte FUNCTION_GET_CURRENT_CONSUMPTION = (byte)11;
	public final static byte FUNCTION_ENABLE = (byte)12;
	public final static byte FUNCTION_DISABLE = (byte)13;
	public final static byte FUNCTION_IS_ENABLED = (byte)14;
	public final static byte FUNCTION_SET_MINIMUM_VOLTAGE = (byte)15;
	public final static byte FUNCTION_GET_MINIMUM_VOLTAGE = (byte)16;
	public final static byte FUNCTION_SET_DRIVE_MODE = (byte)17;
	public final static byte FUNCTION_GET_DRIVE_MODE = (byte)18;
	public final static byte FUNCTION_SET_CURRENT_VELOCITY_PERIOD = (byte)19;
	public final static byte FUNCTION_GET_CURRENT_VELOCITY_PERIOD = (byte)20;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = (byte)231;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = (byte)232;
	public final static byte FUNCTION_GET_SEND_TIMEOUT_COUNT = (byte)233;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE = (byte)234;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE = (byte)235;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)237;
	public final static byte FUNCTION_ENABLE_STATUS_LED = (byte)238;
	public final static byte FUNCTION_DISABLE_STATUS_LED = (byte)239;
	public final static byte FUNCTION_IS_STATUS_LED_ENABLED = (byte)240;
	public final static byte FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = (byte)241;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_BRICKLET_PLUGIN = (byte)246;
	public final static byte FUNCTION_READ_BRICKLET_PLUGIN = (byte)247;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_UNDER_VOLTAGE = 21;
	private final static int CALLBACK_EMERGENCY_SHUTDOWN = 22;
	private final static int CALLBACK_VELOCITY_REACHED = 23;
	private final static int CALLBACK_CURRENT_VELOCITY = 24;

	public final static short DRIVE_MODE_DRIVE_BRAKE = (short)0;
	public final static short DRIVE_MODE_DRIVE_COAST = (short)1;
	public final static short COMMUNICATION_METHOD_NONE = (short)0;
	public final static short COMMUNICATION_METHOD_USB = (short)1;
	public final static short COMMUNICATION_METHOD_SPI_STACK = (short)2;
	public final static short COMMUNICATION_METHOD_CHIBI = (short)3;
	public final static short COMMUNICATION_METHOD_RS485 = (short)4;
	public final static short COMMUNICATION_METHOD_WIFI = (short)5;
	public final static short COMMUNICATION_METHOD_ETHERNET = (short)6;
	public final static short COMMUNICATION_METHOD_WIFI_V2 = (short)7;

	private List<UnderVoltageListener> listenerUnderVoltage = new CopyOnWriteArrayList<UnderVoltageListener>();
	private List<EmergencyShutdownListener> listenerEmergencyShutdown = new CopyOnWriteArrayList<EmergencyShutdownListener>();
	private List<VelocityReachedListener> listenerVelocityReached = new CopyOnWriteArrayList<VelocityReachedListener>();
	private List<CurrentVelocityListener> listenerCurrentVelocity = new CopyOnWriteArrayList<CurrentVelocityListener>();

	public class SPITFPBaudrateConfig {
		public boolean enableDynamicBaudrate;
		public long minimumDynamicBaudrate;

		public String toString() {
			return "[" + "enableDynamicBaudrate = " + enableDynamicBaudrate + ", " + "minimumDynamicBaudrate = " + minimumDynamicBaudrate + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountACKChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountACKChecksum = " + errorCountACKChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	public class Protocol1BrickletName {
		public short protocolVersion;
		public short[] firmwareVersion = new short[3];
		public String name;

		public String toString() {
			return "[" + "protocolVersion = " + protocolVersion + ", " + "firmwareVersion = " + Arrays.toString(firmwareVersion) + ", " + "name = " + name + "]";
		}
	}

	/**
	 * This listener is triggered when the input voltage drops below the value set by
	 * {@link BrickDC#setMinimumVoltage(int)}. The parameter is the current voltage.
	 */
	public interface UnderVoltageListener extends DeviceListener {
		public void underVoltage(int voltage);
	}

	/**
	 * This listener is triggered if either the current consumption
	 * is too high (above 5A) or the temperature of the driver chip is too high
	 * (above 175°C). These two possibilities are essentially the same, since the
	 * temperature will reach this threshold immediately if the motor consumes too
	 * much current. In case of a voltage below 3.3V (external or stack) this
	 * listener is triggered as well.
	 * 
	 * If this listener is triggered, the driver chip gets disabled at the same time.
	 * That means, {@link BrickDC#enable()} has to be called to drive the motor again.
	 * 
	 * \note
	 *  This listener only works in Drive/Brake mode (see {@link BrickDC#setDriveMode(short)}). In
	 *  Drive/Coast mode it is unfortunately impossible to reliably read the
	 *  overcurrent/overtemperature signal from the driver chip.
	 */
	public interface EmergencyShutdownListener extends DeviceListener {
		public void emergencyShutdown();
	}

	/**
	 * This listener is triggered whenever a set velocity is reached. For example:
	 * If a velocity of 0 is present, acceleration is set to 5000 and velocity
	 * to 10000, the {@link BrickDC.VelocityReachedListener} listener will be triggered after about
	 * 2 seconds, when the set velocity is actually reached.
	 * 
	 * \note
	 *  Since we can't get any feedback from the DC motor, this only works if the
	 *  acceleration (see {@link BrickDC#setAcceleration(int)}) is set smaller or equal to the
	 *  maximum acceleration of the motor. Otherwise the motor will lag behind the
	 *  control value and the listener will be triggered too early.
	 */
	public interface VelocityReachedListener extends DeviceListener {
		public void velocityReached(short velocity);
	}

	/**
	 * This listener is triggered with the period that is set by
	 * {@link BrickDC#setCurrentVelocityPeriod(int)}. The parameter is the *current*
	 * velocity used by the motor.
	 * 
	 * The {@link BrickDC.CurrentVelocityListener} listener is only triggered after the set period
	 * if there is a change in the velocity.
	 */
	public interface CurrentVelocityListener extends DeviceListener {
		public void currentVelocity(short velocity);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickDC(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 3;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_VELOCITY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_VELOCITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_VELOCITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ACCELERATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_PWM_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PWM_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_FULL_BRAKE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STACK_INPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_CONSUMPTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MINIMUM_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MINIMUM_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DRIVE_MODE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DRIVE_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CURRENT_VELOCITY_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_VELOCITY_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SEND_TIMEOUT_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_STATUS_LED_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PROTOCOL1_BRICKLET_NAME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_UNDER_VOLTAGE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = IPConnectionBase.unsignedShort(bb.getShort());

				for (UnderVoltageListener listener: listenerUnderVoltage) {
					listener.underVoltage(voltage);
				}
			}
		};

		callbacks[CALLBACK_EMERGENCY_SHUTDOWN] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 8) {
					return; // silently ignoring callback with wrong length
				}

				for (EmergencyShutdownListener listener: listenerEmergencyShutdown) {
					listener.emergencyShutdown();
				}
			}
		};

		callbacks[CALLBACK_VELOCITY_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short velocity = (bb.getShort());

				for (VelocityReachedListener listener: listenerVelocityReached) {
					listener.velocityReached(velocity);
				}
			}
		};

		callbacks[CALLBACK_CURRENT_VELOCITY] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short velocity = (bb.getShort());

				for (CurrentVelocityListener listener: listenerCurrentVelocity) {
					listener.currentVelocity(velocity);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the velocity of the motor. Whereas -32767 is full speed backward,
	 * 0 is stop and 32767 is full speed forward. Depending on the
	 * acceleration (see {@link BrickDC#setAcceleration(int)}), the motor is not immediately
	 * brought to the velocity but smoothly accelerated.
	 * 
	 * The velocity describes the duty cycle of the PWM with which the motor is
	 * controlled, e.g. a velocity of 3277 sets a PWM with a 10% duty cycle.
	 * You can not only control the duty cycle of the PWM but also the frequency,
	 * see {@link BrickDC#setPWMFrequency(int)}.
	 */
	public void setVelocity(short velocity) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VELOCITY, this);

		bb.putShort(velocity);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the velocity as set by {@link BrickDC#setVelocity(short)}.
	 */
	public short getVelocity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VELOCITY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short velocity = (bb.getShort());

		return velocity;
	}

	/**
	 * Returns the *current* velocity of the motor. This value is different
	 * from {@link BrickDC#getVelocity()} whenever the motor is currently accelerating
	 * to a goal set by {@link BrickDC#setVelocity(short)}.
	 */
	public short getCurrentVelocity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_VELOCITY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short velocity = (bb.getShort());

		return velocity;
	}

	/**
	 * Sets the acceleration of the motor. It is given in *velocity/s*. An
	 * acceleration of 10000 means, that every second the velocity is increased
	 * by 10000 (or about 30% duty cycle).
	 * 
	 * For example: If the current velocity is 0 and you want to accelerate to a
	 * velocity of 16000 (about 50% duty cycle) in 10 seconds, you should set
	 * an acceleration of 1600.
	 * 
	 * If acceleration is set to 0, there is no speed ramping, i.e. a new velocity
	 * is immediately given to the motor.
	 */
	public void setAcceleration(int acceleration) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_ACCELERATION, this);

		bb.putShort((short)acceleration);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the acceleration as set by {@link BrickDC#setAcceleration(int)}.
	 */
	public int getAcceleration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int acceleration = IPConnectionBase.unsignedShort(bb.getShort());

		return acceleration;
	}

	/**
	 * Sets the frequency of the PWM with which the motor is driven.
	 * Often a high frequency
	 * is less noisy and the motor runs smoother. However, with a low frequency
	 * there are less switches and therefore fewer switching losses. Also with
	 * most motors lower frequencies enable higher torque.
	 * 
	 * If you have no idea what all this means, just ignore this function and use
	 * the default frequency, it will very likely work fine.
	 */
	public void setPWMFrequency(int frequency) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_PWM_FREQUENCY, this);

		bb.putShort((short)frequency);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the PWM frequency as set by {@link BrickDC#setPWMFrequency(int)}.
	 */
	public int getPWMFrequency() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PWM_FREQUENCY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int frequency = IPConnectionBase.unsignedShort(bb.getShort());

		return frequency;
	}

	/**
	 * Executes an active full brake.
	 * 
	 * \warning
	 *  This function is for emergency purposes,
	 *  where an immediate brake is necessary. Depending on the current velocity and
	 *  the strength of the motor, a full brake can be quite violent.
	 * 
	 * Call {@link BrickDC#setVelocity(short)} with 0 if you just want to stop the motor.
	 */
	public void fullBrake() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_FULL_BRAKE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the stack input voltage. The stack input voltage is the
	 * voltage that is supplied via the stack, i.e. it is given by a
	 * Step-Down or Step-Up Power Supply.
	 */
	public int getStackInputVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STACK_INPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the external input voltage. The external input voltage is
	 * given via the black power input connector on the DC Brick.
	 * 
	 * If there is an external input voltage and a stack input voltage, the motor
	 * will be driven by the external input voltage. If there is only a stack
	 * voltage present, the motor will be driven by this voltage.
	 * 
	 * \warning
	 *  This means, if you have a high stack voltage and a low external voltage,
	 *  the motor will be driven with the low external voltage. If you then remove
	 *  the external connection, it will immediately be driven by the high
	 *  stack voltage.
	 */
	public int getExternalInputVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the current consumption of the motor.
	 */
	public int getCurrentConsumption() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_CONSUMPTION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Enables the driver chip. The driver parameters can be configured (velocity,
	 * acceleration, etc) before it is enabled.
	 */
	public void enable() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the driver chip. The configurations are kept (velocity,
	 * acceleration, etc) but the motor is not driven until it is enabled again.
	 * 
	 * \warning
	 *  Disabling the driver chip while the motor is still turning can damage the
	 *  driver chip. The motor should be stopped calling {@link BrickDC#setVelocity(short)} with 0
	 *  before disabling the motor power. The {@link BrickDC#setVelocity(short)} function will **not**
	 *  wait until the motor is actually stopped. You have to explicitly wait for the
	 *  appropriate time after calling the {@link BrickDC#setVelocity(short)} function before calling
	 *  the {@link BrickDC#disable()} function.
	 */
	public void disable() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the driver chip is enabled, *false* otherwise.
	 */
	public boolean isEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Sets the minimum voltage, below which the {@link BrickDC.UnderVoltageListener} listener
	 * is triggered. The minimum possible value that works with the DC Brick is 6V.
	 * You can use this function to detect the discharge of a battery that is used
	 * to drive the motor. If you have a fixed power supply, you likely do not need
	 * this functionality.
	 */
	public void setMinimumVoltage(int voltage) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_MINIMUM_VOLTAGE, this);

		bb.putShort((short)voltage);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the minimum voltage as set by {@link BrickDC#setMinimumVoltage(int)}
	 */
	public int getMinimumVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MINIMUM_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Sets the drive mode. Possible modes are:
	 * 
	 * * 0 = Drive/Brake
	 * * 1 = Drive/Coast
	 * 
	 * These modes are different kinds of motor controls.
	 * 
	 * In Drive/Brake mode, the motor is always either driving or braking. There
	 * is no freewheeling. Advantages are: A more linear correlation between
	 * PWM and velocity, more exact accelerations and the possibility to drive
	 * with slower velocities.
	 * 
	 * In Drive/Coast mode, the motor is always either driving or freewheeling.
	 * Advantages are: Less current consumption and less demands on the motor and
	 * driver chip.
	 */
	public void setDriveMode(short mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_DRIVE_MODE, this);

		bb.put((byte)mode);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the drive mode, as set by {@link BrickDC#setDriveMode(short)}.
	 */
	public short getDriveMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DRIVE_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets a period with which the {@link BrickDC.CurrentVelocityListener} listener is triggered.
	 * A period of 0 turns the listener off.
	 */
	public void setCurrentVelocityPeriod(int period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CURRENT_VELOCITY_PERIOD, this);

		bb.putShort((short)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickDC#setCurrentVelocityPeriod(int)}.
	 */
	public int getCurrentVelocityPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_VELOCITY_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int period = IPConnectionBase.unsignedShort(bb.getShort());

		return period;
	}

	/**
	 * The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
	 * enabled, the Brick will try to adapt the baudrate for the communication
	 * between Bricks and Bricklets according to the amount of data that is transferred.
	 * 
	 * The baudrate will be increased exponentially if lots of data is sent/received and
	 * decreased linearly if little data is sent/received.
	 * 
	 * This lowers the baudrate in applications where little data is transferred (e.g.
	 * a weather station) and increases the robustness. If there is lots of data to transfer
	 * (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
	 * 
	 * In cases where some data has to transferred as fast as possible every few seconds
	 * (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
	 * the dynamic baudrate off to get the highest possible performance.
	 * 
	 * The maximum value of the baudrate can be set per port with the function
	 * {@link BrickDC#setSPITFPBaudrate(char, long)}. If the dynamic baudrate is disabled, the baudrate
	 * as set by {@link BrickDC#setSPITFPBaudrate(char, long)} will be used statically.
	 * 
	 * .. versionadded:: 2.3.5$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, this);

		bb.put((byte)(enableDynamicBaudrate ? 1 : 0));
		bb.putInt((int)minimumDynamicBaudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate config, see {@link BrickDC#setSPITFPBaudrateConfig(boolean, long)}.
	 * 
	 * .. versionadded:: 2.3.5$nbsp;(Firmware)
	 */
	public SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPBaudrateConfig obj = new SPITFPBaudrateConfig();
		obj.enableDynamicBaudrate = (bb.get()) != 0;
		obj.minimumDynamicBaudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the timeout count for the different communication methods.
	 * 
	 * The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
	 * 
	 * This function is mostly used for debugging during development, in normal operation
	 * the counters should nearly always stay at 0.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public long getSendTimeoutCount(short communicationMethod) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SEND_TIMEOUT_COUNT, this);

		bb.put((byte)communicationMethod);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long timeoutCount = IPConnectionBase.unsignedInt(bb.getInt());

		return timeoutCount;
	}

	/**
	 * Sets the baudrate for a specific Bricklet port.
	 * 
	 * If you want to increase the throughput of Bricklets you can increase
	 * the baudrate. If you get a high error count because of high
	 * interference (see {@link BrickDC#getSPITFPErrorCount(char)}) you can decrease the
	 * baudrate.
	 * 
	 * If the dynamic baudrate feature is enabled, the baudrate set by this
	 * function corresponds to the maximum baudrate (see {@link BrickDC#setSPITFPBaudrateConfig(boolean, long)}).
	 * 
	 * Regulatory testing is done with the default baudrate. If CE compatibility
	 * or similar is necessary in your applications we recommend to not change
	 * the baudrate.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);
		bb.putInt((int)baudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate for a given Bricklet port, see {@link BrickDC#setSPITFPBaudrate(char, long)}.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long baudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return baudrate;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Brick side. All
	 * Bricklets have a similar function that returns the errors on the Bricklet side.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_ERROR_COUNT, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountACKChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Enables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void enableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void disableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the status LED is enabled, *false* otherwise.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public boolean isStatusLEDEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_STATUS_LED_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Returns the firmware and protocol version and the name of the Bricklet for a
	 * given port.
	 * 
	 * This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
	 * plugins.
	 */
	public Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array(), 52);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Protocol1BrickletName obj = new Protocol1BrickletName();
		obj.protocolVersion = IPConnectionBase.unsignedByte(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.name = IPConnectionBase.string(bb, 40);

		return obj;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has an
	 * accuracy of ±15%. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public short getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Brick. Calling this function
	 * on a Brick inside of a stack will reset the whole stack.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 32 bytes of firmware to the bricklet attached at the given port.
	 * The bytes are written to the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void writeBrickletPlugin(char port, short offset, short[] chunk) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)42, FUNCTION_WRITE_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);
		for (int i = 0; i < 32; i++) {
			bb.put((byte)chunk[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Reads 32 bytes of firmware from the bricklet attached at the given port.
	 * The bytes are read starting at the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public short[] readBrickletPlugin(char port, short offset) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_READ_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);

		byte[] response = sendRequest(bb.array(), 40);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] chunk = new short[32];
		for (int i = 0; i < 32; i++) {
			chunk[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return chunk;
	}

	/**
	 * Returns the UID, the UID where the Brick is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position is the position in the stack from '0' (bottom) to '8' (top).
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a UnderVoltage listener.
	 */
	public void addUnderVoltageListener(UnderVoltageListener listener) {
		listenerUnderVoltage.add(listener);
	}

	/**
	 * Removes a UnderVoltage listener.
	 */
	public void removeUnderVoltageListener(UnderVoltageListener listener) {
		listenerUnderVoltage.remove(listener);
	}

	/**
	 * Adds a EmergencyShutdown listener.
	 */
	public void addEmergencyShutdownListener(EmergencyShutdownListener listener) {
		listenerEmergencyShutdown.add(listener);
	}

	/**
	 * Removes a EmergencyShutdown listener.
	 */
	public void removeEmergencyShutdownListener(EmergencyShutdownListener listener) {
		listenerEmergencyShutdown.remove(listener);
	}

	/**
	 * Adds a VelocityReached listener.
	 */
	public void addVelocityReachedListener(VelocityReachedListener listener) {
		listenerVelocityReached.add(listener);
	}

	/**
	 * Removes a VelocityReached listener.
	 */
	public void removeVelocityReachedListener(VelocityReachedListener listener) {
		listenerVelocityReached.remove(listener);
	}

	/**
	 * Adds a CurrentVelocity listener.
	 */
	public void addCurrentVelocityListener(CurrentVelocityListener listener) {
		listenerCurrentVelocity.add(listener);
	}

	/**
	 * Removes a CurrentVelocity listener.
	 */
	public void removeCurrentVelocityListener(CurrentVelocityListener listener) {
		listenerCurrentVelocity.remove(listener);
	}
}
