/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Full fledged AHRS with 9 degrees of freedom
 */
public class BrickIMU extends Device {
	public final static int DEVICE_IDENTIFIER = 16;
	public final static String DEVICE_DISPLAY_NAME = "IMU Brick";

	public final static byte FUNCTION_GET_ACCELERATION = (byte)1;
	public final static byte FUNCTION_GET_MAGNETIC_FIELD = (byte)2;
	public final static byte FUNCTION_GET_ANGULAR_VELOCITY = (byte)3;
	public final static byte FUNCTION_GET_ALL_DATA = (byte)4;
	public final static byte FUNCTION_GET_ORIENTATION = (byte)5;
	public final static byte FUNCTION_GET_QUATERNION = (byte)6;
	public final static byte FUNCTION_GET_IMU_TEMPERATURE = (byte)7;
	public final static byte FUNCTION_LEDS_ON = (byte)8;
	public final static byte FUNCTION_LEDS_OFF = (byte)9;
	public final static byte FUNCTION_ARE_LEDS_ON = (byte)10;
	public final static byte FUNCTION_SET_ACCELERATION_RANGE = (byte)11;
	public final static byte FUNCTION_GET_ACCELERATION_RANGE = (byte)12;
	public final static byte FUNCTION_SET_MAGNETOMETER_RANGE = (byte)13;
	public final static byte FUNCTION_GET_MAGNETOMETER_RANGE = (byte)14;
	public final static byte FUNCTION_SET_CONVERGENCE_SPEED = (byte)15;
	public final static byte FUNCTION_GET_CONVERGENCE_SPEED = (byte)16;
	public final static byte FUNCTION_SET_CALIBRATION = (byte)17;
	public final static byte FUNCTION_GET_CALIBRATION = (byte)18;
	public final static byte FUNCTION_SET_ACCELERATION_PERIOD = (byte)19;
	public final static byte FUNCTION_GET_ACCELERATION_PERIOD = (byte)20;
	public final static byte FUNCTION_SET_MAGNETIC_FIELD_PERIOD = (byte)21;
	public final static byte FUNCTION_GET_MAGNETIC_FIELD_PERIOD = (byte)22;
	public final static byte FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = (byte)23;
	public final static byte FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = (byte)24;
	public final static byte FUNCTION_SET_ALL_DATA_PERIOD = (byte)25;
	public final static byte FUNCTION_GET_ALL_DATA_PERIOD = (byte)26;
	public final static byte FUNCTION_SET_ORIENTATION_PERIOD = (byte)27;
	public final static byte FUNCTION_GET_ORIENTATION_PERIOD = (byte)28;
	public final static byte FUNCTION_SET_QUATERNION_PERIOD = (byte)29;
	public final static byte FUNCTION_GET_QUATERNION_PERIOD = (byte)30;
	public final static byte FUNCTION_ORIENTATION_CALCULATION_ON = (byte)37;
	public final static byte FUNCTION_ORIENTATION_CALCULATION_OFF = (byte)38;
	public final static byte FUNCTION_IS_ORIENTATION_CALCULATION_ON = (byte)39;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = (byte)231;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = (byte)232;
	public final static byte FUNCTION_GET_SEND_TIMEOUT_COUNT = (byte)233;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE = (byte)234;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE = (byte)235;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)237;
	public final static byte FUNCTION_ENABLE_STATUS_LED = (byte)238;
	public final static byte FUNCTION_DISABLE_STATUS_LED = (byte)239;
	public final static byte FUNCTION_IS_STATUS_LED_ENABLED = (byte)240;
	public final static byte FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = (byte)241;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_BRICKLET_PLUGIN = (byte)246;
	public final static byte FUNCTION_READ_BRICKLET_PLUGIN = (byte)247;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_ACCELERATION = 31;
	private final static int CALLBACK_MAGNETIC_FIELD = 32;
	private final static int CALLBACK_ANGULAR_VELOCITY = 33;
	private final static int CALLBACK_ALL_DATA = 34;
	private final static int CALLBACK_ORIENTATION = 35;
	private final static int CALLBACK_QUATERNION = 36;

	public final static short CALIBRATION_TYPE_ACCELEROMETER_GAIN = (short)0;
	public final static short CALIBRATION_TYPE_ACCELEROMETER_BIAS = (short)1;
	public final static short CALIBRATION_TYPE_MAGNETOMETER_GAIN = (short)2;
	public final static short CALIBRATION_TYPE_MAGNETOMETER_BIAS = (short)3;
	public final static short CALIBRATION_TYPE_GYROSCOPE_GAIN = (short)4;
	public final static short CALIBRATION_TYPE_GYROSCOPE_BIAS = (short)5;
	public final static short COMMUNICATION_METHOD_NONE = (short)0;
	public final static short COMMUNICATION_METHOD_USB = (short)1;
	public final static short COMMUNICATION_METHOD_SPI_STACK = (short)2;
	public final static short COMMUNICATION_METHOD_CHIBI = (short)3;
	public final static short COMMUNICATION_METHOD_RS485 = (short)4;
	public final static short COMMUNICATION_METHOD_WIFI = (short)5;
	public final static short COMMUNICATION_METHOD_ETHERNET = (short)6;
	public final static short COMMUNICATION_METHOD_WIFI_V2 = (short)7;

	private List<AccelerationListener> listenerAcceleration = new CopyOnWriteArrayList<AccelerationListener>();
	private List<MagneticFieldListener> listenerMagneticField = new CopyOnWriteArrayList<MagneticFieldListener>();
	private List<AngularVelocityListener> listenerAngularVelocity = new CopyOnWriteArrayList<AngularVelocityListener>();
	private List<AllDataListener> listenerAllData = new CopyOnWriteArrayList<AllDataListener>();
	private List<OrientationListener> listenerOrientation = new CopyOnWriteArrayList<OrientationListener>();
	private List<QuaternionListener> listenerQuaternion = new CopyOnWriteArrayList<QuaternionListener>();

	public class Acceleration {
		public short x;
		public short y;
		public short z;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class MagneticField {
		public short x;
		public short y;
		public short z;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class AngularVelocity {
		public short x;
		public short y;
		public short z;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class AllData {
		public short accX;
		public short accY;
		public short accZ;
		public short magX;
		public short magY;
		public short magZ;
		public short angX;
		public short angY;
		public short angZ;
		public short temperature;

		public String toString() {
			return "[" + "accX = " + accX + ", " + "accY = " + accY + ", " + "accZ = " + accZ + ", " + "magX = " + magX + ", " + "magY = " + magY + ", " + "magZ = " + magZ + ", " + "angX = " + angX + ", " + "angY = " + angY + ", " + "angZ = " + angZ + ", " + "temperature = " + temperature + "]";
		}
	}

	public class Orientation {
		public short roll;
		public short pitch;
		public short yaw;

		public String toString() {
			return "[" + "roll = " + roll + ", " + "pitch = " + pitch + ", " + "yaw = " + yaw + "]";
		}
	}

	public class Quaternion {
		public float x;
		public float y;
		public float z;
		public float w;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + ", " + "w = " + w + "]";
		}
	}

	public class SPITFPBaudrateConfig {
		public boolean enableDynamicBaudrate;
		public long minimumDynamicBaudrate;

		public String toString() {
			return "[" + "enableDynamicBaudrate = " + enableDynamicBaudrate + ", " + "minimumDynamicBaudrate = " + minimumDynamicBaudrate + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountACKChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountACKChecksum = " + errorCountACKChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	public class Protocol1BrickletName {
		public short protocolVersion;
		public short[] firmwareVersion = new short[3];
		public String name;

		public String toString() {
			return "[" + "protocolVersion = " + protocolVersion + ", " + "firmwareVersion = " + Arrays.toString(firmwareVersion) + ", " + "name = " + name + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setAccelerationPeriod(long)}. The parameters are the acceleration
	 * for the x, y and z axis.
	 */
	public interface AccelerationListener extends DeviceListener {
		public void acceleration(short x, short y, short z);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setMagneticFieldPeriod(long)}. The parameters are the magnetic
	 * field for the x, y and z axis.
	 */
	public interface MagneticFieldListener extends DeviceListener {
		public void magneticField(short x, short y, short z);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setAngularVelocityPeriod(long)}. The parameters are the angular
	 * velocity for the x, y and z axis.
	 */
	public interface AngularVelocityListener extends DeviceListener {
		public void angularVelocity(short x, short y, short z);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setAllDataPeriod(long)}. The parameters are the acceleration,
	 * the magnetic field and the angular velocity for the x, y and z axis as
	 * well as the temperature of the IMU Brick.
	 */
	public interface AllDataListener extends DeviceListener {
		public void allData(short accX, short accY, short accZ, short magX, short magY, short magZ, short angX, short angY, short angZ, short temperature);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setOrientationPeriod(long)}. The parameters are the orientation
	 * (roll, pitch and yaw) of the IMU Brick in Euler angles. See
	 * {@link BrickIMU#getOrientation()} for details.
	 */
	public interface OrientationListener extends DeviceListener {
		public void orientation(short roll, short pitch, short yaw);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickIMU#setQuaternionPeriod(long)}. The parameters are the orientation
	 * (x, y, z, w) of the IMU Brick in quaternions. See {@link BrickIMU#getQuaternion()}
	 * for details.
	 */
	public interface QuaternionListener extends DeviceListener {
		public void quaternion(float x, float y, float z, float w);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickIMU(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 4;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MAGNETIC_FIELD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ANGULAR_VELOCITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALL_DATA)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ORIENTATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_QUATERNION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IMU_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_LEDS_ON)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_LEDS_OFF)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ARE_LEDS_ON)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ACCELERATION_RANGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION_RANGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MAGNETOMETER_RANGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MAGNETOMETER_RANGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONVERGENCE_SPEED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONVERGENCE_SPEED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ACCELERATION_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MAGNETIC_FIELD_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MAGNETIC_FIELD_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ANGULAR_VELOCITY_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ANGULAR_VELOCITY_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ALL_DATA_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALL_DATA_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ORIENTATION_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ORIENTATION_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_QUATERNION_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_QUATERNION_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ORIENTATION_CALCULATION_ON)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ORIENTATION_CALCULATION_OFF)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_ORIENTATION_CALCULATION_ON)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SEND_TIMEOUT_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_STATUS_LED_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PROTOCOL1_BRICKLET_NAME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_ACCELERATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 14) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				for (AccelerationListener listener: listenerAcceleration) {
					listener.acceleration(x, y, z);
				}
			}
		};

		callbacks[CALLBACK_MAGNETIC_FIELD] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 14) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				for (MagneticFieldListener listener: listenerMagneticField) {
					listener.magneticField(x, y, z);
				}
			}
		};

		callbacks[CALLBACK_ANGULAR_VELOCITY] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 14) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());
				short z = (bb.getShort());

				for (AngularVelocityListener listener: listenerAngularVelocity) {
					listener.angularVelocity(x, y, z);
				}
			}
		};

		callbacks[CALLBACK_ALL_DATA] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 28) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short accX = (bb.getShort());
				short accY = (bb.getShort());
				short accZ = (bb.getShort());
				short magX = (bb.getShort());
				short magY = (bb.getShort());
				short magZ = (bb.getShort());
				short angX = (bb.getShort());
				short angY = (bb.getShort());
				short angZ = (bb.getShort());
				short temperature = (bb.getShort());

				for (AllDataListener listener: listenerAllData) {
					listener.allData(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
				}
			}
		};

		callbacks[CALLBACK_ORIENTATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 14) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short roll = (bb.getShort());
				short pitch = (bb.getShort());
				short yaw = (bb.getShort());

				for (OrientationListener listener: listenerOrientation) {
					listener.orientation(roll, pitch, yaw);
				}
			}
		};

		callbacks[CALLBACK_QUATERNION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 24) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				float x = (bb.getFloat());
				float y = (bb.getFloat());
				float z = (bb.getFloat());
				float w = (bb.getFloat());

				for (QuaternionListener listener: listenerQuaternion) {
					listener.quaternion(x, y, z, w);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the calibrated acceleration from the accelerometer for the
	 * x, y and z axis.
	 * 
	 * If you want to get the acceleration periodically, it is recommended
	 * to use the {@link BrickIMU.AccelerationListener} listener and set the period with
	 * {@link BrickIMU#setAccelerationPeriod(long)}.
	 */
	public Acceleration getAcceleration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Acceleration obj = new Acceleration();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		return obj;
	}

	/**
	 * Returns the calibrated magnetic field from the magnetometer for the
	 * x, y and z axis.
	 * 
	 * If you want to get the magnetic field periodically, it is recommended
	 * to use the {@link BrickIMU.MagneticFieldListener} listener and set the period with
	 * {@link BrickIMU#setMagneticFieldPeriod(long)}.
	 */
	public MagneticField getMagneticField() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MAGNETIC_FIELD, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		MagneticField obj = new MagneticField();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		return obj;
	}

	/**
	 * Returns the calibrated angular velocity from the gyroscope for the
	 * x, y and z axis in °/14.375s (you have to divide by 14.375 to
	 * get the value in °/s).
	 * 
	 * If you want to get the angular velocity periodically, it is recommended
	 * to use the {@link BrickIMU.AngularVelocityListener} listener and set the period with
	 * {@link BrickIMU#setAngularVelocityPeriod(long)}.
	 */
	public AngularVelocity getAngularVelocity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ANGULAR_VELOCITY, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AngularVelocity obj = new AngularVelocity();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());
		obj.z = (bb.getShort());

		return obj;
	}

	/**
	 * Returns the data from {@link BrickIMU#getAcceleration()}, {@link BrickIMU#getMagneticField()}
	 * and {@link BrickIMU#getAngularVelocity()} as well as the temperature of the IMU Brick.
	 * 
	 * If you want to get the data periodically, it is recommended
	 * to use the {@link BrickIMU.AllDataListener} listener and set the period with
	 * {@link BrickIMU#setAllDataPeriod(long)}.
	 */
	public AllData getAllData() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_DATA, this);


		byte[] response = sendRequest(bb.array(), 28);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllData obj = new AllData();
		obj.accX = (bb.getShort());
		obj.accY = (bb.getShort());
		obj.accZ = (bb.getShort());
		obj.magX = (bb.getShort());
		obj.magY = (bb.getShort());
		obj.magZ = (bb.getShort());
		obj.angX = (bb.getShort());
		obj.angY = (bb.getShort());
		obj.angZ = (bb.getShort());
		obj.temperature = (bb.getShort());

		return obj;
	}

	/**
	 * Returns the current orientation (roll, pitch, yaw) of the IMU Brick as Euler
	 * angles. Note that Euler angles always experience a
	 * `gimbal lock &lt;https://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
	 * 
	 * We recommend that you use quaternions instead.
	 * 
	 * The order to sequence in which the orientation values should be applied is
	 * roll, yaw, pitch.
	 * 
	 * If you want to get the orientation periodically, it is recommended
	 * to use the {@link BrickIMU.OrientationListener} listener and set the period with
	 * {@link BrickIMU#setOrientationPeriod(long)}.
	 */
	public Orientation getOrientation() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ORIENTATION, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Orientation obj = new Orientation();
		obj.roll = (bb.getShort());
		obj.pitch = (bb.getShort());
		obj.yaw = (bb.getShort());

		return obj;
	}

	/**
	 * Returns the current orientation (x, y, z, w) of the IMU as
	 * `quaternions &lt;https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation&gt;`__.
	 * 
	 * You can go from quaternions to Euler angles with the following formula::
	 * 
	 *  xAngle = atan2(2*y*w - 2*x*z, 1 - 2*y*y - 2*z*z)
	 *  yAngle = atan2(2*x*w - 2*y*z, 1 - 2*x*x - 2*z*z)
	 *  zAngle =  asin(2*x*y + 2*z*w)
	 * 
	 * This process is not reversible, because of the
	 * `gimbal lock &lt;https://en.wikipedia.org/wiki/Gimbal_lock&gt;`__.
	 * 
	 * It is also possible to calculate independent angles. You can calculate
	 * yaw, pitch and roll in a right-handed vehicle coordinate system according to
	 * DIN70000 with::
	 * 
	 *  yaw   =  atan2(2*x*y + 2*w*z, w*w + x*x - y*y - z*z)
	 *  pitch = -asin(2*w*y - 2*x*z)
	 *  roll  = -atan2(2*y*z + 2*w*x, -w*w + x*x + y*y - z*z))
	 * 
	 * Converting the quaternions to an OpenGL transformation matrix is
	 * possible with the following formula::
	 * 
	 *  matrix = [[1 - 2*(y*y + z*z),     2*(x*y - w*z),     2*(x*z + w*y), 0],
	 *            [    2*(x*y + w*z), 1 - 2*(x*x + z*z),     2*(y*z - w*x), 0],
	 *            [    2*(x*z - w*y),     2*(y*z + w*x), 1 - 2*(x*x + y*y), 0],
	 *            [                0,                 0,                 0, 1]]
	 * 
	 * If you want to get the quaternions periodically, it is recommended
	 * to use the {@link BrickIMU.QuaternionListener} listener and set the period with
	 * {@link BrickIMU#setQuaternionPeriod(long)}.
	 */
	public Quaternion getQuaternion() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_QUATERNION, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Quaternion obj = new Quaternion();
		obj.x = (bb.getFloat());
		obj.y = (bb.getFloat());
		obj.z = (bb.getFloat());
		obj.w = (bb.getFloat());

		return obj;
	}

	/**
	 * Returns the temperature of the IMU Brick.
	 */
	public short getIMUTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IMU_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Turns the orientation and direction LEDs of the IMU Brick on.
	 */
	public void ledsOn() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_LEDS_ON, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Turns the orientation and direction LEDs of the IMU Brick off.
	 */
	public void ledsOff() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_LEDS_OFF, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the orientation and direction LEDs of the IMU Brick
	 * are on, *false* otherwise.
	 */
	public boolean areLedsOn() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ARE_LEDS_ON, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean leds = (bb.get()) != 0;

		return leds;
	}

	/**
	 * Not implemented yet.
	 */
	public void setAccelerationRange(short range) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_ACCELERATION_RANGE, this);

		bb.put((byte)range);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Not implemented yet.
	 */
	public short getAccelerationRange() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION_RANGE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short range = IPConnectionBase.unsignedByte(bb.get());

		return range;
	}

	/**
	 * Not implemented yet.
	 */
	public void setMagnetometerRange(short range) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_MAGNETOMETER_RANGE, this);

		bb.put((byte)range);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Not implemented yet.
	 */
	public short getMagnetometerRange() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MAGNETOMETER_RANGE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short range = IPConnectionBase.unsignedByte(bb.get());

		return range;
	}

	/**
	 * Sets the convergence speed of the IMU Brick. The convergence speed
	 * determines how the different sensor measurements are fused.
	 * 
	 * If the orientation of the IMU Brick is off by 10° and the convergence speed is
	 * set to 20°/s, it will take 0.5s until the orientation is corrected. However,
	 * if the correct orientation is reached and the convergence speed is too high,
	 * the orientation will fluctuate with the fluctuations of the accelerometer and
	 * the magnetometer.
	 * 
	 * If you set the convergence speed to 0, practically only the gyroscope is used
	 * to calculate the orientation. This gives very smooth movements, but errors of the
	 * gyroscope will not be corrected. If you set the convergence speed to something
	 * above 500, practically only the magnetometer and the accelerometer are used to
	 * calculate the orientation. In this case the movements are abrupt and the values
	 * will fluctuate, but there won't be any errors that accumulate over time.
	 * 
	 * In an application with high angular velocities, we recommend a high convergence
	 * speed, so the errors of the gyroscope can be corrected fast. In applications with
	 * only slow movements we recommend a low convergence speed. You can change the
	 * convergence speed on the fly. So it is possible (and recommended) to increase
	 * the convergence speed before an abrupt movement and decrease it afterwards
	 * again.
	 * 
	 * You might want to play around with the convergence speed in the Brick Viewer to
	 * get a feeling for a good value for your application.
	 */
	public void setConvergenceSpeed(int speed) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONVERGENCE_SPEED, this);

		bb.putShort((short)speed);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the convergence speed as set by {@link BrickIMU#setConvergenceSpeed(int)}.
	 */
	public int getConvergenceSpeed() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONVERGENCE_SPEED, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int speed = IPConnectionBase.unsignedShort(bb.getShort());

		return speed;
	}

	/**
	 * There are several different types that can be calibrated:
	 * 
	 * \verbatim
	 *  "Type", "Description", "Values"
	 * 
	 *  "0",    "Accelerometer Gain", "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
	 *  "1",    "Accelerometer Bias", "``[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]``"
	 *  "2",    "Magnetometer Gain",  "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
	 *  "3",    "Magnetometer Bias",  "``[bias x, bias y, bias z, 0, 0, 0, 0, 0, 0, 0]``"
	 *  "4",    "Gyroscope Gain",     "``[mul x, mul y, mul z, div x, div y, div z, 0, 0, 0, 0]``"
	 *  "5",    "Gyroscope Bias",     "``[bias xl, bias yl, bias zl, temp l, bias xh, bias yh, bias zh, temp h, 0, 0]``"
	 * \endverbatim
	 * 
	 * The calibration via gain and bias is done with the following formula::
	 * 
	 *  new_value = (bias + orig_value) * gain_mul / gain_div
	 * 
	 * If you really want to write your own calibration software, please keep
	 * in mind that you first have to undo the old calibration (set bias to 0 and
	 * gain to 1/1) and that you have to average over several thousand values
	 * to obtain a usable result in the end.
	 * 
	 * The gyroscope bias is highly dependent on the temperature, so you have to
	 * calibrate the bias two times with different temperatures. The values ``xl``,
	 * ``yl``, ``zl`` and ``temp l`` are the bias for ``x``, ``y``, ``z`` and the
	 * corresponding temperature for a low temperature. The values ``xh``, ``yh``,
	 * ``zh`` and ``temp h`` are the same for a high temperatures. The temperature
	 * difference should be at least 5°C. If you have a temperature where the
	 * IMU Brick is mostly used, you should use this temperature for one of the
	 * sampling points.
	 * 
	 * \note
	 *  We highly recommend that you use the Brick Viewer to calibrate your
	 *  IMU Brick.
	 */
	public void setCalibration(short typ, short[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)29, FUNCTION_SET_CALIBRATION, this);

		bb.put((byte)typ);
		for (int i = 0; i < 10; i++) {
			bb.putShort(data[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the calibration for a given type as set by {@link BrickIMU#setCalibration(short, short[])}.
	 */
	public short[] getCalibration(short typ) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CALIBRATION, this);

		bb.put((byte)typ);

		byte[] response = sendRequest(bb.array(), 28);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] data = new short[10];
		for (int i = 0; i < 10; i++) {
			data[i] = (bb.getShort());
		}

		return data;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.AccelerationListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 */
	public void setAccelerationPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ACCELERATION_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setAccelerationPeriod(long)}.
	 */
	public long getAccelerationPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.MagneticFieldListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 */
	public void setMagneticFieldPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_MAGNETIC_FIELD_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setMagneticFieldPeriod(long)}.
	 */
	public long getMagneticFieldPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MAGNETIC_FIELD_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.AngularVelocityListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 */
	public void setAngularVelocityPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setAngularVelocityPeriod(long)}.
	 */
	public long getAngularVelocityPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.AllDataListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 */
	public void setAllDataPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ALL_DATA_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setAllDataPeriod(long)}.
	 */
	public long getAllDataPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_DATA_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.OrientationListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 */
	public void setOrientationPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ORIENTATION_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setOrientationPeriod(long)}.
	 */
	public long getOrientationPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ORIENTATION_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickIMU.QuaternionListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 */
	public void setQuaternionPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_QUATERNION_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickIMU#setQuaternionPeriod(long)}.
	 */
	public long getQuaternionPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_QUATERNION_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Turns the orientation calculation of the IMU Brick on.
	 * 
	 * As default the calculation is on.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Firmware)
	 */
	public void orientationCalculationOn() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ORIENTATION_CALCULATION_ON, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Turns the orientation calculation of the IMU Brick off.
	 * 
	 * If the calculation is off, {@link BrickIMU#getOrientation()} will return
	 * the last calculated value until the calculation is turned on again.
	 * 
	 * The trigonometric functions that are needed to calculate the orientation
	 * are very expensive. We recommend to turn the orientation calculation
	 * off if the orientation is not needed, to free calculation time for the
	 * sensor fusion algorithm.
	 * 
	 * As default the calculation is on.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Firmware)
	 */
	public void orientationCalculationOff() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ORIENTATION_CALCULATION_OFF, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the orientation calculation of the IMU Brick
	 * is on, *false* otherwise.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Firmware)
	 */
	public boolean isOrientationCalculationOn() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_ORIENTATION_CALCULATION_ON, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean orientationCalculationOn = (bb.get()) != 0;

		return orientationCalculationOn;
	}

	/**
	 * The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
	 * enabled, the Brick will try to adapt the baudrate for the communication
	 * between Bricks and Bricklets according to the amount of data that is transferred.
	 * 
	 * The baudrate will be increased exponentially if lots of data is sent/received and
	 * decreased linearly if little data is sent/received.
	 * 
	 * This lowers the baudrate in applications where little data is transferred (e.g.
	 * a weather station) and increases the robustness. If there is lots of data to transfer
	 * (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
	 * 
	 * In cases where some data has to transferred as fast as possible every few seconds
	 * (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
	 * the dynamic baudrate off to get the highest possible performance.
	 * 
	 * The maximum value of the baudrate can be set per port with the function
	 * {@link BrickIMU#setSPITFPBaudrate(char, long)}. If the dynamic baudrate is disabled, the baudrate
	 * as set by {@link BrickIMU#setSPITFPBaudrate(char, long)} will be used statically.
	 * 
	 * .. versionadded:: 2.3.5$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, this);

		bb.put((byte)(enableDynamicBaudrate ? 1 : 0));
		bb.putInt((int)minimumDynamicBaudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate config, see {@link BrickIMU#setSPITFPBaudrateConfig(boolean, long)}.
	 * 
	 * .. versionadded:: 2.3.5$nbsp;(Firmware)
	 */
	public SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPBaudrateConfig obj = new SPITFPBaudrateConfig();
		obj.enableDynamicBaudrate = (bb.get()) != 0;
		obj.minimumDynamicBaudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the timeout count for the different communication methods.
	 * 
	 * The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
	 * 
	 * This function is mostly used for debugging during development, in normal operation
	 * the counters should nearly always stay at 0.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public long getSendTimeoutCount(short communicationMethod) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SEND_TIMEOUT_COUNT, this);

		bb.put((byte)communicationMethod);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long timeoutCount = IPConnectionBase.unsignedInt(bb.getInt());

		return timeoutCount;
	}

	/**
	 * Sets the baudrate for a specific Bricklet port.
	 * 
	 * If you want to increase the throughput of Bricklets you can increase
	 * the baudrate. If you get a high error count because of high
	 * interference (see {@link BrickIMU#getSPITFPErrorCount(char)}) you can decrease the
	 * baudrate.
	 * 
	 * If the dynamic baudrate feature is enabled, the baudrate set by this
	 * function corresponds to the maximum baudrate (see {@link BrickIMU#setSPITFPBaudrateConfig(boolean, long)}).
	 * 
	 * Regulatory testing is done with the default baudrate. If CE compatibility
	 * or similar is necessary in your applications we recommend to not change
	 * the baudrate.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);
		bb.putInt((int)baudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate for a given Bricklet port, see {@link BrickIMU#setSPITFPBaudrate(char, long)}.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long baudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return baudrate;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Brick side. All
	 * Bricklets have a similar function that returns the errors on the Bricklet side.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_ERROR_COUNT, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountACKChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Enables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void enableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void disableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the status LED is enabled, *false* otherwise.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public boolean isStatusLEDEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_STATUS_LED_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Returns the firmware and protocol version and the name of the Bricklet for a
	 * given port.
	 * 
	 * This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
	 * plugins.
	 */
	public Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array(), 52);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Protocol1BrickletName obj = new Protocol1BrickletName();
		obj.protocolVersion = IPConnectionBase.unsignedByte(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.name = IPConnectionBase.string(bb, 40);

		return obj;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has an
	 * accuracy of ±15%. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public short getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Brick. Calling this function
	 * on a Brick inside of a stack will reset the whole stack.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 32 bytes of firmware to the bricklet attached at the given port.
	 * The bytes are written to the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void writeBrickletPlugin(char port, short offset, short[] chunk) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)42, FUNCTION_WRITE_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);
		for (int i = 0; i < 32; i++) {
			bb.put((byte)chunk[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Reads 32 bytes of firmware from the bricklet attached at the given port.
	 * The bytes are read starting at the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public short[] readBrickletPlugin(char port, short offset) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_READ_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);

		byte[] response = sendRequest(bb.array(), 40);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] chunk = new short[32];
		for (int i = 0; i < 32; i++) {
			chunk[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return chunk;
	}

	/**
	 * Returns the UID, the UID where the Brick is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position is the position in the stack from '0' (bottom) to '8' (top).
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Acceleration listener.
	 */
	public void addAccelerationListener(AccelerationListener listener) {
		listenerAcceleration.add(listener);
	}

	/**
	 * Removes a Acceleration listener.
	 */
	public void removeAccelerationListener(AccelerationListener listener) {
		listenerAcceleration.remove(listener);
	}

	/**
	 * Adds a MagneticField listener.
	 */
	public void addMagneticFieldListener(MagneticFieldListener listener) {
		listenerMagneticField.add(listener);
	}

	/**
	 * Removes a MagneticField listener.
	 */
	public void removeMagneticFieldListener(MagneticFieldListener listener) {
		listenerMagneticField.remove(listener);
	}

	/**
	 * Adds a AngularVelocity listener.
	 */
	public void addAngularVelocityListener(AngularVelocityListener listener) {
		listenerAngularVelocity.add(listener);
	}

	/**
	 * Removes a AngularVelocity listener.
	 */
	public void removeAngularVelocityListener(AngularVelocityListener listener) {
		listenerAngularVelocity.remove(listener);
	}

	/**
	 * Adds a AllData listener.
	 */
	public void addAllDataListener(AllDataListener listener) {
		listenerAllData.add(listener);
	}

	/**
	 * Removes a AllData listener.
	 */
	public void removeAllDataListener(AllDataListener listener) {
		listenerAllData.remove(listener);
	}

	/**
	 * Adds a Orientation listener.
	 */
	public void addOrientationListener(OrientationListener listener) {
		listenerOrientation.add(listener);
	}

	/**
	 * Removes a Orientation listener.
	 */
	public void removeOrientationListener(OrientationListener listener) {
		listenerOrientation.remove(listener);
	}

	/**
	 * Adds a Quaternion listener.
	 */
	public void addQuaternionListener(QuaternionListener listener) {
		listenerQuaternion.add(listener);
	}

	/**
	 * Removes a Quaternion listener.
	 */
	public void removeQuaternionListener(QuaternionListener listener) {
		listenerQuaternion.remove(listener);
	}
}
