/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Drives one bipolar stepper motor with up to 38V and 2.5A per phase
 */
public class BrickStepper extends Device {
	public final static int DEVICE_IDENTIFIER = 15;
	public final static String DEVICE_DISPLAY_NAME = "Stepper Brick";

	public final static byte FUNCTION_SET_MAX_VELOCITY = (byte)1;
	public final static byte FUNCTION_GET_MAX_VELOCITY = (byte)2;
	public final static byte FUNCTION_GET_CURRENT_VELOCITY = (byte)3;
	public final static byte FUNCTION_SET_SPEED_RAMPING = (byte)4;
	public final static byte FUNCTION_GET_SPEED_RAMPING = (byte)5;
	public final static byte FUNCTION_FULL_BRAKE = (byte)6;
	public final static byte FUNCTION_SET_CURRENT_POSITION = (byte)7;
	public final static byte FUNCTION_GET_CURRENT_POSITION = (byte)8;
	public final static byte FUNCTION_SET_TARGET_POSITION = (byte)9;
	public final static byte FUNCTION_GET_TARGET_POSITION = (byte)10;
	public final static byte FUNCTION_SET_STEPS = (byte)11;
	public final static byte FUNCTION_GET_STEPS = (byte)12;
	public final static byte FUNCTION_GET_REMAINING_STEPS = (byte)13;
	public final static byte FUNCTION_SET_STEP_MODE = (byte)14;
	public final static byte FUNCTION_GET_STEP_MODE = (byte)15;
	public final static byte FUNCTION_DRIVE_FORWARD = (byte)16;
	public final static byte FUNCTION_DRIVE_BACKWARD = (byte)17;
	public final static byte FUNCTION_STOP = (byte)18;
	public final static byte FUNCTION_GET_STACK_INPUT_VOLTAGE = (byte)19;
	public final static byte FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = (byte)20;
	public final static byte FUNCTION_GET_CURRENT_CONSUMPTION = (byte)21;
	public final static byte FUNCTION_SET_MOTOR_CURRENT = (byte)22;
	public final static byte FUNCTION_GET_MOTOR_CURRENT = (byte)23;
	public final static byte FUNCTION_ENABLE = (byte)24;
	public final static byte FUNCTION_DISABLE = (byte)25;
	public final static byte FUNCTION_IS_ENABLED = (byte)26;
	public final static byte FUNCTION_SET_DECAY = (byte)27;
	public final static byte FUNCTION_GET_DECAY = (byte)28;
	public final static byte FUNCTION_SET_MINIMUM_VOLTAGE = (byte)29;
	public final static byte FUNCTION_GET_MINIMUM_VOLTAGE = (byte)30;
	public final static byte FUNCTION_SET_SYNC_RECT = (byte)33;
	public final static byte FUNCTION_IS_SYNC_RECT = (byte)34;
	public final static byte FUNCTION_SET_TIME_BASE = (byte)35;
	public final static byte FUNCTION_GET_TIME_BASE = (byte)36;
	public final static byte FUNCTION_GET_ALL_DATA = (byte)37;
	public final static byte FUNCTION_SET_ALL_DATA_PERIOD = (byte)38;
	public final static byte FUNCTION_GET_ALL_DATA_PERIOD = (byte)39;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = (byte)231;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = (byte)232;
	public final static byte FUNCTION_GET_SEND_TIMEOUT_COUNT = (byte)233;
	public final static byte FUNCTION_SET_SPITFP_BAUDRATE = (byte)234;
	public final static byte FUNCTION_GET_SPITFP_BAUDRATE = (byte)235;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)237;
	public final static byte FUNCTION_ENABLE_STATUS_LED = (byte)238;
	public final static byte FUNCTION_DISABLE_STATUS_LED = (byte)239;
	public final static byte FUNCTION_IS_STATUS_LED_ENABLED = (byte)240;
	public final static byte FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = (byte)241;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_BRICKLET_PLUGIN = (byte)246;
	public final static byte FUNCTION_READ_BRICKLET_PLUGIN = (byte)247;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_UNDER_VOLTAGE = 31;
	private final static int CALLBACK_POSITION_REACHED = 32;
	private final static int CALLBACK_ALL_DATA = 40;
	private final static int CALLBACK_NEW_STATE = 41;

	public final static short STEP_MODE_FULL_STEP = (short)1;
	public final static short STEP_MODE_HALF_STEP = (short)2;
	public final static short STEP_MODE_QUARTER_STEP = (short)4;
	public final static short STEP_MODE_EIGHTH_STEP = (short)8;
	public final static short STATE_STOP = (short)1;
	public final static short STATE_ACCELERATION = (short)2;
	public final static short STATE_RUN = (short)3;
	public final static short STATE_DEACCELERATION = (short)4;
	public final static short STATE_DIRECTION_CHANGE_TO_FORWARD = (short)5;
	public final static short STATE_DIRECTION_CHANGE_TO_BACKWARD = (short)6;
	public final static short COMMUNICATION_METHOD_NONE = (short)0;
	public final static short COMMUNICATION_METHOD_USB = (short)1;
	public final static short COMMUNICATION_METHOD_SPI_STACK = (short)2;
	public final static short COMMUNICATION_METHOD_CHIBI = (short)3;
	public final static short COMMUNICATION_METHOD_RS485 = (short)4;
	public final static short COMMUNICATION_METHOD_WIFI = (short)5;
	public final static short COMMUNICATION_METHOD_ETHERNET = (short)6;
	public final static short COMMUNICATION_METHOD_WIFI_V2 = (short)7;

	private List<UnderVoltageListener> listenerUnderVoltage = new CopyOnWriteArrayList<UnderVoltageListener>();
	private List<PositionReachedListener> listenerPositionReached = new CopyOnWriteArrayList<PositionReachedListener>();
	private List<AllDataListener> listenerAllData = new CopyOnWriteArrayList<AllDataListener>();
	private List<NewStateListener> listenerNewState = new CopyOnWriteArrayList<NewStateListener>();

	public class SpeedRamping {
		public int acceleration;
		public int deacceleration;

		public String toString() {
			return "[" + "acceleration = " + acceleration + ", " + "deacceleration = " + deacceleration + "]";
		}
	}

	public class AllData {
		public int currentVelocity;
		public int currentPosition;
		public int remainingSteps;
		public int stackVoltage;
		public int externalVoltage;
		public int currentConsumption;

		public String toString() {
			return "[" + "currentVelocity = " + currentVelocity + ", " + "currentPosition = " + currentPosition + ", " + "remainingSteps = " + remainingSteps + ", " + "stackVoltage = " + stackVoltage + ", " + "externalVoltage = " + externalVoltage + ", " + "currentConsumption = " + currentConsumption + "]";
		}
	}

	public class SPITFPBaudrateConfig {
		public boolean enableDynamicBaudrate;
		public long minimumDynamicBaudrate;

		public String toString() {
			return "[" + "enableDynamicBaudrate = " + enableDynamicBaudrate + ", " + "minimumDynamicBaudrate = " + minimumDynamicBaudrate + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountACKChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountACKChecksum = " + errorCountACKChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	public class Protocol1BrickletName {
		public short protocolVersion;
		public short[] firmwareVersion = new short[3];
		public String name;

		public String toString() {
			return "[" + "protocolVersion = " + protocolVersion + ", " + "firmwareVersion = " + Arrays.toString(firmwareVersion) + ", " + "name = " + name + "]";
		}
	}

	/**
	 * This listener is triggered when the input voltage drops below the value set by
	 * {@link BrickStepper#setMinimumVoltage(int)}. The parameter is the current voltage.
	 */
	public interface UnderVoltageListener extends DeviceListener {
		public void underVoltage(int voltage);
	}

	/**
	 * This listener is triggered when a position set by {@link BrickStepper#setSteps(int)} or
	 * {@link BrickStepper#setTargetPosition(int)} is reached.
	 * 
	 * \note
	 *  Since we can't get any feedback from the stepper motor, this only works if the
	 *  acceleration (see {@link BrickStepper#setSpeedRamping(int, int)}) is set smaller or equal to the
	 *  maximum acceleration of the motor. Otherwise the motor will lag behind the
	 *  control value and the listener will be triggered too early.
	 */
	public interface PositionReachedListener extends DeviceListener {
		public void positionReached(int position);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickStepper#setAllDataPeriod(long)}. The parameters are: the current velocity,
	 * the current position, the remaining steps, the stack voltage, the external
	 * voltage and the current consumption of the stepper motor.
	 */
	public interface AllDataListener extends DeviceListener {
		public void allData(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption);
	}

	/**
	 * This listener is triggered whenever the Stepper Brick enters a new state.
	 * It returns the new state as well as the previous state.
	 */
	public interface NewStateListener extends DeviceListener {
		public void newState(short stateNew, short statePrevious);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickStepper(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 4;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MAX_VELOCITY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MAX_VELOCITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_VELOCITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPEED_RAMPING)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPEED_RAMPING)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_FULL_BRAKE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CURRENT_POSITION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_POSITION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_TARGET_POSITION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_TARGET_POSITION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STEPS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STEPS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_REMAINING_STEPS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STEP_MODE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STEP_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRIVE_FORWARD)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRIVE_BACKWARD)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_STOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STACK_INPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CURRENT_CONSUMPTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MOTOR_CURRENT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MOTOR_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DECAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DECAY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MINIMUM_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MINIMUM_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SYNC_RECT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_SYNC_RECT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_TIME_BASE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_TIME_BASE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALL_DATA)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ALL_DATA_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALL_DATA_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SEND_TIMEOUT_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_BAUDRATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE_STATUS_LED)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_STATUS_LED_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PROTOCOL1_BRICKLET_NAME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_BRICKLET_PLUGIN)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_UNDER_VOLTAGE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = IPConnectionBase.unsignedShort(bb.getShort());

				for (UnderVoltageListener listener: listenerUnderVoltage) {
					listener.underVoltage(voltage);
				}
			}
		};

		callbacks[CALLBACK_POSITION_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int position = (bb.getInt());

				for (PositionReachedListener listener: listenerPositionReached) {
					listener.positionReached(position);
				}
			}
		};

		callbacks[CALLBACK_ALL_DATA] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 24) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int currentVelocity = IPConnectionBase.unsignedShort(bb.getShort());
				int currentPosition = (bb.getInt());
				int remainingSteps = (bb.getInt());
				int stackVoltage = IPConnectionBase.unsignedShort(bb.getShort());
				int externalVoltage = IPConnectionBase.unsignedShort(bb.getShort());
				int currentConsumption = IPConnectionBase.unsignedShort(bb.getShort());

				for (AllDataListener listener: listenerAllData) {
					listener.allData(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption);
				}
			}
		};

		callbacks[CALLBACK_NEW_STATE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short stateNew = IPConnectionBase.unsignedByte(bb.get());
				short statePrevious = IPConnectionBase.unsignedByte(bb.get());

				for (NewStateListener listener: listenerNewState) {
					listener.newState(stateNew, statePrevious);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the maximum velocity of the stepper motor.
	 * This function does *not* start the motor, it merely sets the maximum
	 * velocity the stepper motor is accelerated to. To get the motor running use
	 * either {@link BrickStepper#setTargetPosition(int)}, {@link BrickStepper#setSteps(int)}, {@link BrickStepper#driveForward()} or
	 * {@link BrickStepper#driveBackward()}.
	 */
	public void setMaxVelocity(int velocity) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_MAX_VELOCITY, this);

		bb.putShort((short)velocity);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the velocity as set by {@link BrickStepper#setMaxVelocity(int)}.
	 */
	public int getMaxVelocity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MAX_VELOCITY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int velocity = IPConnectionBase.unsignedShort(bb.getShort());

		return velocity;
	}

	/**
	 * Returns the *current* velocity of the stepper motor.
	 */
	public int getCurrentVelocity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_VELOCITY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int velocity = IPConnectionBase.unsignedShort(bb.getShort());

		return velocity;
	}

	/**
	 * Sets the acceleration and deacceleration of the stepper motor.
	 * An acceleration of 1000 means, that
	 * every second the velocity is increased by 1000 *steps/s*.
	 * 
	 * For example: If the current velocity is 0 and you want to accelerate to a
	 * velocity of 8000 *steps/s* in 10 seconds, you should set an acceleration
	 * of 800 *steps/s²*.
	 * 
	 * An acceleration/deacceleration of 0 means instantaneous
	 * acceleration/deacceleration (not recommended)
	 */
	public void setSpeedRamping(int acceleration, int deacceleration) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SPEED_RAMPING, this);

		bb.putShort((short)acceleration);
		bb.putShort((short)deacceleration);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the acceleration and deacceleration as set by
	 * {@link BrickStepper#setSpeedRamping(int, int)}.
	 */
	public SpeedRamping getSpeedRamping() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPEED_RAMPING, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SpeedRamping obj = new SpeedRamping();
		obj.acceleration = IPConnectionBase.unsignedShort(bb.getShort());
		obj.deacceleration = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Executes an active full brake.
	 * 
	 * \warning
	 *  This function is for emergency purposes,
	 *  where an immediate brake is necessary. Depending on the current velocity and
	 *  the strength of the motor, a full brake can be quite violent.
	 * 
	 * Call {@link BrickStepper#stop()} if you just want to stop the motor.
	 */
	public void fullBrake() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_FULL_BRAKE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Sets the current steps of the internal step counter. This can be used to
	 * set the current position to 0 when some kind of starting position
	 * is reached (e.g. when a CNC machine reaches a corner).
	 */
	public void setCurrentPosition(int position) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CURRENT_POSITION, this);

		bb.putInt(position);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current position of the stepper motor in steps. On startup
	 * the position is 0. The steps are counted with all possible driving
	 * functions ({@link BrickStepper#setTargetPosition(int)}, {@link BrickStepper#setSteps(int)}, {@link BrickStepper#driveForward()} or
	 * {@link BrickStepper#driveBackward()}). It also is possible to reset the steps to 0 or
	 * set them to any other desired value with {@link BrickStepper#setCurrentPosition(int)}.
	 */
	public int getCurrentPosition() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_POSITION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int position = (bb.getInt());

		return position;
	}

	/**
	 * Sets the target position of the stepper motor in steps. For example,
	 * if the current position of the motor is 500 and {@link BrickStepper#setTargetPosition(int)} is
	 * called with 1000, the stepper motor will drive 500 steps forward. It will
	 * use the velocity, acceleration and deacceleration as set by
	 * {@link BrickStepper#setMaxVelocity(int)} and {@link BrickStepper#setSpeedRamping(int, int)}.
	 * 
	 * A call of {@link BrickStepper#setTargetPosition(int)} with the parameter *x* is equivalent to
	 * a call of {@link BrickStepper#setSteps(int)} with the parameter
	 * (*x* - {@link BrickStepper#getCurrentPosition()}).
	 */
	public void setTargetPosition(int position) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_TARGET_POSITION, this);

		bb.putInt(position);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the last target position as set by {@link BrickStepper#setTargetPosition(int)}.
	 */
	public int getTargetPosition() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TARGET_POSITION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int position = (bb.getInt());

		return position;
	}

	/**
	 * Sets the number of steps the stepper motor should run. Positive values
	 * will drive the motor forward and negative values backward.
	 * The velocity, acceleration and deacceleration as set by
	 * {@link BrickStepper#setMaxVelocity(int)} and {@link BrickStepper#setSpeedRamping(int, int)} will be used.
	 */
	public void setSteps(int steps) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_STEPS, this);

		bb.putInt(steps);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the last steps as set by {@link BrickStepper#setSteps(int)}.
	 */
	public int getSteps() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STEPS, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int steps = (bb.getInt());

		return steps;
	}

	/**
	 * Returns the remaining steps of the last call of {@link BrickStepper#setSteps(int)}.
	 * For example, if {@link BrickStepper#setSteps(int)} is called with 2000 and
	 * {@link BrickStepper#getRemainingSteps()} is called after the motor has run for 500 steps,
	 * it will return 1500.
	 */
	public int getRemainingSteps() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REMAINING_STEPS, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int steps = (bb.getInt());

		return steps;
	}

	/**
	 * Sets the step mode of the stepper motor. Possible values are:
	 * 
	 * * Full Step = 1
	 * * Half Step = 2
	 * * Quarter Step = 4
	 * * Eighth Step = 8
	 * 
	 * A higher value will increase the resolution and
	 * decrease the torque of the stepper motor.
	 */
	public void setStepMode(short mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STEP_MODE, this);

		bb.put((byte)mode);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the step mode as set by {@link BrickStepper#setStepMode(short)}.
	 */
	public short getStepMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STEP_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Drives the stepper motor forward until {@link BrickStepper#driveBackward()} or
	 * {@link BrickStepper#stop()} is called. The velocity, acceleration and deacceleration as
	 * set by {@link BrickStepper#setMaxVelocity(int)} and {@link BrickStepper#setSpeedRamping(int, int)} will be used.
	 */
	public void driveForward() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DRIVE_FORWARD, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Drives the stepper motor backward until {@link BrickStepper#driveForward()} or
	 * {@link BrickStepper#stop()} is triggered. The velocity, acceleration and deacceleration as
	 * set by {@link BrickStepper#setMaxVelocity(int)} and {@link BrickStepper#setSpeedRamping(int, int)} will be used.
	 */
	public void driveBackward() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DRIVE_BACKWARD, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Stops the stepper motor with the deacceleration as set by
	 * {@link BrickStepper#setSpeedRamping(int, int)}.
	 */
	public void stop() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_STOP, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the stack input voltage. The stack input voltage is the
	 * voltage that is supplied via the stack, i.e. it is given by a
	 * Step-Down or Step-Up Power Supply.
	 */
	public int getStackInputVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STACK_INPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the external input voltage. The external input voltage is
	 * given via the black power input connector on the Stepper Brick.
	 * 
	 * If there is an external input voltage and a stack input voltage, the motor
	 * will be driven by the external input voltage. If there is only a stack
	 * voltage present, the motor will be driven by this voltage.
	 * 
	 * \warning
	 *  This means, if you have a high stack voltage and a low external voltage,
	 *  the motor will be driven with the low external voltage. If you then remove
	 *  the external connection, it will immediately be driven by the high
	 *  stack voltage
	 */
	public int getExternalInputVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the current consumption of the motor.
	 */
	public int getCurrentConsumption() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_CONSUMPTION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = IPConnectionBase.unsignedShort(bb.getShort());

		return current;
	}

	/**
	 * Sets the current with which the motor will be driven.
	 * 
	 * \warning
	 *  Do not set this value above the specifications of your stepper motor.
	 *  Otherwise it may damage your motor.
	 */
	public void setMotorCurrent(int current) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_MOTOR_CURRENT, this);

		bb.putShort((short)current);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current as set by {@link BrickStepper#setMotorCurrent(int)}.
	 */
	public int getMotorCurrent() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTOR_CURRENT, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = IPConnectionBase.unsignedShort(bb.getShort());

		return current;
	}

	/**
	 * Enables the driver chip. The driver parameters can be configured (maximum velocity,
	 * acceleration, etc) before it is enabled.
	 */
	public void enable() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the driver chip. The configurations are kept (maximum velocity,
	 * acceleration, etc) but the motor is not driven until it is enabled again.
	 * 
	 * \warning
	 *  Disabling the driver chip while the motor is still turning can damage the
	 *  driver chip. The motor should be stopped calling {@link BrickStepper#stop()} function
	 *  before disabling the motor power. The {@link BrickStepper#stop()} function will **not**
	 *  wait until the motor is actually stopped. You have to explicitly wait for the
	 *  appropriate time after calling the {@link BrickStepper#stop()} function before calling
	 *  the {@link BrickStepper#disable()} function.
	 */
	public void disable() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the driver chip is enabled, *false* otherwise.
	 */
	public boolean isEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Sets the decay mode of the stepper motor.
	 * A value of 0 sets the fast decay mode, a value of
	 * 65535 sets the slow decay mode and a value in between sets the mixed
	 * decay mode.
	 * 
	 * Changing the decay mode is only possible if synchronous rectification
	 * is enabled (see {@link BrickStepper#setSyncRect(boolean)}).
	 * 
	 * For a good explanation of the different decay modes see
	 * `this &lt;https://ebldc.com/?p=86/&gt;`__ blog post by Avayan.
	 * 
	 * A good decay mode is unfortunately different for every motor. The best
	 * way to work out a good decay mode for your stepper motor, if you can't
	 * measure the current with an oscilloscope, is to listen to the sound of
	 * the motor. If the value is too low, you often hear a high pitched
	 * sound and if it is too high you can often hear a humming sound.
	 * 
	 * Generally, fast decay mode (small value) will be noisier but also
	 * allow higher motor speeds.
	 * 
	 * \note
	 *  There is unfortunately no formula to calculate a perfect decay
	 *  mode for a given stepper motor. If you have problems with loud noises
	 *  or the maximum motor speed is too slow, you should try to tinker with
	 *  the decay value
	 */
	public void setDecay(int decay) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_DECAY, this);

		bb.putShort((short)decay);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the decay mode as set by {@link BrickStepper#setDecay(int)}.
	 */
	public int getDecay() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DECAY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int decay = IPConnectionBase.unsignedShort(bb.getShort());

		return decay;
	}

	/**
	 * Sets the minimum voltage, below which the {@link BrickStepper.UnderVoltageListener} listener
	 * is triggered. The minimum possible value that works with the Stepper Brick is 8V.
	 * You can use this function to detect the discharge of a battery that is used
	 * to drive the stepper motor. If you have a fixed power supply, you likely do
	 * not need this functionality.
	 */
	public void setMinimumVoltage(int voltage) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_MINIMUM_VOLTAGE, this);

		bb.putShort((short)voltage);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the minimum voltage as set by {@link BrickStepper#setMinimumVoltage(int)}.
	 */
	public int getMinimumVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MINIMUM_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Turns synchronous rectification on or off (*true* or *false*).
	 * 
	 * With synchronous rectification on, the decay can be changed
	 * (see {@link BrickStepper#setDecay(int)}). Without synchronous rectification fast
	 * decay is used.
	 * 
	 * For an explanation of synchronous rectification see
	 * `here &lt;https://en.wikipedia.org/wiki/Active_rectification&gt;`__.
	 * 
	 * \warning
	 *  If you want to use high speeds (&gt; 10000 steps/s) for a large
	 *  stepper motor with a large inductivity we strongly
	 *  suggest that you disable synchronous rectification. Otherwise the
	 *  Brick may not be able to cope with the load and overheat.
	 */
	public void setSyncRect(boolean syncRect) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_SYNC_RECT, this);

		bb.put((byte)(syncRect ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if synchronous rectification is enabled, *false* otherwise.
	 */
	public boolean isSyncRect() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_SYNC_RECT, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean syncRect = (bb.get()) != 0;

		return syncRect;
	}

	/**
	 * Sets the time base of the velocity and the acceleration of the stepper brick.
	 * 
	 * For example, if you want to make one step every 1.5 seconds, you can set
	 * the time base to 15 and the velocity to 10. Now the velocity is
	 * 10steps/15s = 1steps/1.5s.
	 */
	public void setTimeBase(long timeBase) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_TIME_BASE, this);

		bb.putInt((int)timeBase);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the time base as set by {@link BrickStepper#setTimeBase(long)}.
	 */
	public long getTimeBase() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TIME_BASE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long timeBase = IPConnectionBase.unsignedInt(bb.getInt());

		return timeBase;
	}

	/**
	 * Returns the following parameters: The current velocity,
	 * the current position, the remaining steps, the stack voltage, the external
	 * voltage and the current consumption of the stepper motor.
	 * 
	 * There is also a listener for this function, see {@link BrickStepper.AllDataListener} listener.
	 */
	public AllData getAllData() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_DATA, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllData obj = new AllData();
		obj.currentVelocity = IPConnectionBase.unsignedShort(bb.getShort());
		obj.currentPosition = (bb.getInt());
		obj.remainingSteps = (bb.getInt());
		obj.stackVoltage = IPConnectionBase.unsignedShort(bb.getShort());
		obj.externalVoltage = IPConnectionBase.unsignedShort(bb.getShort());
		obj.currentConsumption = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the {@link BrickStepper.AllDataListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 */
	public void setAllDataPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ALL_DATA_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickStepper#setAllDataPeriod(long)}.
	 */
	public long getAllDataPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_DATA_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
	 * enabled, the Brick will try to adapt the baudrate for the communication
	 * between Bricks and Bricklets according to the amount of data that is transferred.
	 * 
	 * The baudrate will be increased exponentially if lots of data is sent/received and
	 * decreased linearly if little data is sent/received.
	 * 
	 * This lowers the baudrate in applications where little data is transferred (e.g.
	 * a weather station) and increases the robustness. If there is lots of data to transfer
	 * (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
	 * 
	 * In cases where some data has to transferred as fast as possible every few seconds
	 * (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
	 * the dynamic baudrate off to get the highest possible performance.
	 * 
	 * The maximum value of the baudrate can be set per port with the function
	 * {@link BrickStepper#setSPITFPBaudrate(char, long)}. If the dynamic baudrate is disabled, the baudrate
	 * as set by {@link BrickStepper#setSPITFPBaudrate(char, long)} will be used statically.
	 * 
	 * .. versionadded:: 2.3.6$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, this);

		bb.put((byte)(enableDynamicBaudrate ? 1 : 0));
		bb.putInt((int)minimumDynamicBaudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate config, see {@link BrickStepper#setSPITFPBaudrateConfig(boolean, long)}.
	 * 
	 * .. versionadded:: 2.3.6$nbsp;(Firmware)
	 */
	public SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPBaudrateConfig obj = new SPITFPBaudrateConfig();
		obj.enableDynamicBaudrate = (bb.get()) != 0;
		obj.minimumDynamicBaudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the timeout count for the different communication methods.
	 * 
	 * The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
	 * 
	 * This function is mostly used for debugging during development, in normal operation
	 * the counters should nearly always stay at 0.
	 * 
	 * .. versionadded:: 2.3.4$nbsp;(Firmware)
	 */
	public long getSendTimeoutCount(short communicationMethod) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SEND_TIMEOUT_COUNT, this);

		bb.put((byte)communicationMethod);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long timeoutCount = IPConnectionBase.unsignedInt(bb.getInt());

		return timeoutCount;
	}

	/**
	 * Sets the baudrate for a specific Bricklet port.
	 * 
	 * If you want to increase the throughput of Bricklets you can increase
	 * the baudrate. If you get a high error count because of high
	 * interference (see {@link BrickStepper#getSPITFPErrorCount(char)}) you can decrease the
	 * baudrate.
	 * 
	 * If the dynamic baudrate feature is enabled, the baudrate set by this
	 * function corresponds to the maximum baudrate (see {@link BrickStepper#setSPITFPBaudrateConfig(boolean, long)}).
	 * 
	 * Regulatory testing is done with the default baudrate. If CE compatibility
	 * or similar is necessary in your applications we recommend to not change
	 * the baudrate.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);
		bb.putInt((int)baudrate);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the baudrate for a given Bricklet port, see {@link BrickStepper#setSPITFPBaudrate(char, long)}.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_BAUDRATE, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long baudrate = IPConnectionBase.unsignedInt(bb.getInt());

		return baudrate;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Brick side. All
	 * Bricklets have a similar function that returns the errors on the Bricklet side.
	 * 
	 * .. versionadded:: 2.3.3$nbsp;(Firmware)
	 */
	public SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SPITFP_ERROR_COUNT, this);

		bb.put((byte)brickletPort);

		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountACKChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Enables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void enableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the status LED.
	 * 
	 * The status LED is the blue LED next to the USB connector. If enabled is is
	 * on and it flickers if data is transfered. If disabled it is always off.
	 * 
	 * The default state is enabled.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public void disableStatusLED() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE_STATUS_LED, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the status LED is enabled, *false* otherwise.
	 * 
	 * .. versionadded:: 2.3.1$nbsp;(Firmware)
	 */
	public boolean isStatusLEDEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_STATUS_LED_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Returns the firmware and protocol version and the name of the Bricklet for a
	 * given port.
	 * 
	 * This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
	 * plugins.
	 */
	public Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, this);

		bb.put((byte)port);

		byte[] response = sendRequest(bb.array(), 52);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Protocol1BrickletName obj = new Protocol1BrickletName();
		obj.protocolVersion = IPConnectionBase.unsignedByte(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.name = IPConnectionBase.string(bb, 40);

		return obj;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has an
	 * accuracy of ±15%. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public short getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Brick. Calling this function
	 * on a Brick inside of a stack will reset the whole stack.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 32 bytes of firmware to the bricklet attached at the given port.
	 * The bytes are written to the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void writeBrickletPlugin(char port, short offset, short[] chunk) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)42, FUNCTION_WRITE_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);
		for (int i = 0; i < 32; i++) {
			bb.put((byte)chunk[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Reads 32 bytes of firmware from the bricklet attached at the given port.
	 * The bytes are read starting at the position offset * 32.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public short[] readBrickletPlugin(char port, short offset) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_READ_BRICKLET_PLUGIN, this);

		bb.put((byte)port);
		bb.put((byte)offset);

		byte[] response = sendRequest(bb.array(), 40);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] chunk = new short[32];
		for (int i = 0; i < 32; i++) {
			chunk[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return chunk;
	}

	/**
	 * Returns the UID, the UID where the Brick is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position is the position in the stack from '0' (bottom) to '8' (top).
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a UnderVoltage listener.
	 */
	public void addUnderVoltageListener(UnderVoltageListener listener) {
		listenerUnderVoltage.add(listener);
	}

	/**
	 * Removes a UnderVoltage listener.
	 */
	public void removeUnderVoltageListener(UnderVoltageListener listener) {
		listenerUnderVoltage.remove(listener);
	}

	/**
	 * Adds a PositionReached listener.
	 */
	public void addPositionReachedListener(PositionReachedListener listener) {
		listenerPositionReached.add(listener);
	}

	/**
	 * Removes a PositionReached listener.
	 */
	public void removePositionReachedListener(PositionReachedListener listener) {
		listenerPositionReached.remove(listener);
	}

	/**
	 * Adds a AllData listener.
	 */
	public void addAllDataListener(AllDataListener listener) {
		listenerAllData.add(listener);
	}

	/**
	 * Removes a AllData listener.
	 */
	public void removeAllDataListener(AllDataListener listener) {
		listenerAllData.remove(listener);
	}

	/**
	 * Adds a NewState listener.
	 */
	public void addNewStateListener(NewStateListener listener) {
		listenerNewState.add(listener);
	}

	/**
	 * Removes a NewState listener.
	 */
	public void removeNewStateListener(NewStateListener listener) {
		listenerNewState.remove(listener);
	}
}
