/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Measures acceleration in three axis
 */
public class BrickletAccelerometerV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2130;
	public final static String DEVICE_DISPLAY_NAME = "Accelerometer Bricklet 2.0";

	public final static byte FUNCTION_GET_ACCELERATION = (byte)1;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_SET_INFO_LED_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_INFO_LED_CONFIG = (byte)7;
	public final static byte FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_SET_FILTER_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_FILTER_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_ACCELERATION = 8;
	private final static int CALLBACK_CONTINUOUS_ACCELERATION_16_BIT = 11;
	private final static int CALLBACK_CONTINUOUS_ACCELERATION_8_BIT = 12;

	public final static int DATA_RATE_0_781HZ = 0;
	public final static int DATA_RATE_1_563HZ = 1;
	public final static int DATA_RATE_3_125HZ = 2;
	public final static int DATA_RATE_6_2512HZ = 3;
	public final static int DATA_RATE_12_5HZ = 4;
	public final static int DATA_RATE_25HZ = 5;
	public final static int DATA_RATE_50HZ = 6;
	public final static int DATA_RATE_100HZ = 7;
	public final static int DATA_RATE_200HZ = 8;
	public final static int DATA_RATE_400HZ = 9;
	public final static int DATA_RATE_800HZ = 10;
	public final static int DATA_RATE_1600HZ = 11;
	public final static int DATA_RATE_3200HZ = 12;
	public final static int DATA_RATE_6400HZ = 13;
	public final static int DATA_RATE_12800HZ = 14;
	public final static int DATA_RATE_25600HZ = 15;
	public final static int FULL_SCALE_2G = 0;
	public final static int FULL_SCALE_4G = 1;
	public final static int FULL_SCALE_8G = 2;
	public final static int INFO_LED_CONFIG_OFF = 0;
	public final static int INFO_LED_CONFIG_ON = 1;
	public final static int INFO_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int RESOLUTION_8BIT = 0;
	public final static int RESOLUTION_16BIT = 1;
	public final static int IIR_BYPASS_APPLIED = 0;
	public final static int IIR_BYPASS_BYPASSED = 1;
	public final static int LOW_PASS_FILTER_NINTH = 0;
	public final static int LOW_PASS_FILTER_HALF = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<AccelerationListener> listenerAcceleration = new CopyOnWriteArrayList<AccelerationListener>();
	private List<ContinuousAcceleration16BitListener> listenerContinuousAcceleration16Bit = new CopyOnWriteArrayList<ContinuousAcceleration16BitListener>();
	private List<ContinuousAcceleration8BitListener> listenerContinuousAcceleration8Bit = new CopyOnWriteArrayList<ContinuousAcceleration8BitListener>();

	public class Acceleration {
		public int x;
		public int y;
		public int z;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + ", " + "z = " + z + "]";
		}
	}

	public class Configuration {
		public int dataRate;
		public int fullScale;

		public String toString() {
			return "[" + "dataRate = " + dataRate + ", " + "fullScale = " + fullScale + "]";
		}
	}

	public class AccelerationCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class ContinuousAccelerationConfiguration {
		public boolean enableX;
		public boolean enableY;
		public boolean enableZ;
		public int resolution;

		public String toString() {
			return "[" + "enableX = " + enableX + ", " + "enableY = " + enableY + ", " + "enableZ = " + enableZ + ", " + "resolution = " + resolution + "]";
		}
	}

	public class FilterConfiguration {
		public int iirBypass;
		public int lowPassFilter;

		public String toString() {
			return "[" + "iirBypass = " + iirBypass + ", " + "lowPassFilter = " + lowPassFilter + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAccelerometerV2#setAccelerationCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletAccelerometerV2#getAcceleration()}.
	 */
	public interface AccelerationListener extends DeviceListener {
		public void acceleration(int x, int y, int z);
	}

	/**
	 * Returns 30 acceleration values with 16 bit resolution. The data rate can
	 * be configured with {@link BrickletAccelerometerV2#setConfiguration(int, int)} and this listener can be
	 * enabled with {@link BrickletAccelerometerV2#setContinuousAccelerationConfiguration(boolean, boolean, boolean, int)}.
	 * 
	 * The returned values are raw ADC data. If you want to put this data into
	 * a FFT to determine the occurrences of specific frequencies we recommend
	 * that you use the data as is. It has all of the ADC noise in it. This noise
	 * looks like pure noise at first glance, but it might still have some frequnecy
	 * information in it that can be utilized by the FFT.
	 * 
	 * Otherwise you have to use the following formulas that depend on the
	 * full scale range (see {@link BrickletAccelerometerV2#setConfiguration(int, int)}) to calculate
	 * the data in gₙ/10000 (same unit that is returned by {@link BrickletAccelerometerV2#getAcceleration()}):
	 * 
	 * * Full scale 2g: acceleration = value * 625 / 1024
	 * * Full scale 4g: acceleration = value * 1250 / 1024
	 * * Full scale 8g: acceleration = value * 2500 / 1024
	 * 
	 * The data is formated in the sequence "x, y, z, x, y, z, ..." depending on
	 * the enabled axis. Examples:
	 * 
	 * * x, y, z enabled: "x, y, z, ..." 10x repeated
	 * * x, z enabled: "x, z, ..." 15x repeated
	 * * y enabled: "y, ..." 30x repeated
	 */
	public interface ContinuousAcceleration16BitListener extends DeviceListener {
		public void continuousAcceleration16Bit(int[] acceleration);
	}

	/**
	 * Returns 60 acceleration values with 8 bit resolution. The data rate can
	 * be configured with {@link BrickletAccelerometerV2#setConfiguration(int, int)} and this listener can be
	 * enabled with {@link BrickletAccelerometerV2#setContinuousAccelerationConfiguration(boolean, boolean, boolean, int)}.
	 * 
	 * The returned values are raw ADC data. If you want to put this data into
	 * a FFT to determine the occurrences of specific frequencies we recommend
	 * that you use the data as is. It has all of the ADC noise in it. This noise
	 * looks like pure noise at first glance, but it might still have some frequnecy
	 * information in it that can be utilized by the FFT.
	 * 
	 * Otherwise you have to use the following formulas that depend on the
	 * full scale range (see {@link BrickletAccelerometerV2#setConfiguration(int, int)}) to calculate
	 * the data in gₙ/10000 (same unit that is returned by {@link BrickletAccelerometerV2#getAcceleration()}):
	 * 
	 * * Full scale 2g: acceleration = value * 256 * 625 / 1024
	 * * Full scale 4g: acceleration = value * 256 * 1250 / 1024
	 * * Full scale 8g: acceleration = value * 256 * 2500 / 1024
	 * 
	 * The data is formated in the sequence "x, y, z, x, y, z, ..." depending on
	 * the enabled axis. Examples:
	 * 
	 * * x, y, z enabled: "x, y, z, ..." 20x repeated
	 * * x, z enabled: "x, z, ..." 30x repeated
	 * * y enabled: "y, ..." 60x repeated
	 */
	public interface ContinuousAcceleration8BitListener extends DeviceListener {
		public void continuousAcceleration8Bit(int[] acceleration);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletAccelerometerV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_INFO_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_INFO_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FILTER_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FILTER_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_ACCELERATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 20) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int x = (bb.getInt());
				int y = (bb.getInt());
				int z = (bb.getInt());

				for (AccelerationListener listener: listenerAcceleration) {
					listener.acceleration(x, y, z);
				}
			}
		};

		callbacks[CALLBACK_CONTINUOUS_ACCELERATION_16_BIT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 68) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int[] acceleration = new int[30];
				for (int i = 0; i < 30; i++) {
					acceleration[i] = (bb.getShort());
				}

				for (ContinuousAcceleration16BitListener listener: listenerContinuousAcceleration16Bit) {
					listener.continuousAcceleration16Bit(acceleration);
				}
			}
		};

		callbacks[CALLBACK_CONTINUOUS_ACCELERATION_8_BIT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 68) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int[] acceleration = new int[60];
				for (int i = 0; i < 60; i++) {
					acceleration[i] = (bb.get());
				}

				for (ContinuousAcceleration8BitListener listener: listenerContinuousAcceleration8Bit) {
					listener.continuousAcceleration8Bit(acceleration);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the acceleration in x, y and z direction. The values
	 * are given in gₙ/10000 (1gₙ = 9.80665m/s²). The range is
	 * configured with {@link BrickletAccelerometerV2#setConfiguration(int, int)}.
	 * 
	 * If you want to get the acceleration periodically, it is recommended
	 * to use the {@link BrickletAccelerometerV2.AccelerationListener} listener and set the period with
	 * {@link BrickletAccelerometerV2#setAccelerationCallbackConfiguration(long, boolean)}.
	 */
	public Acceleration getAcceleration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION, this);


		byte[] response = sendRequest(bb.array(), 20);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Acceleration obj = new Acceleration();
		obj.x = (bb.getInt());
		obj.y = (bb.getInt());
		obj.z = (bb.getInt());

		return obj;
	}

	/**
	 * Configures the data rate and full scale range.
	 * Possible values are:
	 * 
	 * * Data rate of 0.781Hz to 25600Hz.
	 * * Full scale range of ±2g up to ±8g.
	 * 
	 * Decreasing data rate or full scale range will also decrease the noise on
	 * the data.
	 */
	public void setConfiguration(int dataRate, int fullScale) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)dataRate);
		bb.put((byte)fullScale);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletAccelerometerV2#setConfiguration(int, int)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.dataRate = IPConnectionBase.unsignedByte(bb.get());
		obj.fullScale = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletAccelerometerV2.AccelerationListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * If this listener is enabled, the {@link BrickletAccelerometerV2.ContinuousAcceleration16BitListener} listener
	 * and {@link BrickletAccelerometerV2.ContinuousAcceleration8BitListener} listener will automatically be disabled.
	 */
	public void setAccelerationCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_ACCELERATION_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletAccelerometerV2#setAccelerationCallbackConfiguration(long, boolean)}.
	 */
	public AccelerationCallbackConfiguration getAccelerationCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ACCELERATION_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AccelerationCallbackConfiguration obj = new AccelerationCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Configures the info LED (marked as "Force" on the Bricklet) to be either turned off,
	 * turned on, or blink in heartbeat mode.
	 */
	public void setInfoLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_INFO_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the LED configuration as set by {@link BrickletAccelerometerV2#setInfoLEDConfig(int)}
	 */
	public int getInfoLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_INFO_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * For high throughput of acceleration data (&gt; 1000Hz) you have to use the
	 * {@link BrickletAccelerometerV2.ContinuousAcceleration16BitListener} or {@link BrickletAccelerometerV2.ContinuousAcceleration8BitListener}
	 * callbacks.
	 * 
	 * You can enable the listener for each axis (x, y, z) individually and choose a
	 * resolution of 8 bit or 16 bit.
	 * 
	 * If at least one of the axis is enabled and the resolution is set to 8 bit,
	 * the {@link BrickletAccelerometerV2.ContinuousAcceleration8BitListener} listener is activated. If at least
	 * one of the axis is enabled and the resolution is set to 16 bit,
	 * the {@link BrickletAccelerometerV2.ContinuousAcceleration16BitListener} listener is activated.
	 * 
	 * The returned values are raw ADC data. If you want to put this data into
	 * a FFT to determine the occurrences of specific frequencies we recommend
	 * that you use the data as is. It has all of the ADC noise in it. This noise
	 * looks like pure noise at first glance, but it might still have some frequnecy
	 * information in it that can be utilized by the FFT.
	 * 
	 * Otherwise you have to use the following formulas that depend on the configured
	 * resolution (8/16 bit) and the full scale range (see {@link BrickletAccelerometerV2#setConfiguration(int, int)}) to calculate
	 * the data in gₙ/10000 (same unit that is returned by {@link BrickletAccelerometerV2#getAcceleration()}):
	 * 
	 * * 16 bit, full scale 2g: acceleration = value * 625 / 1024
	 * * 16 bit, full scale 4g: acceleration = value * 1250 / 1024
	 * * 16 bit, full scale 8g: acceleration = value * 2500 / 1024
	 * 
	 * If a resolution of 8 bit is used, only the 8 most significant bits will be
	 * transferred, so you can use the following formulas:
	 * 
	 * * 8 bit, full scale 2g: acceleration = value * 256 * 625 / 1024
	 * * 8 bit, full scale 4g: acceleration = value * 256 * 1250 / 1024
	 * * 8 bit, full scale 8g: acceleration = value * 256 * 2500 / 1024
	 * 
	 * If no axis is enabled, both listeners are disabled. If one of the continuous
	 * callbacks is enabled, the {@link BrickletAccelerometerV2.AccelerationListener} listener is disabled.
	 * 
	 * The maximum throughput depends on the exact configuration:
	 * 
	 * \verbatim
	 *  "Number of axis enabled", "Throughput 8 bit", "Throughout 16 bit"
	 * 
	 *  "1", "25600Hz", "25600Hz"
	 *  "2", "25600Hz", "15000Hz"
	 *  "3", "20000Hz", "10000Hz"
	 * \endverbatim
	 */
	public void setContinuousAccelerationConfiguration(boolean enableX, boolean enableY, boolean enableZ, int resolution) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CONTINUOUS_ACCELERATION_CONFIGURATION, this);

		bb.put((byte)(enableX ? 1 : 0));
		bb.put((byte)(enableY ? 1 : 0));
		bb.put((byte)(enableZ ? 1 : 0));
		bb.put((byte)resolution);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the continuous acceleration configuration as set by
	 * {@link BrickletAccelerometerV2#setContinuousAccelerationConfiguration(boolean, boolean, boolean, int)}.
	 */
	public ContinuousAccelerationConfiguration getContinuousAccelerationConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONTINUOUS_ACCELERATION_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ContinuousAccelerationConfiguration obj = new ContinuousAccelerationConfiguration();
		obj.enableX = (bb.get()) != 0;
		obj.enableY = (bb.get()) != 0;
		obj.enableZ = (bb.get()) != 0;
		obj.resolution = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Configures IIR Bypass filter mode and low pass filter roll off corner frequency.
	 * 
	 * The filter can be applied or bypassed and the corner frequency can be
	 * half or a ninth of the output data rate.
	 * 
	 * .. image:: /Images/Bricklets/bricklet_accelerometer_v2_filter.png
	 *    :scale: 100 %
	 *    :alt: Accelerometer filter
	 *    :align: center
	 *    :target: ../../_images/Bricklets/bricklet_accelerometer_v2_filter.png
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public void setFilterConfiguration(int iirBypass, int lowPassFilter) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_FILTER_CONFIGURATION, this);

		bb.put((byte)iirBypass);
		bb.put((byte)lowPassFilter);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletAccelerometerV2#setFilterConfiguration(int, int)}.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public FilterConfiguration getFilterConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FILTER_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		FilterConfiguration obj = new FilterConfiguration();
		obj.iirBypass = IPConnectionBase.unsignedByte(bb.get());
		obj.lowPassFilter = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletAccelerometerV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletAccelerometerV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletAccelerometerV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletAccelerometerV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Acceleration listener.
	 */
	public void addAccelerationListener(AccelerationListener listener) {
		listenerAcceleration.add(listener);
	}

	/**
	 * Removes a Acceleration listener.
	 */
	public void removeAccelerationListener(AccelerationListener listener) {
		listenerAcceleration.remove(listener);
	}

	/**
	 * Adds a ContinuousAcceleration16Bit listener.
	 */
	public void addContinuousAcceleration16BitListener(ContinuousAcceleration16BitListener listener) {
		listenerContinuousAcceleration16Bit.add(listener);
	}

	/**
	 * Removes a ContinuousAcceleration16Bit listener.
	 */
	public void removeContinuousAcceleration16BitListener(ContinuousAcceleration16BitListener listener) {
		listenerContinuousAcceleration16Bit.remove(listener);
	}

	/**
	 * Adds a ContinuousAcceleration8Bit listener.
	 */
	public void addContinuousAcceleration8BitListener(ContinuousAcceleration8BitListener listener) {
		listenerContinuousAcceleration8Bit.add(listener);
	}

	/**
	 * Removes a ContinuousAcceleration8Bit listener.
	 */
	public void removeContinuousAcceleration8BitListener(ContinuousAcceleration8BitListener listener) {
		listenerContinuousAcceleration8Bit.remove(listener);
	}
}
