/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Measures air pressure and altitude changes
 */
public class BrickletBarometerV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2117;
	public final static String DEVICE_DISPLAY_NAME = "Barometer Bricklet 2.0";

	public final static byte FUNCTION_GET_AIR_PRESSURE = (byte)1;
	public final static byte FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_ALTITUDE = (byte)5;
	public final static byte FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_GET_TEMPERATURE = (byte)9;
	public final static byte FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_SET_REFERENCE_AIR_PRESSURE = (byte)15;
	public final static byte FUNCTION_GET_REFERENCE_AIR_PRESSURE = (byte)16;
	public final static byte FUNCTION_SET_CALIBRATION = (byte)17;
	public final static byte FUNCTION_GET_CALIBRATION = (byte)18;
	public final static byte FUNCTION_SET_SENSOR_CONFIGURATION = (byte)19;
	public final static byte FUNCTION_GET_SENSOR_CONFIGURATION = (byte)20;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_AIR_PRESSURE = 4;
	private final static int CALLBACK_ALTITUDE = 8;
	private final static int CALLBACK_TEMPERATURE = 12;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DATA_RATE_OFF = 0;
	public final static int DATA_RATE_1HZ = 1;
	public final static int DATA_RATE_10HZ = 2;
	public final static int DATA_RATE_25HZ = 3;
	public final static int DATA_RATE_50HZ = 4;
	public final static int DATA_RATE_75HZ = 5;
	public final static int LOW_PASS_FILTER_OFF = 0;
	public final static int LOW_PASS_FILTER_1_9TH = 1;
	public final static int LOW_PASS_FILTER_1_20TH = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<AirPressureListener> listenerAirPressure = new CopyOnWriteArrayList<AirPressureListener>();
	private List<AltitudeListener> listenerAltitude = new CopyOnWriteArrayList<AltitudeListener>();
	private List<TemperatureListener> listenerTemperature = new CopyOnWriteArrayList<TemperatureListener>();

	public class AirPressureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class AltitudeCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class TemperatureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class MovingAverageConfiguration {
		public int movingAverageLengthAirPressure;
		public int movingAverageLengthTemperature;

		public String toString() {
			return "[" + "movingAverageLengthAirPressure = " + movingAverageLengthAirPressure + ", " + "movingAverageLengthTemperature = " + movingAverageLengthTemperature + "]";
		}
	}

	public class Calibration {
		public int measuredAirPressure;
		public int actualAirPressure;

		public String toString() {
			return "[" + "measuredAirPressure = " + measuredAirPressure + ", " + "actualAirPressure = " + actualAirPressure + "]";
		}
	}

	public class SensorConfiguration {
		public int dataRate;
		public int airPressureLowPassFilter;

		public String toString() {
			return "[" + "dataRate = " + dataRate + ", " + "airPressureLowPassFilter = " + airPressureLowPassFilter + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getAirPressure()}.
	 */
	public interface AirPressureListener extends DeviceListener {
		public void airPressure(int airPressure);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getAltitude()}.
	 */
	public interface AltitudeListener extends DeviceListener {
		public void altitude(int altitude);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getTemperature()}.
	 */
	public interface TemperatureListener extends DeviceListener {
		public void temperature(int temperature);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletBarometerV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALTITUDE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_REFERENCE_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_REFERENCE_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SENSOR_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SENSOR_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_AIR_PRESSURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int airPressure = (bb.getInt());

				for (AirPressureListener listener: listenerAirPressure) {
					listener.airPressure(airPressure);
				}
			}
		};

		callbacks[CALLBACK_ALTITUDE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int altitude = (bb.getInt());

				for (AltitudeListener listener: listenerAltitude) {
					listener.altitude(altitude);
				}
			}
		};

		callbacks[CALLBACK_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int temperature = (bb.getInt());

				for (TemperatureListener listener: listenerTemperature) {
					listener.temperature(temperature);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the measured air pressure.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.AirPressureListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getAirPressure() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int airPressure = (bb.getInt());

		return airPressure;
	}

	/**
	 * The period is the period with which the {@link BrickletBarometerV2.AirPressureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.AirPressureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setAirPressureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public AirPressureCallbackConfiguration getAirPressureCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 22);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AirPressureCallbackConfiguration obj = new AirPressureCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the relative altitude of the air pressure sensor. The value
	 * is calculated based on the difference between the
	 * current air pressure and the reference air pressure that can be set
	 * with {@link BrickletBarometerV2#setReferenceAirPressure(int)}.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.AltitudeListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getAltitude() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int altitude = (bb.getInt());

		return altitude;
	}

	/**
	 * The period is the period with which the {@link BrickletBarometerV2.AltitudeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.AltitudeListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setAltitudeCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public AltitudeCallbackConfiguration getAltitudeCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 22);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AltitudeCallbackConfiguration obj = new AltitudeCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the temperature of the air pressure sensor.
	 * 
	 * This temperature is used internally for temperature compensation
	 * of the air pressure measurement. It is not as accurate as the
	 * temperature measured by the :ref:`temperature_v2_bricklet` or the
	 * :ref:`temperature_ir_v2_bricklet`.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.TemperatureListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getInt());

		return temperature;
	}

	/**
	 * The period is the period with which the {@link BrickletBarometerV2.TemperatureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.TemperatureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 22);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureCallbackConfiguration obj = new TemperatureCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
	 * for the air pressure and temperature measurements.
	 * 
	 * Setting the length to 1 will turn the averaging off. With less
	 * averaging, there is more noise on the data.
	 * 
	 * If you want to do long term measurements the longest moving average will give
	 * the cleanest results.
	 */
	public void setMovingAverageConfiguration(int movingAverageLengthAirPressure, int movingAverageLengthTemperature) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, this);

		bb.putShort((short)movingAverageLengthAirPressure);
		bb.putShort((short)movingAverageLengthTemperature);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the moving average configuration as set by
	 * {@link BrickletBarometerV2#setMovingAverageConfiguration(int, int)}.
	 */
	public MovingAverageConfiguration getMovingAverageConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		MovingAverageConfiguration obj = new MovingAverageConfiguration();
		obj.movingAverageLengthAirPressure = IPConnectionBase.unsignedShort(bb.getShort());
		obj.movingAverageLengthTemperature = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the reference air pressure for the altitude calculation.
	 * Setting the reference to the
	 * current air pressure results in a calculated altitude of 0mm. Passing 0 is
	 * a shortcut for passing the current air pressure as reference.
	 * 
	 * Well known reference values are the Q codes
	 * `QNH &lt;https://en.wikipedia.org/wiki/QNH&gt;`__ and
	 * `QFE &lt;https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure&gt;`__
	 * used in aviation.
	 */
	public void setReferenceAirPressure(int airPressure) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_REFERENCE_AIR_PRESSURE, this);

		bb.putInt(airPressure);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the reference air pressure as set by {@link BrickletBarometerV2#setReferenceAirPressure(int)}.
	 */
	public int getReferenceAirPressure() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REFERENCE_AIR_PRESSURE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int airPressure = (bb.getInt());

		return airPressure;
	}

	/**
	 * Sets the one point calibration (OPC) values for the air pressure measurement.
	 * 
	 * Before the Bricklet can be calibrated any previous calibration has to be removed
	 * by setting ``measured air pressure`` and ``actual air pressure`` to 0.
	 * 
	 * Then the current air pressure has to be measured using the Bricklet
	 * (``measured air pressure``) and with an accurate reference barometer
	 * (``actual air pressure``) at the same time and passed to this function.
	 * 
	 * After proper calibration the air pressure measurement can achieve an accuracy
	 * up to 0.2 hPa.
	 * 
	 * The calibration is saved in the EEPROM of the Bricklet and only needs to be
	 * configured once.
	 */
	public void setCalibration(int measuredAirPressure, int actualAirPressure) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_CALIBRATION, this);

		bb.putInt(measuredAirPressure);
		bb.putInt(actualAirPressure);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the air pressure one point calibration values as set by
	 * {@link BrickletBarometerV2#setCalibration(int, int)}.
	 */
	public Calibration getCalibration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CALIBRATION, this);


		byte[] response = sendRequest(bb.array(), 16);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Calibration obj = new Calibration();
		obj.measuredAirPressure = (bb.getInt());
		obj.actualAirPressure = (bb.getInt());

		return obj;
	}

	/**
	 * Configures the data rate and air pressure low pass filter. The low pass filter
	 * cut-off frequency (if enabled) can be set to 1/9th or 1/20th of the configure
	 * data rate to decrease the noise on the air pressure data.
	 * 
	 * The low pass filter configuration only applies to the air pressure measurement.
	 * There is no low pass filter for the temperature measurement.
	 * 
	 * A higher data rate will result in a less precise temperature because of
	 * self-heating of the sensor. If the accuracy of the temperature reading is
	 * important to you, we would recommend the 1Hz data rate.
	 */
	public void setSensorConfiguration(int dataRate, int airPressureLowPassFilter) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SENSOR_CONFIGURATION, this);

		bb.put((byte)dataRate);
		bb.put((byte)airPressureLowPassFilter);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the sensor configuration as set by {@link BrickletBarometerV2#setSensorConfiguration(int, int)}.
	 */
	public SensorConfiguration getSensorConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SENSOR_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SensorConfiguration obj = new SensorConfiguration();
		obj.dataRate = IPConnectionBase.unsignedByte(bb.get());
		obj.airPressureLowPassFilter = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletBarometerV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletBarometerV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletBarometerV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletBarometerV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a AirPressure listener.
	 */
	public void addAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.add(listener);
	}

	/**
	 * Removes a AirPressure listener.
	 */
	public void removeAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.remove(listener);
	}

	/**
	 * Adds a Altitude listener.
	 */
	public void addAltitudeListener(AltitudeListener listener) {
		listenerAltitude.add(listener);
	}

	/**
	 * Removes a Altitude listener.
	 */
	public void removeAltitudeListener(AltitudeListener listener) {
		listenerAltitude.remove(listener);
	}

	/**
	 * Adds a Temperature listener.
	 */
	public void addTemperatureListener(TemperatureListener listener) {
		listenerTemperature.add(listener);
	}

	/**
	 * Removes a Temperature listener.
	 */
	public void removeTemperatureListener(TemperatureListener listener) {
		listenerTemperature.remove(listener);
	}
}
