/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Measures color (RGB value), illuminance and color temperature
 */
public class BrickletColorV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2128;
	public final static String DEVICE_DISPLAY_NAME = "Color Bricklet 2.0";

	public final static byte FUNCTION_GET_COLOR = (byte)1;
	public final static byte FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_ILLUMINANCE = (byte)5;
	public final static byte FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_GET_COLOR_TEMPERATURE = (byte)9;
	public final static byte FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_SET_LIGHT = (byte)13;
	public final static byte FUNCTION_GET_LIGHT = (byte)14;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)15;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)16;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COLOR = 4;
	private final static int CALLBACK_ILLUMINANCE = 8;
	private final static int CALLBACK_COLOR_TEMPERATURE = 12;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int GAIN_1X = 0;
	public final static int GAIN_4X = 1;
	public final static int GAIN_16X = 2;
	public final static int GAIN_60X = 3;
	public final static int INTEGRATION_TIME_2MS = 0;
	public final static int INTEGRATION_TIME_24MS = 1;
	public final static int INTEGRATION_TIME_101MS = 2;
	public final static int INTEGRATION_TIME_154MS = 3;
	public final static int INTEGRATION_TIME_700MS = 4;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<ColorListener> listenerColor = new CopyOnWriteArrayList<ColorListener>();
	private List<IlluminanceListener> listenerIlluminance = new CopyOnWriteArrayList<IlluminanceListener>();
	private List<ColorTemperatureListener> listenerColorTemperature = new CopyOnWriteArrayList<ColorTemperatureListener>();

	public class Color {
		public int r;
		public int g;
		public int b;
		public int c;

		public String toString() {
			return "[" + "r = " + r + ", " + "g = " + g + ", " + "b = " + b + ", " + "c = " + c + "]";
		}
	}

	public class ColorCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class IlluminanceCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public long min;
		public long max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class ColorTemperatureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class Configuration {
		public int gain;
		public int integrationTime;

		public String toString() {
			return "[" + "gain = " + gain + ", " + "integrationTime = " + integrationTime + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletColorV2#setColorCallbackConfiguration(long, boolean)}. The parameter is the color
	 * of the sensor as RGBC.
	 * 
	 * The {@link BrickletColorV2.ColorListener} listener is only triggered if the color has changed since the
	 * last triggering.
	 */
	public interface ColorListener extends DeviceListener {
		public void color(int r, int g, int b, int c);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletColorV2#setIlluminanceCallbackConfiguration(long, boolean, char, long, long)}.
	 * 
	 * The parameter is the same as {@link BrickletColorV2#getIlluminance()}.
	 */
	public interface IlluminanceListener extends DeviceListener {
		public void illuminance(long illuminance);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletColorV2#setColorTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletColorV2#getColorTemperature()}.
	 */
	public interface ColorTemperatureListener extends DeviceListener {
		public void colorTemperature(int colorTemperature);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletColorV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COLOR)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ILLUMINANCE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COLOR_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_LIGHT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_LIGHT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COLOR] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 16) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int r = IPConnectionBase.unsignedShort(bb.getShort());
				int g = IPConnectionBase.unsignedShort(bb.getShort());
				int b = IPConnectionBase.unsignedShort(bb.getShort());
				int c = IPConnectionBase.unsignedShort(bb.getShort());

				for (ColorListener listener: listenerColor) {
					listener.color(r, g, b, c);
				}
			}
		};

		callbacks[CALLBACK_ILLUMINANCE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long illuminance = IPConnectionBase.unsignedInt(bb.getInt());

				for (IlluminanceListener listener: listenerIlluminance) {
					listener.illuminance(illuminance);
				}
			}
		};

		callbacks[CALLBACK_COLOR_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int colorTemperature = IPConnectionBase.unsignedShort(bb.getShort());

				for (ColorTemperatureListener listener: listenerColorTemperature) {
					listener.colorTemperature(colorTemperature);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the measured color of the sensor.
	 * 
	 * The red (r), green (g), blue (b) and clear (c) colors are measured
	 * with four different photodiodes that are responsive at different
	 * wavelengths:
	 * 
	 * .. image:: /Images/Bricklets/bricklet_color_wavelength_chart_600.jpg
	 *    :scale: 100 %
	 *    :alt: Chart Responsivity / Wavelength
	 *    :align: center
	 *    :target: ../../_images/Bricklets/bricklet_color_wavelength_chart_600.jpg
	 * 
	 * If you want to get the color periodically, it is recommended
	 * to use the {@link BrickletColorV2.ColorListener} listener and set the period with
	 * {@link BrickletColorV2#setColorCallbackConfiguration(long, boolean)}.
	 */
	public Color getColor() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COLOR, this);


		byte[] response = sendRequest(bb.array(), 16);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Color obj = new Color();
		obj.r = IPConnectionBase.unsignedShort(bb.getShort());
		obj.g = IPConnectionBase.unsignedShort(bb.getShort());
		obj.b = IPConnectionBase.unsignedShort(bb.getShort());
		obj.c = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletColorV2.ColorListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setColorCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletColorV2#setColorCallbackConfiguration(long, boolean)}.
	 */
	public ColorCallbackConfiguration getColorCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ColorCallbackConfiguration obj = new ColorCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the illuminance affected by the gain and integration time as
	 * set by {@link BrickletColorV2#setConfiguration(int, int)}. To get the illuminance in Lux apply this formula::
	 * 
	 *  lux = illuminance * 700 / gain / integration_time
	 * 
	 * To get a correct illuminance measurement make sure that the color
	 * values themselves are not saturated. The color value (R, G or B)
	 * is saturated if it is equal to the maximum value of 65535.
	 * In that case you have to reduce the gain, see {@link BrickletColorV2#setConfiguration(int, int)}.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletColorV2.IlluminanceListener} listener. You can set the listener configuration
	 * with {@link BrickletColorV2#setIlluminanceCallbackConfiguration(long, boolean, char, long, long)}.
	 */
	public long getIlluminance() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ILLUMINANCE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long illuminance = IPConnectionBase.unsignedInt(bb.getInt());

		return illuminance;
	}

	/**
	 * The period is the period with which the {@link BrickletColorV2.IlluminanceListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletColorV2.IlluminanceListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setIlluminanceCallbackConfiguration(long period, boolean valueHasToChange, char option, long min, long max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt((int)min);
		bb.putInt((int)max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletColorV2#setIlluminanceCallbackConfiguration(long, boolean, char, long, long)}.
	 */
	public IlluminanceCallbackConfiguration getIlluminanceCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 22);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		IlluminanceCallbackConfiguration obj = new IlluminanceCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = IPConnectionBase.unsignedInt(bb.getInt());
		obj.max = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the color temperature.
	 * 
	 * To get a correct color temperature measurement make sure that the color
	 * values themselves are not saturated. The color value (R, G or B)
	 * is saturated if it is equal to the maximum value of 65535.
	 * In that case you have to reduce the gain, see {@link BrickletColorV2#setConfiguration(int, int)}.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletColorV2.ColorTemperatureListener} listener. You can set the listener configuration
	 * with {@link BrickletColorV2#setColorTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getColorTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COLOR_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int colorTemperature = IPConnectionBase.unsignedShort(bb.getShort());

		return colorTemperature;
	}

	/**
	 * The period is the period with which the {@link BrickletColorV2.ColorTemperatureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletColorV2.ColorTemperatureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setColorTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putShort((short)min);
		bb.putShort((short)max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletColorV2#setColorTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public ColorTemperatureCallbackConfiguration getColorTemperatureCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 18);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ColorTemperatureCallbackConfiguration obj = new ColorTemperatureCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = IPConnectionBase.unsignedShort(bb.getShort());
		obj.max = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Turns the white LED on the Bricklet on/off.
	 */
	public void setLight(boolean enable) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_LIGHT, this);

		bb.put((byte)(enable ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the value as set by {@link BrickletColorV2#setLight(boolean)}.
	 */
	public boolean getLight() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_LIGHT, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enable = (bb.get()) != 0;

		return enable;
	}

	/**
	 * Sets the configuration of the sensor. Gain and integration time
	 * can be configured this way.
	 * 
	 * For configuring the gain:
	 * 
	 * * 0: 1x Gain
	 * * 1: 4x Gain
	 * * 2: 16x Gain
	 * * 3: 60x Gain
	 * 
	 * For configuring the integration time:
	 * 
	 * * 0: 2.4ms
	 * * 1: 24ms
	 * * 2: 101ms
	 * * 3: 154ms
	 * * 4: 700ms
	 * 
	 * Increasing the gain enables the sensor to detect a
	 * color from a higher distance.
	 * 
	 * The integration time provides a trade-off between conversion time
	 * and accuracy. With a longer integration time the values read will
	 * be more accurate but it will take longer to get the conversion
	 * results.
	 */
	public void setConfiguration(int gain, int integrationTime) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)gain);
		bb.put((byte)integrationTime);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletColorV2#setConfiguration(int, int)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.gain = IPConnectionBase.unsignedByte(bb.get());
		obj.integrationTime = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletColorV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletColorV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletColorV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletColorV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Color listener.
	 */
	public void addColorListener(ColorListener listener) {
		listenerColor.add(listener);
	}

	/**
	 * Removes a Color listener.
	 */
	public void removeColorListener(ColorListener listener) {
		listenerColor.remove(listener);
	}

	/**
	 * Adds a Illuminance listener.
	 */
	public void addIlluminanceListener(IlluminanceListener listener) {
		listenerIlluminance.add(listener);
	}

	/**
	 * Removes a Illuminance listener.
	 */
	public void removeIlluminanceListener(IlluminanceListener listener) {
		listenerIlluminance.remove(listener);
	}

	/**
	 * Adds a ColorTemperature listener.
	 */
	public void addColorTemperatureListener(ColorTemperatureListener listener) {
		listenerColorTemperature.add(listener);
	}

	/**
	 * Removes a ColorTemperature listener.
	 */
	public void removeColorTemperatureListener(ColorTemperatureListener listener) {
		listenerColorTemperature.remove(listener);
	}
}
