/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * DMX master and slave
 */
public class BrickletDMX extends Device {
	public final static int DEVICE_IDENTIFIER = 285;
	public final static String DEVICE_DISPLAY_NAME = "DMX Bricklet";

	public final static byte FUNCTION_SET_DMX_MODE = (byte)1;
	public final static byte FUNCTION_GET_DMX_MODE = (byte)2;
	public final static byte FUNCTION_WRITE_FRAME_LOW_LEVEL = (byte)3;
	public final static byte FUNCTION_READ_FRAME_LOW_LEVEL = (byte)4;
	public final static byte FUNCTION_SET_FRAME_DURATION = (byte)5;
	public final static byte FUNCTION_GET_FRAME_DURATION = (byte)6;
	public final static byte FUNCTION_GET_FRAME_ERROR_COUNT = (byte)7;
	public final static byte FUNCTION_SET_COMMUNICATION_LED_CONFIG = (byte)8;
	public final static byte FUNCTION_GET_COMMUNICATION_LED_CONFIG = (byte)9;
	public final static byte FUNCTION_SET_ERROR_LED_CONFIG = (byte)10;
	public final static byte FUNCTION_GET_ERROR_LED_CONFIG = (byte)11;
	public final static byte FUNCTION_SET_FRAME_CALLBACK_CONFIG = (byte)12;
	public final static byte FUNCTION_GET_FRAME_CALLBACK_CONFIG = (byte)13;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_FRAME_STARTED = 14;
	private final static int CALLBACK_FRAME_AVAILABLE = 15;
	private final static int CALLBACK_FRAME_LOW_LEVEL = 16;
	private final static int CALLBACK_FRAME_ERROR_COUNT = 17;
	private final static int CALLBACK_FRAME = -16;

	public final static int DMX_MODE_MASTER = 0;
	public final static int DMX_MODE_SLAVE = 1;
	public final static int COMMUNICATION_LED_CONFIG_OFF = 0;
	public final static int COMMUNICATION_LED_CONFIG_ON = 1;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
	public final static int ERROR_LED_CONFIG_OFF = 0;
	public final static int ERROR_LED_CONFIG_ON = 1;
	public final static int ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int ERROR_LED_CONFIG_SHOW_ERROR = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<FrameStartedListener> listenerFrameStarted = new CopyOnWriteArrayList<FrameStartedListener>();
	private List<FrameAvailableListener> listenerFrameAvailable = new CopyOnWriteArrayList<FrameAvailableListener>();
	private List<FrameLowLevelListener> listenerFrameLowLevel = new CopyOnWriteArrayList<FrameLowLevelListener>();
	private List<FrameErrorCountListener> listenerFrameErrorCount = new CopyOnWriteArrayList<FrameErrorCountListener>();
	private List<FrameListener> listenerFrame = new CopyOnWriteArrayList<FrameListener>();

	public class ReadFrameLowLevel {
		public int frameLength;
		public int frameChunkOffset;
		public int[] frameChunkData = new int[56];
		public long frameNumber;

		public String toString() {
			return "[" + "frameLength = " + frameLength + ", " + "frameChunkOffset = " + frameChunkOffset + ", " + "frameChunkData = " + Arrays.toString(frameChunkData) + ", " + "frameNumber = " + frameNumber + "]";
		}
	}

	public class FrameErrorCount {
		public long overrunErrorCount;
		public long framingErrorCount;

		public String toString() {
			return "[" + "overrunErrorCount = " + overrunErrorCount + ", " + "framingErrorCount = " + framingErrorCount + "]";
		}
	}

	public class FrameCallbackConfig {
		public boolean frameStartedCallbackEnabled;
		public boolean frameAvailableCallbackEnabled;
		public boolean frameCallbackEnabled;
		public boolean frameErrorCountCallbackEnabled;

		public String toString() {
			return "[" + "frameStartedCallbackEnabled = " + frameStartedCallbackEnabled + ", " + "frameAvailableCallbackEnabled = " + frameAvailableCallbackEnabled + ", " + "frameCallbackEnabled = " + frameCallbackEnabled + ", " + "frameErrorCountCallbackEnabled = " + frameErrorCountCallbackEnabled + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	public class ReadFrame {
		public int[] frame;
		public long frameNumber;

		public ReadFrame(int[] frame, long frameNumber) {
			this.frame = frame;
			this.frameNumber = frameNumber;
		}

		public String toString() {
			return "[" + "frame = " + Arrays.toString(frame) + ", " + "frameNumber = " + frameNumber + "]";
		}
	}

	/**
	 * This listener is triggered as soon as a new frame write is started.
	 * You should send the data for the next frame directly after this listener
	 * was triggered.
	 * 
	 * For an explanation of the general approach see {@link BrickletDMX#writeFrame(int[])}.
	 * 
	 * This listener can be enabled via {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 * 
	 * This listener can only be triggered in master mode.
	 */
	public interface FrameStartedListener extends DeviceListener {
		public void frameStarted();
	}

	/**
	 * This listener is triggered in slave mode when a new frame was received from the DMX master
	 * and it can be read out. You have to read the frame before the master has written
	 * the next frame, see {@link BrickletDMX#readFrame()} for more details.
	 * 
	 * The parameter is the frame number, it is increased by one with each received frame.
	 * 
	 * This listener can be enabled via {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 * 
	 * This listener can only be triggered in slave mode.
	 */
	public interface FrameAvailableListener extends DeviceListener {
		public void frameAvailable(long frameNumber);
	}

	/**
	 * @see FrameListener
	 */
	public interface FrameLowLevelListener extends DeviceListener {
		public void frameLowLevel(int frameLength, int frameChunkOffset, int[] frameChunkData, long frameNumber);
	}

	/**
	 * This listener is called if a new error occurs. It returns
	 * the current overrun and framing error count.
	 */
	public interface FrameErrorCountListener extends DeviceListener {
		public void frameErrorCount(long overrunErrorCount, long framingErrorCount);
	}

	/**
	 * This listener is called as soon as a new frame is available
	 * (written by the DMX master).
	 * 
	 * The size of the array is equivalent to the number of channels in
	 * the frame. Each byte represents one channel.
	 * 
	 * This listener can be enabled via {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 * 
	 * This listener can only be triggered in slave mode.
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for frame.
	 */
	public interface FrameListener extends DeviceListener {
		public void frame(int[] frame, long frameNumber);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletDMX(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DMX_MODE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DMX_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FRAME_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_FRAME_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_COMMUNICATION_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COMMUNICATION_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ERROR_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ERROR_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_CALLBACK_CONFIG)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_CALLBACK_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_FRAME_STARTED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 8) {
					return; // silently ignoring callback with wrong length
				}

				for (FrameStartedListener listener: listenerFrameStarted) {
					listener.frameStarted();
				}
			}
		};

		callbacks[CALLBACK_FRAME_AVAILABLE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long frameNumber = IPConnectionBase.unsignedInt(bb.getInt());

				for (FrameAvailableListener listener: listenerFrameAvailable) {
					listener.frameAvailable(frameNumber);
				}
			}
		};

		highLevelCallbacks[-CALLBACK_FRAME] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_FRAME_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 72) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int frameLength = IPConnectionBase.unsignedShort(bb.getShort());
				int frameChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
				int[] frameChunkData = new int[56];
				for (int i = 0; i < 56; i++) {
					frameChunkData[i] = IPConnectionBase.unsignedByte(bb.get());
				}
				long frameNumber = IPConnectionBase.unsignedInt(bb.getInt());

				IPConnectionBase.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_FRAME];
				int frameChunkLength = Math.min(frameLength - frameChunkOffset, 56);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (frameChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[frameLength];
						highLevelCallback.length = frameChunkLength;

						System.arraycopy(frameChunkData, 0, (int[])highLevelCallback.data, 0, frameChunkLength);

						if (highLevelCallback.length >= frameLength) { // stream complete
							for (FrameListener listener: listenerFrame) {
								listener.frame((int[])highLevelCallback.data, frameNumber);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (frameChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (FrameListener listener: listenerFrame) {
							listener.frame((int[])highLevelCallback.data, frameNumber);
						}
					} else { // stream in-sync
						System.arraycopy(frameChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, frameChunkLength);
						highLevelCallback.length += frameChunkLength;

						if (highLevelCallback.length >= frameLength) { // stream complete
							for (FrameListener listener: listenerFrame) {
								listener.frame((int[])highLevelCallback.data, frameNumber);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (FrameLowLevelListener listener: listenerFrameLowLevel) {
					listener.frameLowLevel(frameLength, frameChunkOffset, frameChunkData, frameNumber);
				}
			}
		};

		callbacks[CALLBACK_FRAME_ERROR_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 16) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long overrunErrorCount = IPConnectionBase.unsignedInt(bb.getInt());
				long framingErrorCount = IPConnectionBase.unsignedInt(bb.getInt());

				for (FrameErrorCountListener listener: listenerFrameErrorCount) {
					listener.frameErrorCount(overrunErrorCount, framingErrorCount);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the DMX mode to either master or slave.
	 * 
	 * Calling this function sets frame number to 0.
	 */
	public void setDMXMode(int dmxMode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_DMX_MODE, this);

		bb.put((byte)dmxMode);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the DMX mode, as set by {@link BrickletDMX#setDMXMode(int)}.
	 */
	public int getDMXMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DMX_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int dmxMode = IPConnectionBase.unsignedByte(bb.get());

		return dmxMode;
	}

	/**
	 * Writes a DMX frame. The maximum frame size is 512 byte. Each byte represents one channel.
	 * 
	 * The next frame can be written after the {@link BrickletDMX.FrameStartedListener} listener was called. The frame
	 * is double buffered, so a new frame can be written as soon as the writing of the prior frame
	 * starts.
	 * 
	 * The data will be transfered when the next frame duration ends, see {@link BrickletDMX#setFrameDuration(int)}.
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per second you want to achieve.
	 * * Set channels for first frame.
	 * * Wait for the {@link BrickletDMX.FrameStartedListener} listener.
	 * * Set channels for next frame.
	 * * Wait for the {@link BrickletDMX.FrameStartedListener} listener.
	 * * and so on.
	 * 
	 * This approach ensures that you can set new DMX data with a fixed frame rate.
	 * 
	 * This function can only be called in master mode.
	 */
	public void writeFrameLowLevel(int frameLength, int frameChunkOffset, int[] frameChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FRAME_LOW_LEVEL, this);

		bb.putShort((short)frameLength);
		bb.putShort((short)frameChunkOffset);
		for (int i = 0; i < 60; i++) {
			bb.put((byte)frameChunkData[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the last frame that was written by the DMX master. The size of the array
	 * is equivalent to the number of channels in the frame. Each byte represents one channel.
	 * 
	 * The next frame is available after the {@link BrickletDMX.FrameAvailableListener} listener was called.
	 * 
	 * Generic approach:
	 * 
	 * * Call {@link BrickletDMX#readFrame()} to get first frame.
	 * * Wait for the {@link BrickletDMX.FrameAvailableListener} listener.
	 * * Call {@link BrickletDMX#readFrame()} to get second frame.
	 * * Wait for the {@link BrickletDMX.FrameAvailableListener} listener.
	 * * and so on.
	 * 
	 * Instead of polling this function you can also use the {@link BrickletDMX.FrameListener} listener.
	 * You can enable it with {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 * 
	 * The frame number starts at 0 and it is increased by one with each received frame.
	 * 
	 * This function can only be called in slave mode.
	 */
	public ReadFrameLowLevel readFrameLowLevel() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_FRAME_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadFrameLowLevel obj = new ReadFrameLowLevel();
		obj.frameLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.frameChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 56; i++) {
			obj.frameChunkData[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.frameNumber = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the duration of a frame.
	 * 
	 * Example: If you want to achieve 20 frames per second, you should
	 * set the frame duration to 50ms (50ms * 20 = 1 second).
	 * 
	 * If you always want to send a frame as fast as possible you can set
	 * this value to 0.
	 * 
	 * This setting is only used in master mode.
	 */
	public void setFrameDuration(int frameDuration) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_FRAME_DURATION, this);

		bb.putShort((short)frameDuration);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the frame duration as set by {@link BrickletDMX#setFrameDuration(int)}.
	 */
	public int getFrameDuration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_DURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int frameDuration = IPConnectionBase.unsignedShort(bb.getShort());

		return frameDuration;
	}

	/**
	 * Returns the current number of overrun and framing errors.
	 */
	public FrameErrorCount getFrameErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 16);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		FrameErrorCount obj = new FrameErrorCount();
		obj.overrunErrorCount = IPConnectionBase.unsignedInt(bb.getInt());
		obj.framingErrorCount = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the communication LED configuration. By default the LED shows
	 * communication traffic, it flickers once for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is off.
	 */
	public void setCommunicationLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_COMMUNICATION_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletDMX#setCommunicationLEDConfig(int)}
	 */
	public int getCommunicationLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COMMUNICATION_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Sets the error LED configuration.
	 * 
	 * By default the error LED turns on if there is any error (see {@link BrickletDMX.FrameErrorCountListener}
	 * callback). If you call this function with the Show-Error option again, the LED
	 * will turn off until the next error occurs.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is off.
	 */
	public void setErrorLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_ERROR_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletDMX#setErrorLEDConfig(int)}.
	 */
	public int getErrorLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ERROR_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Enables/Disables the different listeners. By default the
	 * {@link BrickletDMX.FrameStartedListener} listener and {@link BrickletDMX.FrameAvailableListener} listener are enabled while
	 * the {@link BrickletDMX.FrameListener} listener and {@link BrickletDMX.FrameErrorCountListener} listener are disabled.
	 * 
	 * If you want to use the {@link BrickletDMX.FrameListener} listener you can enable it and disable
	 * the cb:`Frame Available` listener at the same time. It becomes redundant in
	 * this case.
	 */
	public void setFrameCallbackConfig(boolean frameStartedCallbackEnabled, boolean frameAvailableCallbackEnabled, boolean frameCallbackEnabled, boolean frameErrorCountCallbackEnabled) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_FRAME_CALLBACK_CONFIG, this);

		bb.put((byte)(frameStartedCallbackEnabled ? 1 : 0));
		bb.put((byte)(frameAvailableCallbackEnabled ? 1 : 0));
		bb.put((byte)(frameCallbackEnabled ? 1 : 0));
		bb.put((byte)(frameErrorCountCallbackEnabled ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the frame listener config as set by {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 */
	public FrameCallbackConfig getFrameCallbackConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_CALLBACK_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		FrameCallbackConfig obj = new FrameCallbackConfig();
		obj.frameStartedCallbackEnabled = (bb.get()) != 0;
		obj.frameAvailableCallbackEnabled = (bb.get()) != 0;
		obj.frameCallbackEnabled = (bb.get()) != 0;
		obj.frameErrorCountCallbackEnabled = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletDMX#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletDMX#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletDMX#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletDMX#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Writes a DMX frame. The maximum frame size is 512 byte. Each byte represents one channel.
	 * 
	 * The next frame can be written after the {@link BrickletDMX.FrameStartedListener} listener was called. The frame
	 * is double buffered, so a new frame can be written as soon as the writing of the prior frame
	 * starts.
	 * 
	 * The data will be transfered when the next frame duration ends, see {@link BrickletDMX#setFrameDuration(int)}.
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per second you want to achieve.
	 * * Set channels for first frame.
	 * * Wait for the {@link BrickletDMX.FrameStartedListener} listener.
	 * * Set channels for next frame.
	 * * Wait for the {@link BrickletDMX.FrameStartedListener} listener.
	 * * and so on.
	 * 
	 * This approach ensures that you can set new DMX data with a fixed frame rate.
	 * 
	 * This function can only be called in master mode.
	 */
	public void writeFrame(int[] frame) throws TinkerforgeException {
		if (frame.length > 65535) {
			throw new IllegalArgumentException("Frame can be at most 65535 items long");
		}

		int frameLength = frame.length;
		int frameChunkOffset = 0;
		int[] frameChunkData = new int[60];
		int frameChunkLength;

		if (frameLength == 0) {
			Arrays.fill(frameChunkData, 0);

			writeFrameLowLevel(frameLength, frameChunkOffset, frameChunkData);
		} else {
			synchronized (streamMutex) {
				while (frameChunkOffset < frameLength) {
					frameChunkLength = Math.min(frameLength - frameChunkOffset, 60);

					System.arraycopy(frame, frameChunkOffset, frameChunkData, 0, frameChunkLength);
					Arrays.fill(frameChunkData, frameChunkLength, 60, 0);

					writeFrameLowLevel(frameLength, frameChunkOffset, frameChunkData);
					frameChunkOffset += 60;
				}
			}
		}
	}

	/**
	 * Returns the last frame that was written by the DMX master. The size of the array
	 * is equivalent to the number of channels in the frame. Each byte represents one channel.
	 * 
	 * The next frame is available after the {@link BrickletDMX.FrameAvailableListener} listener was called.
	 * 
	 * Generic approach:
	 * 
	 * * Call {@link BrickletDMX#readFrame()} to get first frame.
	 * * Wait for the {@link BrickletDMX.FrameAvailableListener} listener.
	 * * Call {@link BrickletDMX#readFrame()} to get second frame.
	 * * Wait for the {@link BrickletDMX.FrameAvailableListener} listener.
	 * * and so on.
	 * 
	 * Instead of polling this function you can also use the {@link BrickletDMX.FrameListener} listener.
	 * You can enable it with {@link BrickletDMX#setFrameCallbackConfig(boolean, boolean, boolean, boolean)}.
	 * 
	 * The frame number starts at 0 and it is increased by one with each received frame.
	 * 
	 * This function can only be called in slave mode.
	 */
	public ReadFrame readFrame() throws TinkerforgeException {
		ReadFrameLowLevel ret;
		int[] frame = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int frameLength;
		int frameChunkOffset;
		int frameChunkLength;
		boolean frameOutOfSync;
		int frameCurrentLength;

		synchronized (streamMutex) {
			ret = readFrameLowLevel();
			frameLength = ret.frameLength;
			frameChunkOffset = ret.frameChunkOffset;
			frameOutOfSync = frameChunkOffset != 0;

			if (!frameOutOfSync) {
				frame = new int[frameLength];
				frameChunkLength = Math.min(frameLength - frameChunkOffset, 56);

				System.arraycopy(ret.frameChunkData, 0, frame, 0, frameChunkLength);

				frameCurrentLength = frameChunkLength;

				while (frameCurrentLength < frameLength) {
					ret = readFrameLowLevel();
					frameLength = ret.frameLength;
					frameOutOfSync = ret.frameChunkOffset != frameCurrentLength;

					if (frameOutOfSync) {
						break;
					}

					frameChunkLength = Math.min(frameLength - ret.frameChunkOffset, 56);

					System.arraycopy(ret.frameChunkData, 0, frame, frameCurrentLength, frameChunkLength);

					frameCurrentLength += frameChunkLength;
				}
			}

			if (frameOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.frameChunkOffset + 56 < frameLength) {
					ret = readFrameLowLevel();
					frameLength = ret.frameLength;
				}

				throw new StreamOutOfSyncException("Frame stream is out-of-sync");
			}
		}

		return new ReadFrame(frame, ret.frameNumber);
	}

	/**
	 * Adds a FrameStarted listener.
	 */
	public void addFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.add(listener);
	}

	/**
	 * Removes a FrameStarted listener.
	 */
	public void removeFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.remove(listener);
	}

	/**
	 * Adds a FrameAvailable listener.
	 */
	public void addFrameAvailableListener(FrameAvailableListener listener) {
		listenerFrameAvailable.add(listener);
	}

	/**
	 * Removes a FrameAvailable listener.
	 */
	public void removeFrameAvailableListener(FrameAvailableListener listener) {
		listenerFrameAvailable.remove(listener);
	}

	/**
	 * Adds a FrameLowLevel listener.
	 */
	public void addFrameLowLevelListener(FrameLowLevelListener listener) {
		listenerFrameLowLevel.add(listener);
	}

	/**
	 * Removes a FrameLowLevel listener.
	 */
	public void removeFrameLowLevelListener(FrameLowLevelListener listener) {
		listenerFrameLowLevel.remove(listener);
	}

	/**
	 * Adds a FrameErrorCount listener.
	 */
	public void addFrameErrorCountListener(FrameErrorCountListener listener) {
		listenerFrameErrorCount.add(listener);
	}

	/**
	 * Removes a FrameErrorCount listener.
	 */
	public void removeFrameErrorCountListener(FrameErrorCountListener listener) {
		listenerFrameErrorCount.remove(listener);
	}

	/**
	 * Adds a Frame listener.
	 */
	public void addFrameListener(FrameListener listener) {
		listenerFrame.add(listener);
	}

	/**
	 * Removes a Frame listener.
	 */
	public void removeFrameListener(FrameListener listener) {
		listenerFrame.remove(listener);
	}
}
