/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Three color 296x128 e-paper display
 */
public class BrickletEPaper296x128 extends Device {
	public final static int DEVICE_IDENTIFIER = 2146;
	public final static String DEVICE_DISPLAY_NAME = "E-Paper 296x128 Bricklet";

	public final static byte FUNCTION_DRAW = (byte)1;
	public final static byte FUNCTION_GET_DRAW_STATUS = (byte)2;
	public final static byte FUNCTION_WRITE_BLACK_WHITE_LOW_LEVEL = (byte)3;
	public final static byte FUNCTION_READ_BLACK_WHITE_LOW_LEVEL = (byte)4;
	public final static byte FUNCTION_WRITE_COLOR_LOW_LEVEL = (byte)5;
	public final static byte FUNCTION_READ_COLOR_LOW_LEVEL = (byte)6;
	public final static byte FUNCTION_FILL_DISPLAY = (byte)7;
	public final static byte FUNCTION_DRAW_TEXT = (byte)8;
	public final static byte FUNCTION_DRAW_LINE = (byte)9;
	public final static byte FUNCTION_DRAW_BOX = (byte)10;
	public final static byte FUNCTION_SET_UPDATE_MODE = (byte)12;
	public final static byte FUNCTION_GET_UPDATE_MODE = (byte)13;
	public final static byte FUNCTION_SET_DISPLAY_TYPE = (byte)14;
	public final static byte FUNCTION_GET_DISPLAY_TYPE = (byte)15;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_DRAW_STATUS = 11;

	public final static int DRAW_STATUS_IDLE = 0;
	public final static int DRAW_STATUS_COPYING = 1;
	public final static int DRAW_STATUS_DRAWING = 2;
	public final static int COLOR_BLACK = 0;
	public final static int COLOR_WHITE = 1;
	public final static int COLOR_RED = 2;
	public final static int COLOR_GRAY = 2;
	public final static int FONT_6X8 = 0;
	public final static int FONT_6X16 = 1;
	public final static int FONT_6X24 = 2;
	public final static int FONT_6X32 = 3;
	public final static int FONT_12X16 = 4;
	public final static int FONT_12X24 = 5;
	public final static int FONT_12X32 = 6;
	public final static int FONT_18X24 = 7;
	public final static int FONT_18X32 = 8;
	public final static int FONT_24X32 = 9;
	public final static int ORIENTATION_HORIZONTAL = 0;
	public final static int ORIENTATION_VERTICAL = 1;
	public final static int UPDATE_MODE_DEFAULT = 0;
	public final static int UPDATE_MODE_BLACK_WHITE = 1;
	public final static int UPDATE_MODE_DELTA = 2;
	public final static int DISPLAY_TYPE_BLACK_WHITE_RED = 0;
	public final static int DISPLAY_TYPE_BLACK_WHITE_GRAY = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<DrawStatusListener> listenerDrawStatus = new CopyOnWriteArrayList<DrawStatusListener>();

	public class ReadBlackWhiteLowLevel {
		public int pixelsLength;
		public int pixelsChunkOffset;
		public boolean[] pixelsChunkData = new boolean[464];

		public String toString() {
			return "[" + "pixelsLength = " + pixelsLength + ", " + "pixelsChunkOffset = " + pixelsChunkOffset + ", " + "pixelsChunkData = " + Arrays.toString(pixelsChunkData) + "]";
		}
	}

	public class ReadColorLowLevel {
		public int pixelsLength;
		public int pixelsChunkOffset;
		public boolean[] pixelsChunkData = new boolean[464];

		public String toString() {
			return "[" + "pixelsLength = " + pixelsLength + ", " + "pixelsChunkOffset = " + pixelsChunkOffset + ", " + "pixelsChunkData = " + Arrays.toString(pixelsChunkData) + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * Listener for the current draw status. Will be called every time the
	 * draw status changes (see {@link BrickletEPaper296x128#getDrawStatus()}).
	 */
	public interface DrawStatusListener extends DeviceListener {
		public void drawStatus(int drawStatus);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletEPaper296x128(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRAW)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DRAW_STATUS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_BLACK_WHITE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_BLACK_WHITE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_COLOR_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_COLOR_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_FILL_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRAW_TEXT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRAW_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRAW_BOX)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_UPDATE_MODE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_UPDATE_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DISPLAY_TYPE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DISPLAY_TYPE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_DRAW_STATUS] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 9) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int drawStatus = IPConnectionBase.unsignedByte(bb.get());

				for (DrawStatusListener listener: listenerDrawStatus) {
					listener.drawStatus(drawStatus);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Draws the current black/white and red or gray buffer to the e-paper display.
	 * 
	 * The Bricklet does not have any double-buffering. You should not call
	 * this function while writing to the buffer. See {@link BrickletEPaper296x128#getDrawStatus()}.
	 */
	public void draw() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DRAW, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns one of three draw statuses:
	 * 
	 * * Idle
	 * * Copying: Data is being copied from the buffer of the Bricklet to the buffer of the display.
	 * * Drawing: The display is updating its content (during this phase the flickering etc happens).
	 * 
	 * You can write to the buffer (through one of the write or draw functions) when the status is
	 * either *idle* or *drawing*. You should not write to the buffer while it is being *copied* to the
	 * display. There is no double-buffering.
	 */
	public int getDrawStatus() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DRAW_STATUS, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int drawStatus = IPConnectionBase.unsignedByte(bb.get());

		return drawStatus;
	}

	/**
	 * Writes black/white pixels to the specified window into the buffer.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The value 0 (false) corresponds to a black pixel and the value 1 (true) to a
	 * white pixel.
	 * 
	 * This function writes the pixels into the black/white pixel buffer, to draw the
	 * buffer to the display use {@link BrickletEPaper296x128#draw()}.
	 * 
	 * Use {@link BrickletEPaper296x128#writeColor(int, int, int, int, boolean[])} to write red or gray pixels.
	 */
	public void writeBlackWhiteLowLevel(int xStart, int yStart, int xEnd, int yEnd, int pixelsLength, int pixelsChunkOffset, boolean[] pixelsChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_BLACK_WHITE_LOW_LEVEL, this);

		bb.putShort((short)xStart);
		bb.put((byte)yStart);
		bb.putShort((short)xEnd);
		bb.put((byte)yEnd);
		bb.putShort((short)pixelsLength);
		bb.putShort((short)pixelsChunkOffset);

		byte[] pixelsChunkDataBits = new byte[54];
		Arrays.fill(pixelsChunkDataBits, (byte)0);

		for (int i = 0; i < 432; i++) {
			if (pixelsChunkData[i]) {
				pixelsChunkDataBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 54; i++) {
			bb.put(pixelsChunkDataBits[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current content of the black/white pixel buffer for the specified window.
	 * 
	 * The pixels are read into the window line by line top to bottom and
	 * each line is read from left to right.
	 * 
	 * The current content of the buffer does not have to be the current content of the display.
	 * It is possible that the data was not drawn to the display yet and after a restart of
	 * the Bricklet the buffer will be reset to black, while the display retains its content.
	 */
	public ReadBlackWhiteLowLevel readBlackWhiteLowLevel(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_READ_BLACK_WHITE_LOW_LEVEL, this);

		bb.putShort((short)xStart);
		bb.put((byte)yStart);
		bb.putShort((short)xEnd);
		bb.put((byte)yEnd);

		byte[] response = sendRequest(bb.array(), 70);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadBlackWhiteLowLevel obj = new ReadBlackWhiteLowLevel();
		obj.pixelsLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.pixelsChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		byte[] pixelsChunkDataBits = new byte[58];
		bb.get(pixelsChunkDataBits);
		for (int i = 0; i < 464; i++) {
			obj.pixelsChunkData[i] = (pixelsChunkDataBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return obj;
	}

	/**
	 * The E-Paper 296x128 Bricklet is available with the colors black/white/red and
	 * black/white/gray. Depending on the model this function writes either red or
	 * gray pixels to the specified window into the buffer.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The value 0 (false) means that this pixel does not have color. It will be either black
	 * or white (see {@link BrickletEPaper296x128#writeBlackWhite(int, int, int, int, boolean[])}). The value 1 (true) corresponds to a red or gray
	 * pixel, depending on the Bricklet model.
	 * 
	 * This function writes the pixels into the red or gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 * 
	 * Use {@link BrickletEPaper296x128#writeBlackWhite(int, int, int, int, boolean[])} to write black/white pixels.
	 */
	public void writeColorLowLevel(int xStart, int yStart, int xEnd, int yEnd, int pixelsLength, int pixelsChunkOffset, boolean[] pixelsChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_COLOR_LOW_LEVEL, this);

		bb.putShort((short)xStart);
		bb.put((byte)yStart);
		bb.putShort((short)xEnd);
		bb.put((byte)yEnd);
		bb.putShort((short)pixelsLength);
		bb.putShort((short)pixelsChunkOffset);

		byte[] pixelsChunkDataBits = new byte[54];
		Arrays.fill(pixelsChunkDataBits, (byte)0);

		for (int i = 0; i < 432; i++) {
			if (pixelsChunkData[i]) {
				pixelsChunkDataBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 54; i++) {
			bb.put(pixelsChunkDataBits[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current content of the red or gray pixel buffer for the specified window.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The current content of the buffer does not have to be the current content of the display.
	 * It is possible that the data was not drawn to the display yet and after a restart of
	 * the Bricklet the buffer will be reset to black, while the display retains its content.
	 */
	public ReadColorLowLevel readColorLowLevel(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_READ_COLOR_LOW_LEVEL, this);

		bb.putShort((short)xStart);
		bb.put((byte)yStart);
		bb.putShort((short)xEnd);
		bb.put((byte)yEnd);

		byte[] response = sendRequest(bb.array(), 70);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadColorLowLevel obj = new ReadColorLowLevel();
		obj.pixelsLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.pixelsChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		byte[] pixelsChunkDataBits = new byte[58];
		bb.get(pixelsChunkDataBits);
		for (int i = 0; i < 464; i++) {
			obj.pixelsChunkData[i] = (pixelsChunkDataBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return obj;
	}

	/**
	 * Fills the complete content of the display with the given color.
	 * 
	 * This function writes the pixels into the black/white/red|gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 */
	public void fillDisplay(int color) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_FILL_DISPLAY, this);

		bb.put((byte)color);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Draws a text with up to 50 characters at the pixel position (x, y).
	 * 
	 * You can use one of 9 different font sizes and draw the text in
	 * black/white/red|gray. The text can be drawn horizontal or vertical.
	 * 
	 * This function writes the pixels into the black/white/red|gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 */
	public void drawText(int positionX, int positionY, int font, int color, int orientation, String text) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)64, FUNCTION_DRAW_TEXT, this);

		bb.putShort((short)positionX);
		bb.put((byte)positionY);
		bb.put((byte)font);
		bb.put((byte)color);
		bb.put((byte)orientation);
		for (int i = 0; i < 50; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Draws a line from (x, y)-start to (x, y)-end in the given color.
	 * 
	 * This function writes the pixels into the black/white/red|gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 */
	public void drawLine(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, int color) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)15, FUNCTION_DRAW_LINE, this);

		bb.putShort((short)positionXStart);
		bb.put((byte)positionYStart);
		bb.putShort((short)positionXEnd);
		bb.put((byte)positionYEnd);
		bb.put((byte)color);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Draws a box from (x, y)-start to (x, y)-end in the given color.
	 * 
	 * If you set fill to true, the box will be filled with the
	 * color. Otherwise only the outline will be drawn.
	 * 
	 * This function writes the pixels into the black/white/red|gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 */
	public void drawBox(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, int color) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_DRAW_BOX, this);

		bb.putShort((short)positionXStart);
		bb.put((byte)positionYStart);
		bb.putShort((short)positionXEnd);
		bb.put((byte)positionYEnd);
		bb.put((byte)(fill ? 1 : 0));
		bb.put((byte)color);

		sendRequest(bb.array(), 0);
	}

	/**
	 * \note
	 *  The default update mode corresponds to the default e-paper display
	 *  manufacturer settings. All of the other modes are experimental and
	 *  will result in increased ghosting and possibly other long-term
	 *  side effects.
	 * 
	 *  If you want to know more about the inner workings of an e-paper display
	 *  take a look at this excellent video from Ben Krasnow:
	 *  `https://www.youtube.com/watch?v=MsbiO8EAsGw &lt;https://www.youtube.com/watch?v=MsbiO8EAsGw&gt;`__.
	 * 
	 *  If you are not sure about this option, leave the update mode at default.
	 * 
	 * Currently there are three update modes available:
	 * 
	 * * Default: Settings as given by the manufacturer. An update will take about
	 *   7.5 seconds and during the update the screen will flicker several times.
	 * * Black/White: This will only update the black/white pixel. It uses the manufacturer
	 *   settings for black/white and ignores the red or gray pixel buffer. With this mode the
	 *   display will flicker once and it takes about 2.5 seconds. Compared to the default settings
	 *   there is more ghosting.
	 * * Delta: This will only update the black/white pixel. It uses an aggressive method where
	 *   the changes are not applied for a whole buffer but only for the delta between the last
	 *   and the next buffer. With this mode the display will not flicker during an update and
	 *   it takes about 900-950ms. Compared to the other two settings there is more ghosting. This
	 *   mode can be used for something like a flicker-free live update of a text.
	 * 
	 * With the black/white/red display if you use either the black/white or the delta mode,
	 * after a while of going back and forth between black and white the white color will
	 * start to appear red-ish or pink-ish.
	 * 
	 * If you use the aggressive delta mode and rapidly change the content, we recommend that you
	 * change back to the default mode every few hours and in the default mode cycle between the
	 * three available colors a few times. This will get rid of the ghosting and after that you can
	 * go back to the delta mode with flicker-free updates.
	 */
	public void setUpdateMode(int updateMode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_UPDATE_MODE, this);

		bb.put((byte)updateMode);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the update mode as set by {@link BrickletEPaper296x128#setUpdateMode(int)}.
	 */
	public int getUpdateMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_UPDATE_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int updateMode = IPConnectionBase.unsignedByte(bb.get());

		return updateMode;
	}

	/**
	 * Sets the type of the display. The e-paper display is available
	 * in black/white/red and black/white/gray. This will be factory set
	 * during the flashing and testing phase. The value is saved in
	 * non-volatile memory and will stay after a power cycle.
	 */
	public void setDisplayType(int displayType) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_DISPLAY_TYPE, this);

		bb.put((byte)displayType);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the type of the e-paper display. It can either be
	 * black/white/red or black/white/gray.
	 */
	public int getDisplayType() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISPLAY_TYPE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int displayType = IPConnectionBase.unsignedByte(bb.get());

		return displayType;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletEPaper296x128#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletEPaper296x128#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletEPaper296x128#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletEPaper296x128#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Writes black/white pixels to the specified window into the buffer.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The value 0 (false) corresponds to a black pixel and the value 1 (true) to a
	 * white pixel.
	 * 
	 * This function writes the pixels into the black/white pixel buffer, to draw the
	 * buffer to the display use {@link BrickletEPaper296x128#draw()}.
	 * 
	 * Use {@link BrickletEPaper296x128#writeColor(int, int, int, int, boolean[])} to write red or gray pixels.
	 */
	public void writeBlackWhite(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
		if (pixels.length > 65535) {
			throw new IllegalArgumentException("Pixels can be at most 65535 items long");
		}

		int pixelsLength = pixels.length;
		int pixelsChunkOffset = 0;
		boolean[] pixelsChunkData = new boolean[432];
		int pixelsChunkLength;

		if (pixelsLength == 0) {
			Arrays.fill(pixelsChunkData, false);

			writeBlackWhiteLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
		} else {
			synchronized (streamMutex) {
				while (pixelsChunkOffset < pixelsLength) {
					pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 432);

					System.arraycopy(pixels, pixelsChunkOffset, pixelsChunkData, 0, pixelsChunkLength);
					Arrays.fill(pixelsChunkData, pixelsChunkLength, 432, false);

					writeBlackWhiteLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
					pixelsChunkOffset += 432;
				}
			}
		}
	}

	/**
	 * Returns the current content of the black/white pixel buffer for the specified window.
	 * 
	 * The pixels are read into the window line by line top to bottom and
	 * each line is read from left to right.
	 * 
	 * The current content of the buffer does not have to be the current content of the display.
	 * It is possible that the data was not drawn to the display yet and after a restart of
	 * the Bricklet the buffer will be reset to black, while the display retains its content.
	 */
	public boolean[] readBlackWhite(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		ReadBlackWhiteLowLevel ret;
		boolean[] pixels = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int pixelsLength;
		int pixelsChunkOffset;
		int pixelsChunkLength;
		boolean pixelsOutOfSync;
		int pixelsCurrentLength;

		synchronized (streamMutex) {
			ret = readBlackWhiteLowLevel(xStart, yStart, xEnd, yEnd);
			pixelsLength = ret.pixelsLength;
			pixelsChunkOffset = ret.pixelsChunkOffset;
			pixelsOutOfSync = pixelsChunkOffset != 0;

			if (!pixelsOutOfSync) {
				pixels = new boolean[pixelsLength];
				pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 464);

				System.arraycopy(ret.pixelsChunkData, 0, pixels, 0, pixelsChunkLength);

				pixelsCurrentLength = pixelsChunkLength;

				while (pixelsCurrentLength < pixelsLength) {
					ret = readBlackWhiteLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
					pixelsOutOfSync = ret.pixelsChunkOffset != pixelsCurrentLength;

					if (pixelsOutOfSync) {
						break;
					}

					pixelsChunkLength = Math.min(pixelsLength - ret.pixelsChunkOffset, 464);

					System.arraycopy(ret.pixelsChunkData, 0, pixels, pixelsCurrentLength, pixelsChunkLength);

					pixelsCurrentLength += pixelsChunkLength;
				}
			}

			if (pixelsOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.pixelsChunkOffset + 464 < pixelsLength) {
					ret = readBlackWhiteLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
				}

				throw new StreamOutOfSyncException("Pixels stream is out-of-sync");
			}
		}

		return pixels;
	}

	/**
	 * The E-Paper 296x128 Bricklet is available with the colors black/white/red and
	 * black/white/gray. Depending on the model this function writes either red or
	 * gray pixels to the specified window into the buffer.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The value 0 (false) means that this pixel does not have color. It will be either black
	 * or white (see {@link BrickletEPaper296x128#writeBlackWhite(int, int, int, int, boolean[])}). The value 1 (true) corresponds to a red or gray
	 * pixel, depending on the Bricklet model.
	 * 
	 * This function writes the pixels into the red or gray pixel buffer, to draw the buffer
	 * to the display use {@link BrickletEPaper296x128#draw()}.
	 * 
	 * Use {@link BrickletEPaper296x128#writeBlackWhite(int, int, int, int, boolean[])} to write black/white pixels.
	 */
	public void writeColor(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
		if (pixels.length > 65535) {
			throw new IllegalArgumentException("Pixels can be at most 65535 items long");
		}

		int pixelsLength = pixels.length;
		int pixelsChunkOffset = 0;
		boolean[] pixelsChunkData = new boolean[432];
		int pixelsChunkLength;

		if (pixelsLength == 0) {
			Arrays.fill(pixelsChunkData, false);

			writeColorLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
		} else {
			synchronized (streamMutex) {
				while (pixelsChunkOffset < pixelsLength) {
					pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 432);

					System.arraycopy(pixels, pixelsChunkOffset, pixelsChunkData, 0, pixelsChunkLength);
					Arrays.fill(pixelsChunkData, pixelsChunkLength, 432, false);

					writeColorLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
					pixelsChunkOffset += 432;
				}
			}
		}
	}

	/**
	 * Returns the current content of the red or gray pixel buffer for the specified window.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * The current content of the buffer does not have to be the current content of the display.
	 * It is possible that the data was not drawn to the display yet and after a restart of
	 * the Bricklet the buffer will be reset to black, while the display retains its content.
	 */
	public boolean[] readColor(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		ReadColorLowLevel ret;
		boolean[] pixels = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int pixelsLength;
		int pixelsChunkOffset;
		int pixelsChunkLength;
		boolean pixelsOutOfSync;
		int pixelsCurrentLength;

		synchronized (streamMutex) {
			ret = readColorLowLevel(xStart, yStart, xEnd, yEnd);
			pixelsLength = ret.pixelsLength;
			pixelsChunkOffset = ret.pixelsChunkOffset;
			pixelsOutOfSync = pixelsChunkOffset != 0;

			if (!pixelsOutOfSync) {
				pixels = new boolean[pixelsLength];
				pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 464);

				System.arraycopy(ret.pixelsChunkData, 0, pixels, 0, pixelsChunkLength);

				pixelsCurrentLength = pixelsChunkLength;

				while (pixelsCurrentLength < pixelsLength) {
					ret = readColorLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
					pixelsOutOfSync = ret.pixelsChunkOffset != pixelsCurrentLength;

					if (pixelsOutOfSync) {
						break;
					}

					pixelsChunkLength = Math.min(pixelsLength - ret.pixelsChunkOffset, 464);

					System.arraycopy(ret.pixelsChunkData, 0, pixels, pixelsCurrentLength, pixelsChunkLength);

					pixelsCurrentLength += pixelsChunkLength;
				}
			}

			if (pixelsOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.pixelsChunkOffset + 464 < pixelsLength) {
					ret = readColorLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
				}

				throw new StreamOutOfSyncException("Pixels stream is out-of-sync");
			}
		}

		return pixels;
	}

	/**
	 * Adds a DrawStatus listener.
	 */
	public void addDrawStatusListener(DrawStatusListener listener) {
		listenerDrawStatus.add(listener);
	}

	/**
	 * Removes a DrawStatus listener.
	 */
	public void removeDrawStatusListener(DrawStatusListener listener) {
		listenerDrawStatus.remove(listener);
	}
}
