/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Controls up to 2048 RGB(W) LEDs
 */
public class BrickletLEDStripV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2103;
	public final static String DEVICE_DISPLAY_NAME = "LED Strip Bricklet 2.0";

	public final static byte FUNCTION_SET_LED_VALUES_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_GET_LED_VALUES_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_SET_FRAME_DURATION = (byte)3;
	public final static byte FUNCTION_GET_FRAME_DURATION = (byte)4;
	public final static byte FUNCTION_GET_SUPPLY_VOLTAGE = (byte)5;
	public final static byte FUNCTION_SET_CLOCK_FREQUENCY = (byte)7;
	public final static byte FUNCTION_GET_CLOCK_FREQUENCY = (byte)8;
	public final static byte FUNCTION_SET_CHIP_TYPE = (byte)9;
	public final static byte FUNCTION_GET_CHIP_TYPE = (byte)10;
	public final static byte FUNCTION_SET_CHANNEL_MAPPING = (byte)11;
	public final static byte FUNCTION_GET_CHANNEL_MAPPING = (byte)12;
	public final static byte FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_FRAME_STARTED = 6;

	public final static int CHIP_TYPE_WS2801 = 2801;
	public final static int CHIP_TYPE_WS2811 = 2811;
	public final static int CHIP_TYPE_WS2812 = 2812;
	public final static int CHIP_TYPE_LPD8806 = 8806;
	public final static int CHIP_TYPE_APA102 = 102;
	public final static int CHANNEL_MAPPING_RGB = 6;
	public final static int CHANNEL_MAPPING_RBG = 9;
	public final static int CHANNEL_MAPPING_BRG = 33;
	public final static int CHANNEL_MAPPING_BGR = 36;
	public final static int CHANNEL_MAPPING_GRB = 18;
	public final static int CHANNEL_MAPPING_GBR = 24;
	public final static int CHANNEL_MAPPING_RGBW = 27;
	public final static int CHANNEL_MAPPING_RGWB = 30;
	public final static int CHANNEL_MAPPING_RBGW = 39;
	public final static int CHANNEL_MAPPING_RBWG = 45;
	public final static int CHANNEL_MAPPING_RWGB = 54;
	public final static int CHANNEL_MAPPING_RWBG = 57;
	public final static int CHANNEL_MAPPING_GRWB = 78;
	public final static int CHANNEL_MAPPING_GRBW = 75;
	public final static int CHANNEL_MAPPING_GBWR = 108;
	public final static int CHANNEL_MAPPING_GBRW = 99;
	public final static int CHANNEL_MAPPING_GWBR = 120;
	public final static int CHANNEL_MAPPING_GWRB = 114;
	public final static int CHANNEL_MAPPING_BRGW = 135;
	public final static int CHANNEL_MAPPING_BRWG = 141;
	public final static int CHANNEL_MAPPING_BGRW = 147;
	public final static int CHANNEL_MAPPING_BGWR = 156;
	public final static int CHANNEL_MAPPING_BWRG = 177;
	public final static int CHANNEL_MAPPING_BWGR = 180;
	public final static int CHANNEL_MAPPING_WRBG = 201;
	public final static int CHANNEL_MAPPING_WRGB = 198;
	public final static int CHANNEL_MAPPING_WGBR = 216;
	public final static int CHANNEL_MAPPING_WGRB = 210;
	public final static int CHANNEL_MAPPING_WBGR = 228;
	public final static int CHANNEL_MAPPING_WBRG = 225;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<FrameStartedListener> listenerFrameStarted = new CopyOnWriteArrayList<FrameStartedListener>();

	public class LEDValuesLowLevel {
		public int valueLength;
		public int valueChunkOffset;
		public int[] valueChunkData = new int[60];

		public String toString() {
			return "[" + "valueLength = " + valueLength + ", " + "valueChunkOffset = " + valueChunkOffset + ", " + "valueChunkData = " + Arrays.toString(valueChunkData) + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered directly after a new frame render is started.
	 * The parameter is the number of LEDs in that frame.
	 * 
	 * You should send the data for the next frame directly after this listener
	 * was triggered.
	 * 
	 * For an explanation of the general approach see {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 */
	public interface FrameStartedListener extends DeviceListener {
		public void frameStarted(int length);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLEDStripV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_LED_VALUES_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_LED_VALUES_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_DURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SUPPLY_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CLOCK_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CLOCK_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CHIP_TYPE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TYPE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CHANNEL_MAPPING)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHANNEL_MAPPING)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_FRAME_STARTED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int length = IPConnectionBase.unsignedShort(bb.getShort());

				for (FrameStartedListener listener: listenerFrameStarted) {
					listener.frameStarted(length);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the RGB(W) values for the LEDs starting from *index*.
	 * You can set at most 2048 RGB values or 1536 RGBW values (6144 byte each).
	 * 
	 * To make the colors show correctly you need to configure the chip type
	 * (see {@link BrickletLEDStripV2#setChipType(int)}) and a channel mapping (see {@link BrickletLEDStripV2#setChannelMapping(int)})
	 * according to the connected LEDs.
	 * 
	 * If the channel mapping has 3 colors, you need to give the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
	 * sequence RGBWRGBWRGBW...
	 * 
	 * The data is double buffered and the colors will be transfered to the
	 * LEDs when the next frame duration ends (see {@link BrickletLEDStripV2#setFrameDuration(int)}).
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per
	 *   second you want to achieve.
	 * * Set all of the LED colors for one frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * Set all of the LED colors for next frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * And so on.
	 * 
	 * This approach ensures that you can change the LED colors with a fixed frame rate.
	 */
	public void setLEDValuesLowLevel(int index, int valueLength, int valueChunkOffset, int[] valueChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_SET_LED_VALUES_LOW_LEVEL, this);

		bb.putShort((short)index);
		bb.putShort((short)valueLength);
		bb.putShort((short)valueChunkOffset);
		for (int i = 0; i < 58; i++) {
			bb.put((byte)valueChunkData[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *length* RGB(W) values starting from the
	 * given *index*.
	 * 
	 * If the channel mapping has 3 colors, you will get the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you will get the data in the
	 * sequence RGBWRGBWRGBW...
	 * (assuming you start at an index divisible by 3 (RGB) or 4 (RGBW)).
	 */
	public LEDValuesLowLevel getLEDValuesLowLevel(int index, int length) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_GET_LED_VALUES_LOW_LEVEL, this);

		bb.putShort((short)index);
		bb.putShort((short)length);

		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		LEDValuesLowLevel obj = new LEDValuesLowLevel();
		obj.valueLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.valueChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 60; i++) {
			obj.valueChunkData[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return obj;
	}

	/**
	 * Sets the frame duration.
	 * 
	 * Example: If you want to achieve 20 frames per second, you should
	 * set the frame duration to 50ms (50ms * 20 = 1 second).
	 * 
	 * For an explanation of the general approach see {@link BrickletLEDStripV2#setLEDValues(int, int[])}.
	 * 
	 * Default value: 100ms (10 frames per second).
	 */
	public void setFrameDuration(int duration) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_FRAME_DURATION, this);

		bb.putShort((short)duration);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the frame duration as set by {@link BrickletLEDStripV2#setFrameDuration(int)}.
	 */
	public int getFrameDuration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_DURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int duration = IPConnectionBase.unsignedShort(bb.getShort());

		return duration;
	}

	/**
	 * Returns the current supply voltage of the LEDs.
	 */
	public int getSupplyVoltage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SUPPLY_VOLTAGE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnectionBase.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Sets the frequency of the clock.
	 * 
	 * The Bricklet will choose the nearest achievable frequency, which may
	 * be off by a few Hz. You can get the exact frequency that is used by
	 * calling {@link BrickletLEDStripV2#getClockFrequency()}.
	 * 
	 * If you have problems with flickering LEDs, they may be bits flipping. You
	 * can fix this by either making the connection between the LEDs and the
	 * Bricklet shorter or by reducing the frequency.
	 * 
	 * With a decreasing frequency your maximum frames per second will decrease
	 * too.
	 */
	public void setClockFrequency(long frequency) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CLOCK_FREQUENCY, this);

		bb.putInt((int)frequency);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the currently used clock frequency as set by {@link BrickletLEDStripV2#setClockFrequency(long)}.
	 */
	public long getClockFrequency() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CLOCK_FREQUENCY, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long frequency = IPConnectionBase.unsignedInt(bb.getInt());

		return frequency;
	}

	/**
	 * Sets the type of the LED driver chip. We currently support the chips
	 * 
	 * * WS2801,
	 * * WS2811,
	 * * WS2812 / SK6812 / NeoPixel RGB,
	 * * SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812),
	 * * WS2813 / WS2815 (Chip Type = WS2812)
	 * * LPD8806 and
	 * * APA102 / DotStar.
	 */
	public void setChipType(int chip) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CHIP_TYPE, this);

		bb.putShort((short)chip);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the currently used chip type as set by {@link BrickletLEDStripV2#setChipType(int)}.
	 */
	public int getChipType() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TYPE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int chip = IPConnectionBase.unsignedShort(bb.getShort());

		return chip;
	}

	/**
	 * Sets the channel mapping for the connected LEDs.
	 * 
	 * If the mapping has 4 colors, the function {@link BrickletLEDStripV2#setLEDValues(int, int[])} expects 4
	 * values per pixel and if the mapping has 3 colors it expects 3 values per pixel.
	 * 
	 * The function always expects the order RGB(W). The connected LED driver chips
	 * might have their 3 or 4 channels in a different order. For example, the WS2801
	 * chips typically use BGR order, then WS2812 chips typically use GRB order and
	 * the APA102 chips typically use WBGR order.
	 * 
	 * The APA102 chips are special. They have three 8-bit channels for RGB
	 * and an additional 5-bit channel for the overall brightness of the RGB LED
	 * making them 4-channel chips. Internally the brightness channel is the first
	 * channel, therefore one of the Wxyz channel mappings should be used. Then
	 * the W channel controls the brightness.
	 */
	public void setChannelMapping(int mapping) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_CHANNEL_MAPPING, this);

		bb.put((byte)mapping);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the currently used channel mapping as set by {@link BrickletLEDStripV2#setChannelMapping(int)}.
	 */
	public int getChannelMapping() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHANNEL_MAPPING, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mapping = IPConnectionBase.unsignedByte(bb.get());

		return mapping;
	}

	/**
	 * Enables/disables the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 */
	public void setFrameStartedCallbackConfiguration(boolean enable) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION, this);

		bb.put((byte)(enable ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by
	 * {@link BrickletLEDStripV2#setFrameStartedCallbackConfiguration(boolean)}.
	 */
	public boolean getFrameStartedCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enable = (bb.get()) != 0;

		return enable;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletLEDStripV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletLEDStripV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletLEDStripV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletLEDStripV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the RGB(W) values for the LEDs starting from *index*.
	 * You can set at most 2048 RGB values or 1536 RGBW values (6144 byte each).
	 * 
	 * To make the colors show correctly you need to configure the chip type
	 * (see {@link BrickletLEDStripV2#setChipType(int)}) and a channel mapping (see {@link BrickletLEDStripV2#setChannelMapping(int)})
	 * according to the connected LEDs.
	 * 
	 * If the channel mapping has 3 colors, you need to give the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
	 * sequence RGBWRGBWRGBW...
	 * 
	 * The data is double buffered and the colors will be transfered to the
	 * LEDs when the next frame duration ends (see {@link BrickletLEDStripV2#setFrameDuration(int)}).
	 * 
	 * Generic approach:
	 * 
	 * * Set the frame duration to a value that represents the number of frames per
	 *   second you want to achieve.
	 * * Set all of the LED colors for one frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * Set all of the LED colors for next frame.
	 * * Wait for the {@link BrickletLEDStripV2.FrameStartedListener} listener.
	 * * And so on.
	 * 
	 * This approach ensures that you can change the LED colors with a fixed frame rate.
	 */
	public void setLEDValues(int index, int[] value) throws TinkerforgeException {
		if (value.length > 65535) {
			throw new IllegalArgumentException("Value can be at most 65535 items long");
		}

		int valueLength = value.length;
		int valueChunkOffset = 0;
		int[] valueChunkData = new int[58];
		int valueChunkLength;

		if (valueLength == 0) {
			Arrays.fill(valueChunkData, 0);

			setLEDValuesLowLevel(index, valueLength, valueChunkOffset, valueChunkData);
		} else {
			synchronized (streamMutex) {
				while (valueChunkOffset < valueLength) {
					valueChunkLength = Math.min(valueLength - valueChunkOffset, 58);

					System.arraycopy(value, valueChunkOffset, valueChunkData, 0, valueChunkLength);
					Arrays.fill(valueChunkData, valueChunkLength, 58, 0);

					setLEDValuesLowLevel(index, valueLength, valueChunkOffset, valueChunkData);
					valueChunkOffset += 58;
				}
			}
		}
	}

	/**
	 * Returns *length* RGB(W) values starting from the
	 * given *index*.
	 * 
	 * If the channel mapping has 3 colors, you will get the data in the sequence
	 * RGBRGBRGB... if the channel mapping has 4 colors you will get the data in the
	 * sequence RGBWRGBWRGBW...
	 * (assuming you start at an index divisible by 3 (RGB) or 4 (RGBW)).
	 */
	public int[] getLEDValues(int index, int length) throws TinkerforgeException {
		LEDValuesLowLevel ret;
		int[] value = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int valueLength;
		int valueChunkOffset;
		int valueChunkLength;
		boolean valueOutOfSync;
		int valueCurrentLength;

		synchronized (streamMutex) {
			ret = getLEDValuesLowLevel(index, length);
			valueLength = ret.valueLength;
			valueChunkOffset = ret.valueChunkOffset;
			valueOutOfSync = valueChunkOffset != 0;

			if (!valueOutOfSync) {
				value = new int[valueLength];
				valueChunkLength = Math.min(valueLength - valueChunkOffset, 60);

				System.arraycopy(ret.valueChunkData, 0, value, 0, valueChunkLength);

				valueCurrentLength = valueChunkLength;

				while (valueCurrentLength < valueLength) {
					ret = getLEDValuesLowLevel(index, length);
					valueLength = ret.valueLength;
					valueOutOfSync = ret.valueChunkOffset != valueCurrentLength;

					if (valueOutOfSync) {
						break;
					}

					valueChunkLength = Math.min(valueLength - ret.valueChunkOffset, 60);

					System.arraycopy(ret.valueChunkData, 0, value, valueCurrentLength, valueChunkLength);

					valueCurrentLength += valueChunkLength;
				}
			}

			if (valueOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.valueChunkOffset + 60 < valueLength) {
					ret = getLEDValuesLowLevel(index, length);
					valueLength = ret.valueLength;
				}

				throw new StreamOutOfSyncException("Value stream is out-of-sync");
			}
		}

		return value;
	}

	/**
	 * Adds a FrameStarted listener.
	 */
	public void addFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.add(listener);
	}

	/**
	 * Removes a FrameStarted listener.
	 */
	public void removeFrameStartedListener(FrameStartedListener listener) {
		listenerFrameStarted.remove(listener);
	}
}
