/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 3.3cm (1.3") OLED display with 128x64 pixels
 */
public class BrickletOLED128x64V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2112;
	public final static String DEVICE_DISPLAY_NAME = "OLED 128x64 Bricklet 2.0";

	public final static byte FUNCTION_WRITE_PIXELS_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_READ_PIXELS_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_CLEAR_DISPLAY = (byte)3;
	public final static byte FUNCTION_SET_DISPLAY_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_DISPLAY_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_WRITE_LINE = (byte)6;
	public final static byte FUNCTION_DRAW_BUFFERED_FRAME = (byte)7;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;

	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


	public class ReadPixelsLowLevel {
		public int pixelsLength;
		public int pixelsChunkOffset;
		public boolean[] pixelsChunkData = new boolean[480];

		public String toString() {
			return "[" + "pixelsLength = " + pixelsLength + ", " + "pixelsChunkOffset = " + pixelsChunkOffset + ", " + "pixelsChunkData = " + Arrays.toString(pixelsChunkData) + "]";
		}
	}

	public class DisplayConfiguration {
		public int contrast;
		public boolean invert;
		public boolean automaticDraw;

		public String toString() {
			return "[" + "contrast = " + contrast + ", " + "invert = " + invert + ", " + "automaticDraw = " + automaticDraw + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletOLED128x64V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_PIXELS_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_PIXELS_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_CLEAR_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DRAW_BUFFERED_FRAME)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		ipcon.addDevice(this);
	}

	/**
	 * Writes pixels to the specified window.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * If automatic draw is enabled (default) the pixels are directly written to
	 * the screen. Only pixels that have actually changed are updated on the screen,
	 * the rest stays the same.
	 * 
	 * If automatic draw is disabled the pixels are written to an internal buffer and
	 * the buffer is transferred to the display only after {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}
	 * is called. This can be used to avoid flicker when drawing a complex frame in
	 * multiple steps.
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public void writePixelsLowLevel(int xStart, int yStart, int xEnd, int yEnd, int pixelsLength, int pixelsChunkOffset, boolean[] pixelsChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_PIXELS_LOW_LEVEL, this);

		bb.put((byte)xStart);
		bb.put((byte)yStart);
		bb.put((byte)xEnd);
		bb.put((byte)yEnd);
		bb.putShort((short)pixelsLength);
		bb.putShort((short)pixelsChunkOffset);

		byte[] pixelsChunkDataBits = new byte[56];
		Arrays.fill(pixelsChunkDataBits, (byte)0);

		for (int i = 0; i < 448; i++) {
			if (pixelsChunkData[i]) {
				pixelsChunkDataBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 56; i++) {
			bb.put(pixelsChunkDataBits[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Reads pixels from the specified window.
	 * 
	 * The pixels are read from the window line by line top to bottom
	 * and each line is read from left to right.
	 * 
	 * If automatic draw is enabled (default) the pixels that are read are always the
	 * same that are shown on the display.
	 * 
	 * If automatic draw is disabled the pixels are read from the internal buffer
	 * (see {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}).
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public ReadPixelsLowLevel readPixelsLowLevel(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_READ_PIXELS_LOW_LEVEL, this);

		bb.put((byte)xStart);
		bb.put((byte)yStart);
		bb.put((byte)xEnd);
		bb.put((byte)yEnd);

		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadPixelsLowLevel obj = new ReadPixelsLowLevel();
		obj.pixelsLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.pixelsChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		byte[] pixelsChunkDataBits = new byte[60];
		bb.get(pixelsChunkDataBits);
		for (int i = 0; i < 480; i++) {
			obj.pixelsChunkData[i] = (pixelsChunkDataBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return obj;
	}

	/**
	 * Clears the complete content of the display.
	 * 
	 * If automatic draw is enabled (default) the pixels are directly cleared.
	 * 
	 * If automatic draw is disabled the the internal buffer is cleared and
	 * the buffer is transferred to the display only after {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}
	 * is called. This can be used to avoid flicker when drawing a complex frame in
	 * multiple steps.
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public void clearDisplay() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CLEAR_DISPLAY, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Sets the configuration of the display.
	 * 
	 * You can set a contrast value from 0 to 255 and you can invert the color
	 * (white/black) of the display.
	 * 
	 * If automatic draw is set to *true*, the display is automatically updated with every
	 * call of {@link BrickletOLED128x64V2#writePixels(int, int, int, int, boolean[])} or {@link BrickletOLED128x64V2#writeLine(int, int, String)}. If it is set to false, the
	 * changes are written into an internal buffer and only shown on the display after
	 * a call of {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}.
	 */
	public void setDisplayConfiguration(int contrast, boolean invert, boolean automaticDraw) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_DISPLAY_CONFIGURATION, this);

		bb.put((byte)contrast);
		bb.put((byte)(invert ? 1 : 0));
		bb.put((byte)(automaticDraw ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}.
	 */
	public DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISPLAY_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 11);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DisplayConfiguration obj = new DisplayConfiguration();
		obj.contrast = IPConnectionBase.unsignedByte(bb.get());
		obj.invert = (bb.get()) != 0;
		obj.automaticDraw = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Writes text to a specific line with a specific position.
	 * The text can have a maximum of 22 characters.
	 * 
	 * For example: (1, 10, "Hello") will write *Hello* in the middle of the
	 * second line of the display.
	 * 
	 * The display uses a special 5x7 pixel charset. You can view the characters
	 * of the charset in Brick Viewer.
	 * 
	 * If automatic draw is enabled (default) the text is directly written to
	 * the screen. Only pixels that have actually changed are updated on the screen,
	 * the rest stays the same.
	 * 
	 * If automatic draw is disabled the text is written to an internal buffer and
	 * the buffer is transferred to the display only after {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}
	 * is called. This can be used to avoid flicker when drawing a complex frame in
	 * multiple steps.
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public void writeLine(int line, int position, String text) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)32, FUNCTION_WRITE_LINE, this);

		bb.put((byte)line);
		bb.put((byte)position);
		for (int i = 0; i < 22; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Draws the currently buffered frame. Normally each call of {@link BrickletOLED128x64V2#writePixels(int, int, int, int, boolean[])} and
	 * {@link BrickletOLED128x64V2#writeLine(int, int, String)} draws directly onto the display. If you turn automatic draw off
	 * ({@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}), the data is written in an internal buffer and
	 * only transferred to the display by calling this function. This can be used to
	 * avoid flicker when drawing a complex frame in multiple steps.
	 * 
	 * Set the `force complete redraw` to *true* to redraw the whole display
	 * instead of only the changed parts. Normally it should not be necessary to set this to
	 * *true*. It may only become necessary in case of stuck pixels because of errors.
	 */
	public void drawBufferedFrame(boolean forceCompleteRedraw) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_DRAW_BUFFERED_FRAME, this);

		bb.put((byte)(forceCompleteRedraw ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletOLED128x64V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletOLED128x64V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletOLED128x64V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletOLED128x64V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Writes pixels to the specified window.
	 * 
	 * The pixels are written into the window line by line top to bottom
	 * and each line is written from left to right.
	 * 
	 * If automatic draw is enabled (default) the pixels are directly written to
	 * the screen. Only pixels that have actually changed are updated on the screen,
	 * the rest stays the same.
	 * 
	 * If automatic draw is disabled the pixels are written to an internal buffer and
	 * the buffer is transferred to the display only after {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}
	 * is called. This can be used to avoid flicker when drawing a complex frame in
	 * multiple steps.
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public void writePixels(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
		if (pixels.length > 65535) {
			throw new IllegalArgumentException("Pixels can be at most 65535 items long");
		}

		int pixelsLength = pixels.length;
		int pixelsChunkOffset = 0;
		boolean[] pixelsChunkData = new boolean[448];
		int pixelsChunkLength;

		if (pixelsLength == 0) {
			Arrays.fill(pixelsChunkData, false);

			writePixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
		} else {
			synchronized (streamMutex) {
				while (pixelsChunkOffset < pixelsLength) {
					pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 448);

					System.arraycopy(pixels, pixelsChunkOffset, pixelsChunkData, 0, pixelsChunkLength);
					Arrays.fill(pixelsChunkData, pixelsChunkLength, 448, false);

					writePixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
					pixelsChunkOffset += 448;
				}
			}
		}
	}

	/**
	 * Reads pixels from the specified window.
	 * 
	 * The pixels are read from the window line by line top to bottom
	 * and each line is read from left to right.
	 * 
	 * If automatic draw is enabled (default) the pixels that are read are always the
	 * same that are shown on the display.
	 * 
	 * If automatic draw is disabled the pixels are read from the internal buffer
	 * (see {@link BrickletOLED128x64V2#drawBufferedFrame(boolean)}).
	 * 
	 * Automatic draw can be configured with the {@link BrickletOLED128x64V2#setDisplayConfiguration(int, boolean, boolean)}
	 * function.
	 */
	public boolean[] readPixels(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
		ReadPixelsLowLevel ret;
		boolean[] pixels = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int pixelsLength;
		int pixelsChunkOffset;
		int pixelsChunkLength;
		boolean pixelsOutOfSync;
		int pixelsCurrentLength;

		synchronized (streamMutex) {
			ret = readPixelsLowLevel(xStart, yStart, xEnd, yEnd);
			pixelsLength = ret.pixelsLength;
			pixelsChunkOffset = ret.pixelsChunkOffset;
			pixelsOutOfSync = pixelsChunkOffset != 0;

			if (!pixelsOutOfSync) {
				pixels = new boolean[pixelsLength];
				pixelsChunkLength = Math.min(pixelsLength - pixelsChunkOffset, 480);

				System.arraycopy(ret.pixelsChunkData, 0, pixels, 0, pixelsChunkLength);

				pixelsCurrentLength = pixelsChunkLength;

				while (pixelsCurrentLength < pixelsLength) {
					ret = readPixelsLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
					pixelsOutOfSync = ret.pixelsChunkOffset != pixelsCurrentLength;

					if (pixelsOutOfSync) {
						break;
					}

					pixelsChunkLength = Math.min(pixelsLength - ret.pixelsChunkOffset, 480);

					System.arraycopy(ret.pixelsChunkData, 0, pixels, pixelsCurrentLength, pixelsChunkLength);

					pixelsCurrentLength += pixelsChunkLength;
				}
			}

			if (pixelsOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.pixelsChunkOffset + 480 < pixelsLength) {
					ret = readPixelsLowLevel(xStart, yStart, xEnd, yEnd);
					pixelsLength = ret.pixelsLength;
				}

				throw new StreamOutOfSyncException("Pixels stream is out-of-sync");
			}
		}

		return pixels;
	}
}
