/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Measures Particulate Matter concentration (PM1.0, PM2.5 and PM10)
 */
public class BrickletParticulateMatter extends Device {
	public final static int DEVICE_IDENTIFIER = 2110;
	public final static String DEVICE_DISPLAY_NAME = "Particulate Matter Bricklet";

	public final static byte FUNCTION_GET_PM_CONCENTRATION = (byte)1;
	public final static byte FUNCTION_GET_PM_COUNT = (byte)2;
	public final static byte FUNCTION_SET_ENABLE = (byte)3;
	public final static byte FUNCTION_GET_ENABLE = (byte)4;
	public final static byte FUNCTION_GET_SENSOR_INFO = (byte)5;
	public final static byte FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_PM_CONCENTRATION = 10;
	private final static int CALLBACK_PM_COUNT = 11;

	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<PMConcentrationListener> listenerPMConcentration = new CopyOnWriteArrayList<PMConcentrationListener>();
	private List<PMCountListener> listenerPMCount = new CopyOnWriteArrayList<PMCountListener>();

	public class PMConcentration {
		public int pm10;
		public int pm25;
		public int pm100;

		public String toString() {
			return "[" + "pm10 = " + pm10 + ", " + "pm25 = " + pm25 + ", " + "pm100 = " + pm100 + "]";
		}
	}

	public class PMCount {
		public int greater03um;
		public int greater05um;
		public int greater10um;
		public int greater25um;
		public int greater50um;
		public int greater100um;

		public String toString() {
			return "[" + "greater03um = " + greater03um + ", " + "greater05um = " + greater05um + ", " + "greater10um = " + greater10um + ", " + "greater25um = " + greater25um + ", " + "greater50um = " + greater50um + ", " + "greater100um = " + greater100um + "]";
		}
	}

	public class SensorInfo {
		public int sensorVersion;
		public int lastErrorCode;
		public int framingErrorCount;
		public int checksumErrorCount;

		public String toString() {
			return "[" + "sensorVersion = " + sensorVersion + ", " + "lastErrorCode = " + lastErrorCode + ", " + "framingErrorCount = " + framingErrorCount + ", " + "checksumErrorCount = " + checksumErrorCount + "]";
		}
	}

	public class PMConcentrationCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class PMCountCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletParticulateMatter#getPMConcentration()}.
	 */
	public interface PMConcentrationListener extends DeviceListener {
		public void pmConcentration(int pm10, int pm25, int pm100);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletParticulateMatter#getPMCount()}.
	 */
	public interface PMCountListener extends DeviceListener {
		public void pmCount(int greater03um, int greater05um, int greater10um, int greater25um, int greater50um, int greater100um);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletParticulateMatter(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PM_CONCENTRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PM_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ENABLE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ENABLE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SENSOR_INFO)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_PM_CONCENTRATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 14) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int pm10 = IPConnectionBase.unsignedShort(bb.getShort());
				int pm25 = IPConnectionBase.unsignedShort(bb.getShort());
				int pm100 = IPConnectionBase.unsignedShort(bb.getShort());

				for (PMConcentrationListener listener: listenerPMConcentration) {
					listener.pmConcentration(pm10, pm25, pm100);
				}
			}
		};

		callbacks[CALLBACK_PM_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 20) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int greater03um = IPConnectionBase.unsignedShort(bb.getShort());
				int greater05um = IPConnectionBase.unsignedShort(bb.getShort());
				int greater10um = IPConnectionBase.unsignedShort(bb.getShort());
				int greater25um = IPConnectionBase.unsignedShort(bb.getShort());
				int greater50um = IPConnectionBase.unsignedShort(bb.getShort());
				int greater100um = IPConnectionBase.unsignedShort(bb.getShort());

				for (PMCountListener listener: listenerPMCount) {
					listener.pmCount(greater03um, greater05um, greater10um, greater25um, greater50um, greater100um);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the particulate matter concentration, broken down as:
	 * 
	 * * PM\ :sub:`1.0`\ ,
	 * * PM\ :sub:`2.5`\  and
	 * * PM\ :sub:`10.0`\ .
	 * 
	 * If the sensor is disabled (see {@link BrickletParticulateMatter#setEnable(boolean)}) then the last known good
	 * values from the sensor are returned.
	 * 
	 * If you want to get the values periodically, it is recommended to use the
	 * {@link BrickletParticulateMatter.PMConcentrationListener} listener. You can set the listener configuration
	 * with {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 */
	public PMConcentration getPMConcentration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_CONCENTRATION, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMConcentration obj = new PMConcentration();
		obj.pm10 = IPConnectionBase.unsignedShort(bb.getShort());
		obj.pm25 = IPConnectionBase.unsignedShort(bb.getShort());
		obj.pm100 = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the number of particulates in 100 ml of air, broken down by their
	 * diameter:
	 * 
	 * * greater 0.3µm,
	 * * greater 0.5µm,
	 * * greater 1.0µm,
	 * * greater 2.5µm,
	 * * greater 5.0µm and
	 * * greater 10.0µm.
	 * 
	 * If the sensor is disabled (see {@link BrickletParticulateMatter#setEnable(boolean)}) then the last known good
	 * value from the sensor is returned.
	 * 
	 * If you want to get the values periodically, it is recommended to use the
	 * {@link BrickletParticulateMatter.PMCountListener} listener. You can set the listener configuration
	 * with {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 */
	public PMCount getPMCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_COUNT, this);


		byte[] response = sendRequest(bb.array(), 20);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMCount obj = new PMCount();
		obj.greater03um = IPConnectionBase.unsignedShort(bb.getShort());
		obj.greater05um = IPConnectionBase.unsignedShort(bb.getShort());
		obj.greater10um = IPConnectionBase.unsignedShort(bb.getShort());
		obj.greater25um = IPConnectionBase.unsignedShort(bb.getShort());
		obj.greater50um = IPConnectionBase.unsignedShort(bb.getShort());
		obj.greater100um = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Enables/Disables the fan and the laser diode of the sensors.
	 * 
	 * The sensor takes about 30 seconds after it is enabled to settle and produce stable
	 * values.
	 * 
	 * The laser diode has a lifetime of about 8000 hours. If you want to measure in
	 * an interval with a long idle time (e.g. hourly) you should turn the
	 * laser diode off between the measurements.
	 */
	public void setEnable(boolean enable) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_ENABLE, this);

		bb.put((byte)(enable ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the state of the sensor as set by {@link BrickletParticulateMatter#setEnable(boolean)}.
	 */
	public boolean getEnable() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ENABLE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enable = (bb.get()) != 0;

		return enable;
	}

	/**
	 * Returns information about the sensor:
	 * 
	 * * the sensor version number,
	 * * the last error code reported by the sensor (0 means no error) and
	 * * the number of framing and checksum errors that occurred in the communication
	 *   with the sensor.
	 */
	public SensorInfo getSensorInfo() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SENSOR_INFO, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SensorInfo obj = new SensorInfo();
		obj.sensorVersion = IPConnectionBase.unsignedByte(bb.get());
		obj.lastErrorCode = IPConnectionBase.unsignedByte(bb.get());
		obj.framingErrorCount = IPConnectionBase.unsignedByte(bb.get());
		obj.checksumErrorCount = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletParticulateMatter.PMConcentrationListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setPMConcentrationCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_PM_CONCENTRATION_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletParticulateMatter#setPMConcentrationCallbackConfiguration(long, boolean)}.
	 */
	public PMConcentrationCallbackConfiguration getPMConcentrationCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_CONCENTRATION_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMConcentrationCallbackConfiguration obj = new PMConcentrationCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletParticulateMatter.PMCountListener} listener
	 * is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setPMCountCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_PM_COUNT_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletParticulateMatter#setPMCountCallbackConfiguration(long, boolean)}.
	 */
	public PMCountCallbackConfiguration getPMCountCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_PM_COUNT_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PMCountCallbackConfiguration obj = new PMCountCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletParticulateMatter#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletParticulateMatter#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletParticulateMatter#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletParticulateMatter#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a PMConcentration listener.
	 */
	public void addPMConcentrationListener(PMConcentrationListener listener) {
		listenerPMConcentration.add(listener);
	}

	/**
	 * Removes a PMConcentration listener.
	 */
	public void removePMConcentrationListener(PMConcentrationListener listener) {
		listenerPMConcentration.remove(listener);
	}

	/**
	 * Adds a PMCount listener.
	 */
	public void addPMCountListener(PMCountListener listener) {
		listenerPMCount.add(listener);
	}

	/**
	 * Removes a PMCount listener.
	 */
	public void removePMCountListener(PMCountListener listener) {
		listenerPMCount.remove(listener);
	}
}
