/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Communicates with RS232 devices
 */
public class BrickletRS232V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2108;
	public final static String DEVICE_DISPLAY_NAME = "RS232 Bricklet 2.0";

	public final static byte FUNCTION_WRITE_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_READ_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_ENABLE_READ_CALLBACK = (byte)3;
	public final static byte FUNCTION_DISABLE_READ_CALLBACK = (byte)4;
	public final static byte FUNCTION_IS_READ_CALLBACK_ENABLED = (byte)5;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_BUFFER_CONFIG = (byte)8;
	public final static byte FUNCTION_GET_BUFFER_CONFIG = (byte)9;
	public final static byte FUNCTION_GET_BUFFER_STATUS = (byte)10;
	public final static byte FUNCTION_GET_ERROR_COUNT = (byte)11;
	public final static byte FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION = (byte)15;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_READ_LOW_LEVEL = 12;
	private final static int CALLBACK_ERROR_COUNT = 13;
	private final static int CALLBACK_FRAME_READABLE = 16;
	private final static int CALLBACK_READ = -12;

	public final static int PARITY_NONE = 0;
	public final static int PARITY_ODD = 1;
	public final static int PARITY_EVEN = 2;
	public final static int STOPBITS_1 = 1;
	public final static int STOPBITS_2 = 2;
	public final static int WORDLENGTH_5 = 5;
	public final static int WORDLENGTH_6 = 6;
	public final static int WORDLENGTH_7 = 7;
	public final static int WORDLENGTH_8 = 8;
	public final static int FLOWCONTROL_OFF = 0;
	public final static int FLOWCONTROL_SOFTWARE = 1;
	public final static int FLOWCONTROL_HARDWARE = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<ReadLowLevelListener> listenerReadLowLevel = new CopyOnWriteArrayList<ReadLowLevelListener>();
	private List<ErrorCountListener> listenerErrorCount = new CopyOnWriteArrayList<ErrorCountListener>();
	private List<FrameReadableListener> listenerFrameReadable = new CopyOnWriteArrayList<FrameReadableListener>();
	private List<ReadListener> listenerRead = new CopyOnWriteArrayList<ReadListener>();

	public class ReadLowLevel {
		public int messageLength;
		public int messageChunkOffset;
		public char[] messageChunkData = new char[60];

		public String toString() {
			return "[" + "messageLength = " + messageLength + ", " + "messageChunkOffset = " + messageChunkOffset + ", " + "messageChunkData = " + Arrays.toString(messageChunkData) + "]";
		}
	}

	public class Configuration {
		public long baudrate;
		public int parity;
		public int stopbits;
		public int wordlength;
		public int flowcontrol;

		public String toString() {
			return "[" + "baudrate = " + baudrate + ", " + "parity = " + parity + ", " + "stopbits = " + stopbits + ", " + "wordlength = " + wordlength + ", " + "flowcontrol = " + flowcontrol + "]";
		}
	}

	public class BufferConfig {
		public int sendBufferSize;
		public int receiveBufferSize;

		public String toString() {
			return "[" + "sendBufferSize = " + sendBufferSize + ", " + "receiveBufferSize = " + receiveBufferSize + "]";
		}
	}

	public class BufferStatus {
		public int sendBufferUsed;
		public int receiveBufferUsed;

		public String toString() {
			return "[" + "sendBufferUsed = " + sendBufferUsed + ", " + "receiveBufferUsed = " + receiveBufferUsed + "]";
		}
	}

	public class ErrorCount {
		public long errorCountOverrun;
		public long errorCountParity;

		public String toString() {
			return "[" + "errorCountOverrun = " + errorCountOverrun + ", " + "errorCountParity = " + errorCountParity + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * @see ReadListener
	 */
	public interface ReadLowLevelListener extends DeviceListener {
		public void readLowLevel(int messageLength, int messageChunkOffset, char[] messageChunkData);
	}

	/**
	 * This listener is called if a new error occurs. It returns
	 * the current overrun and parity error count.
	 */
	public interface ErrorCountListener extends DeviceListener {
		public void errorCount(long errorCountOverrun, long errorCountParity);
	}

	/**
	 * This listener is called if at least one frame of data is readable. The frame size is configured with {@link BrickletRS232V2#setFrameReadableCallbackConfiguration(int)}.
	 * The frame count parameter is the number of frames that can be read.
	 * This listener is triggered only once until {@link BrickletRS232V2#read(int)} is called. This means, that if you have configured a frame size of X bytes,
	 * you can read exactly X bytes using the {@link BrickletRS232V2#read(int)} function, every time the listener triggers without checking the frame count parameter.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public interface FrameReadableListener extends DeviceListener {
		public void frameReadable(int frameCount);
	}

	/**
	 * This listener is called if new data is available.
	 * 
	 * To enable this listener, use {@link BrickletRS232V2#enableReadCallback()}.
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for message.
	 */
	public interface ReadListener extends DeviceListener {
		public void read(char[] message);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRS232V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE_READ_CALLBACK)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE_READ_CALLBACK)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_READ_CALLBACK_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BUFFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BUFFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BUFFER_STATUS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		highLevelCallbacks[-CALLBACK_READ] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_READ_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 72) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int messageLength = IPConnectionBase.unsignedShort(bb.getShort());
				int messageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
				char[] messageChunkData = new char[60];
				for (int i = 0; i < 60; i++) {
					messageChunkData[i] = (char)(bb.get());
				}

				IPConnectionBase.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_READ];
				int messageChunkLength = Math.min(messageLength - messageChunkOffset, 60);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (messageChunkOffset == 0) { // stream starts
						highLevelCallback.data = new char[messageLength];
						highLevelCallback.length = messageChunkLength;

						System.arraycopy(messageChunkData, 0, (char[])highLevelCallback.data, 0, messageChunkLength);

						if (highLevelCallback.length >= messageLength) { // stream complete
							for (ReadListener listener: listenerRead) {
								listener.read((char[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (messageChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (ReadListener listener: listenerRead) {
							listener.read((char[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(messageChunkData, 0, (char[])highLevelCallback.data, highLevelCallback.length, messageChunkLength);
						highLevelCallback.length += messageChunkLength;

						if (highLevelCallback.length >= messageLength) { // stream complete
							for (ReadListener listener: listenerRead) {
								listener.read((char[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (ReadLowLevelListener listener: listenerReadLowLevel) {
					listener.readLowLevel(messageLength, messageChunkOffset, messageChunkData);
				}
			}
		};

		callbacks[CALLBACK_ERROR_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 16) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long errorCountOverrun = IPConnectionBase.unsignedInt(bb.getInt());
				long errorCountParity = IPConnectionBase.unsignedInt(bb.getInt());

				for (ErrorCountListener listener: listenerErrorCount) {
					listener.errorCount(errorCountOverrun, errorCountParity);
				}
			}
		};

		callbacks[CALLBACK_FRAME_READABLE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int frameCount = IPConnectionBase.unsignedShort(bb.getShort());

				for (FrameReadableListener listener: listenerFrameReadable) {
					listener.frameReadable(frameCount);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Writes characters to the RS232 interface. The characters can be binary data,
	 * ASCII or similar is not necessary.
	 * 
	 * The return value is the number of characters that were written.
	 * 
	 * See {@link BrickletRS232V2#setConfiguration(long, int, int, int, int)} for configuration possibilities
	 * regarding baud rate, parity and so on.
	 */
	public int writeLowLevel(int messageLength, int messageChunkOffset, char[] messageChunkData) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_LOW_LEVEL, this);

		bb.putShort((short)messageLength);
		bb.putShort((short)messageChunkOffset);
		for (int i = 0; i < 60; i++) {
			bb.put((byte)messageChunkData[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int messageChunkWritten = IPConnectionBase.unsignedByte(bb.get());

		return messageChunkWritten;
	}

	/**
	 * Returns up to *length* characters from receive buffer.
	 * 
	 * Instead of polling with this function, you can also use
	 * callbacks. But note that this function will return available
	 * data only when the read listener is disabled.
	 * See {@link BrickletRS232V2#enableReadCallback()} and {@link BrickletRS232V2.ReadListener} listener.
	 */
	public ReadLowLevel readLowLevel(int length) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_READ_LOW_LEVEL, this);

		bb.putShort((short)length);

		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadLowLevel obj = new ReadLowLevel();
		obj.messageLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.messageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 60; i++) {
			obj.messageChunkData[i] = (char)(bb.get());
		}

		return obj;
	}

	/**
	 * Enables the {@link BrickletRS232V2.ReadListener} listener. This will disable the {@link BrickletRS232V2.FrameReadableListener} listener.
	 * 
	 * By default the listener is disabled.
	 */
	public void enableReadCallback() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE_READ_CALLBACK, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the {@link BrickletRS232V2.ReadListener} listener.
	 * 
	 * By default the listener is disabled.
	 */
	public void disableReadCallback() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE_READ_CALLBACK, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the {@link BrickletRS232V2.ReadListener} listener is enabled,
	 * *false* otherwise.
	 */
	public boolean isReadCallbackEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_READ_CALLBACK_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Sets the configuration for the RS232 communication.
	 */
	public void setConfiguration(long baudrate, int parity, int stopbits, int wordlength, int flowcontrol) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_CONFIGURATION, this);

		bb.putInt((int)baudrate);
		bb.put((byte)parity);
		bb.put((byte)stopbits);
		bb.put((byte)wordlength);
		bb.put((byte)flowcontrol);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletRS232V2#setConfiguration(long, int, int, int, int)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 16);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.baudrate = IPConnectionBase.unsignedInt(bb.getInt());
		obj.parity = IPConnectionBase.unsignedByte(bb.get());
		obj.stopbits = IPConnectionBase.unsignedByte(bb.get());
		obj.wordlength = IPConnectionBase.unsignedByte(bb.get());
		obj.flowcontrol = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets the send and receive buffer size in byte. In total the buffers have to be
	 * 10240 byte (10KiB) in size, the minimum buffer size is 1024 byte (1KiB) for each.
	 * 
	 * The current buffer content is lost if this function is called.
	 * 
	 * The send buffer holds data that is given by {@link BrickletRS232V2#write(char[])} and
	 * can not be written yet. The receive buffer holds data that is
	 * received through RS232 but could not yet be send to the
	 * user, either by {@link BrickletRS232V2#read(int)} or through {@link BrickletRS232V2.ReadListener} listener.
	 */
	public void setBufferConfig(int sendBufferSize, int receiveBufferSize) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_BUFFER_CONFIG, this);

		bb.putShort((short)sendBufferSize);
		bb.putShort((short)receiveBufferSize);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the buffer configuration as set by {@link BrickletRS232V2#setBufferConfig(int, int)}.
	 */
	public BufferConfig getBufferConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BUFFER_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		BufferConfig obj = new BufferConfig();
		obj.sendBufferSize = IPConnectionBase.unsignedShort(bb.getShort());
		obj.receiveBufferSize = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the currently used bytes for the send and received buffer.
	 * 
	 * See {@link BrickletRS232V2#setBufferConfig(int, int)} for buffer size configuration.
	 */
	public BufferStatus getBufferStatus() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BUFFER_STATUS, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		BufferStatus obj = new BufferStatus();
		obj.sendBufferUsed = IPConnectionBase.unsignedShort(bb.getShort());
		obj.receiveBufferUsed = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current number of overrun and parity errors.
	 */
	public ErrorCount getErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 16);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ErrorCount obj = new ErrorCount();
		obj.errorCountOverrun = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountParity = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Configures the {@link BrickletRS232V2.FrameReadableListener} listener. The frame size is the number of bytes, that have to be readable to trigger the listener.
	 * A frame size of 0 disables the listener. A frame size greater than 0 enables the listener and disables the {@link BrickletRS232V2.ReadListener} listener.
	 * 
	 * By default the listener is disabled.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public void setFrameReadableCallbackConfiguration(int frameSize) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION, this);

		bb.putShort((short)frameSize);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletRS232V2#setFrameReadableCallbackConfiguration(int)}.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public int getFrameReadableCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int frameSize = IPConnectionBase.unsignedShort(bb.getShort());

		return frameSize;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletRS232V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletRS232V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletRS232V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletRS232V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Writes characters to the RS232 interface. The characters can be binary data,
	 * ASCII or similar is not necessary.
	 * 
	 * The return value is the number of characters that were written.
	 * 
	 * See {@link BrickletRS232V2#setConfiguration(long, int, int, int, int)} for configuration possibilities
	 * regarding baud rate, parity and so on.
	 */
	public int write(char[] message) throws TinkerforgeException {
		if (message.length > 65535) {
			throw new IllegalArgumentException("Message can be at most 65535 items long");
		}

		int ret;
		int messageLength = message.length;
		int messageChunkOffset = 0;
		char[] messageChunkData = new char[60];
		int messageChunkLength;
		int messageWritten;

		if (messageLength == 0) {
			Arrays.fill(messageChunkData, '\0');

			ret = writeLowLevel(messageLength, messageChunkOffset, messageChunkData);
			messageWritten = ret;
		} else {
			messageWritten = 0;

			synchronized (streamMutex) {
				while (messageChunkOffset < messageLength) {
					messageChunkLength = Math.min(messageLength - messageChunkOffset, 60);

					System.arraycopy(message, messageChunkOffset, messageChunkData, 0, messageChunkLength);
					Arrays.fill(messageChunkData, messageChunkLength, 60, '\0');

					ret = writeLowLevel(messageLength, messageChunkOffset, messageChunkData);
					messageWritten += ret;

					if (ret < 60) {
						break; // either last chunk or short write
					}

					messageChunkOffset += 60;
				}
			}
		}

		return messageWritten;
	}

	/**
	 * Returns up to *length* characters from receive buffer.
	 * 
	 * Instead of polling with this function, you can also use
	 * callbacks. But note that this function will return available
	 * data only when the read listener is disabled.
	 * See {@link BrickletRS232V2#enableReadCallback()} and {@link BrickletRS232V2.ReadListener} listener.
	 */
	public char[] read(int length) throws TinkerforgeException {
		ReadLowLevel ret;
		char[] message = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int messageLength;
		int messageChunkOffset;
		int messageChunkLength;
		boolean messageOutOfSync;
		int messageCurrentLength;

		synchronized (streamMutex) {
			ret = readLowLevel(length);
			messageLength = ret.messageLength;
			messageChunkOffset = ret.messageChunkOffset;
			messageOutOfSync = messageChunkOffset != 0;

			if (!messageOutOfSync) {
				message = new char[messageLength];
				messageChunkLength = Math.min(messageLength - messageChunkOffset, 60);

				System.arraycopy(ret.messageChunkData, 0, message, 0, messageChunkLength);

				messageCurrentLength = messageChunkLength;

				while (messageCurrentLength < messageLength) {
					ret = readLowLevel(length);
					messageLength = ret.messageLength;
					messageOutOfSync = ret.messageChunkOffset != messageCurrentLength;

					if (messageOutOfSync) {
						break;
					}

					messageChunkLength = Math.min(messageLength - ret.messageChunkOffset, 60);

					System.arraycopy(ret.messageChunkData, 0, message, messageCurrentLength, messageChunkLength);

					messageCurrentLength += messageChunkLength;
				}
			}

			if (messageOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.messageChunkOffset + 60 < messageLength) {
					ret = readLowLevel(length);
					messageLength = ret.messageLength;
				}

				throw new StreamOutOfSyncException("Message stream is out-of-sync");
			}
		}

		return message;
	}

	/**
	 * Adds a ReadLowLevel listener.
	 */
	public void addReadLowLevelListener(ReadLowLevelListener listener) {
		listenerReadLowLevel.add(listener);
	}

	/**
	 * Removes a ReadLowLevel listener.
	 */
	public void removeReadLowLevelListener(ReadLowLevelListener listener) {
		listenerReadLowLevel.remove(listener);
	}

	/**
	 * Adds a ErrorCount listener.
	 */
	public void addErrorCountListener(ErrorCountListener listener) {
		listenerErrorCount.add(listener);
	}

	/**
	 * Removes a ErrorCount listener.
	 */
	public void removeErrorCountListener(ErrorCountListener listener) {
		listenerErrorCount.remove(listener);
	}

	/**
	 * Adds a FrameReadable listener.
	 */
	public void addFrameReadableListener(FrameReadableListener listener) {
		listenerFrameReadable.add(listener);
	}

	/**
	 * Removes a FrameReadable listener.
	 */
	public void removeFrameReadableListener(FrameReadableListener listener) {
		listenerFrameReadable.remove(listener);
	}

	/**
	 * Adds a Read listener.
	 */
	public void addReadListener(ReadListener listener) {
		listenerRead.add(listener);
	}

	/**
	 * Removes a Read listener.
	 */
	public void removeReadListener(ReadListener listener) {
		listenerRead.remove(listener);
	}
}
