/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Four 7-segment displays with switchable dots
 */
public class BrickletSegmentDisplay4x7V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2137;
	public final static String DEVICE_DISPLAY_NAME = "Segment Display 4x7 Bricklet 2.0";

	public final static byte FUNCTION_SET_SEGMENTS = (byte)1;
	public final static byte FUNCTION_GET_SEGMENTS = (byte)2;
	public final static byte FUNCTION_SET_BRIGHTNESS = (byte)3;
	public final static byte FUNCTION_GET_BRIGHTNESS = (byte)4;
	public final static byte FUNCTION_SET_NUMERIC_VALUE = (byte)5;
	public final static byte FUNCTION_SET_SELECTED_SEGMENT = (byte)6;
	public final static byte FUNCTION_GET_SELECTED_SEGMENT = (byte)7;
	public final static byte FUNCTION_START_COUNTER = (byte)8;
	public final static byte FUNCTION_GET_COUNTER_VALUE = (byte)9;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COUNTER_FINISHED = 10;

	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<CounterFinishedListener> listenerCounterFinished = new CopyOnWriteArrayList<CounterFinishedListener>();

	public class Segments {
		public boolean[] digit0 = new boolean[8];
		public boolean[] digit1 = new boolean[8];
		public boolean[] digit2 = new boolean[8];
		public boolean[] digit3 = new boolean[8];
		public boolean[] colon = new boolean[2];
		public boolean tick;

		public String toString() {
			return "[" + "digit0 = " + Arrays.toString(digit0) + ", " + "digit1 = " + Arrays.toString(digit1) + ", " + "digit2 = " + Arrays.toString(digit2) + ", " + "digit3 = " + Arrays.toString(digit3) + ", " + "colon = " + Arrays.toString(colon) + ", " + "tick = " + tick + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered when the counter (see {@link BrickletSegmentDisplay4x7V2#startCounter(int, int, int, long)}) is
	 * finished.
	 */
	public interface CounterFinishedListener extends DeviceListener {
		public void counterFinished();
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletSegmentDisplay4x7V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SEGMENTS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SEGMENTS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BRIGHTNESS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BRIGHTNESS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_NUMERIC_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SELECTED_SEGMENT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SELECTED_SEGMENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_START_COUNTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_COUNTER_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COUNTER_FINISHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 8) {
					return; // silently ignoring callback with wrong length
				}

				for (CounterFinishedListener listener: listenerCounterFinished) {
					listener.counterFinished();
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the segments of the Segment Display 4x7 Bricklet 2.0 segment-by-segment.
	 * 
	 * The data is split into the four digits, two colon dots and the tick mark.
	 * 
	 * The indices of the segments in the digit and colon parameters are as follows:
	 * 
	 * .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_segment_index.png
	 *    :scale: 100 %
	 *    :alt: Indices of segments
	 *    :align: center
	 */
	public void setSegments(boolean[] digit0, boolean[] digit1, boolean[] digit2, boolean[] digit3, boolean[] colon, boolean tick) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_SEGMENTS, this);


		byte[] digit0Bits = new byte[1];
		Arrays.fill(digit0Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit0[i]) {
				digit0Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit0Bits[i]);
		}

		byte[] digit1Bits = new byte[1];
		Arrays.fill(digit1Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit1[i]) {
				digit1Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit1Bits[i]);
		}

		byte[] digit2Bits = new byte[1];
		Arrays.fill(digit2Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit2[i]) {
				digit2Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit2Bits[i]);
		}

		byte[] digit3Bits = new byte[1];
		Arrays.fill(digit3Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit3[i]) {
				digit3Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit3Bits[i]);
		}

		byte[] colonBits = new byte[1];
		Arrays.fill(colonBits, (byte)0);

		for (int i = 0; i < 2; i++) {
			if (colon[i]) {
				colonBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(colonBits[i]);
		}
		bb.put((byte)(tick ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the segment data as set by {@link BrickletSegmentDisplay4x7V2#setSegments(boolean[], boolean[], boolean[], boolean[], boolean[], boolean)}.
	 */
	public Segments getSegments() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SEGMENTS, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Segments obj = new Segments();
		byte[] digit0Bits = new byte[1];
		bb.get(digit0Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit0[i] = (digit0Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit1Bits = new byte[1];
		bb.get(digit1Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit1[i] = (digit1Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit2Bits = new byte[1];
		bb.get(digit2Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit2[i] = (digit2Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit3Bits = new byte[1];
		bb.get(digit3Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit3[i] = (digit3Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] colonBits = new byte[1];
		bb.get(colonBits);
		for (int i = 0; i < 2; i++) {
			obj.colon[i] = (colonBits[i / 8] & (1 << (i % 8))) != 0;
		}

		obj.tick = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The brightness can be set between 0 (dark) and 7 (bright).
	 */
	public void setBrightness(int brightness) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BRIGHTNESS, this);

		bb.put((byte)brightness);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the brightness as set by {@link BrickletSegmentDisplay4x7V2#setBrightness(int)}.
	 */
	public int getBrightness() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BRIGHTNESS, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int brightness = IPConnectionBase.unsignedByte(bb.get());

		return brightness;
	}

	/**
	 * Sets a numeric value for each of the digits. They represent:
	 * 
	 * * -2: minus sign
	 * * -1: blank
	 * * 0-9: 0-9
	 * * 10: A
	 * * 11: b
	 * * 12: C
	 * * 13: d
	 * * 14: E
	 * * 15: F
	 * 
	 * Example: A call with [-2, -1, 4, 2] will result in a display of "- 42".
	 */
	public void setNumericValue(int[] value) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_NUMERIC_VALUE, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)value[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Turns one specified segment on or off.
	 * 
	 * The indices of the segments are as follows:
	 * 
	 * .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_selected_segment_index.png
	 *    :scale: 100 %
	 *    :alt: Indices of selected segments
	 *    :align: center
	 */
	public void setSelectedSegment(int segment, boolean value) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_SEGMENT, this);

		bb.put((byte)segment);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the value of a single segment.
	 */
	public boolean getSelectedSegment(int segment) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SELECTED_SEGMENT, this);

		bb.put((byte)segment);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean value = (bb.get()) != 0;

		return value;
	}

	/**
	 * Starts a counter with the *from* value that counts to the *to*
	 * value with the each step incremented by *increment*.
	 * *length* is the pause between each increment.
	 * 
	 * Example: If you set *from* to 0, *to* to 100, *increment* to 1 and
	 * *length* to 1000, a counter that goes from 0 to 100 with one second
	 * pause between each increment will be started.
	 * 
	 * Using a negative *increment* allows to count backwards.
	 * 
	 * You can stop the counter at every time by calling {@link BrickletSegmentDisplay4x7V2#setSegments(boolean[], boolean[], boolean[], boolean[], boolean[], boolean)}
	 * or {@link BrickletSegmentDisplay4x7V2#setNumericValue(int[])}.
	 */
	public void startCounter(int valueFrom, int valueTo, int increment, long length) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_START_COUNTER, this);

		bb.putShort((short)valueFrom);
		bb.putShort((short)valueTo);
		bb.putShort((short)increment);
		bb.putInt((int)length);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the counter value that is currently shown on the display.
	 * 
	 * If there is no counter running a 0 will be returned.
	 */
	public int getCounterValue() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COUNTER_VALUE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int value = IPConnectionBase.unsignedShort(bb.getShort());

		return value;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletSegmentDisplay4x7V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletSegmentDisplay4x7V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletSegmentDisplay4x7V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletSegmentDisplay4x7V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a CounterFinished listener.
	 */
	public void addCounterFinishedListener(CounterFinishedListener listener) {
		listenerCounterFinished.add(listener);
	}

	/**
	 * Removes a CounterFinished listener.
	 */
	public void removeCounterFinishedListener(CounterFinishedListener listener) {
		listenerCounterFinished.remove(listener);
	}
}
