/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Measures Sound Pressure Level in dB(A/B/C/D/Z)
 */
public class BrickletSoundPressureLevel extends Device {
	public final static int DEVICE_IDENTIFIER = 290;
	public final static String DEVICE_DISPLAY_NAME = "Sound Pressure Level Bricklet";

	public final static byte FUNCTION_GET_DECIBEL = (byte)1;
	public final static byte FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_SPECTRUM_LOW_LEVEL = (byte)5;
	public final static byte FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_DECIBEL = 4;
	private final static int CALLBACK_SPECTRUM_LOW_LEVEL = 8;
	private final static int CALLBACK_SPECTRUM = -8;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int FFT_SIZE_128 = 0;
	public final static int FFT_SIZE_256 = 1;
	public final static int FFT_SIZE_512 = 2;
	public final static int FFT_SIZE_1024 = 3;
	public final static int WEIGHTING_A = 0;
	public final static int WEIGHTING_B = 1;
	public final static int WEIGHTING_C = 2;
	public final static int WEIGHTING_D = 3;
	public final static int WEIGHTING_Z = 4;
	public final static int WEIGHTING_ITU_R_468 = 5;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<DecibelListener> listenerDecibel = new CopyOnWriteArrayList<DecibelListener>();
	private List<SpectrumLowLevelListener> listenerSpectrumLowLevel = new CopyOnWriteArrayList<SpectrumLowLevelListener>();
	private List<SpectrumListener> listenerSpectrum = new CopyOnWriteArrayList<SpectrumListener>();

	public class DecibelCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class SpectrumLowLevel {
		public int spectrumLength;
		public int spectrumChunkOffset;
		public int[] spectrumChunkData = new int[30];

		public String toString() {
			return "[" + "spectrumLength = " + spectrumLength + ", " + "spectrumChunkOffset = " + spectrumChunkOffset + ", " + "spectrumChunkData = " + Arrays.toString(spectrumChunkData) + "]";
		}
	}

	public class Configuration {
		public int fftSize;
		public int weighting;

		public String toString() {
			return "[" + "fftSize = " + fftSize + ", " + "weighting = " + weighting + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletSoundPressureLevel#setDecibelCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletSoundPressureLevel#getDecibel()}.
	 */
	public interface DecibelListener extends DeviceListener {
		public void decibel(int decibel);
	}

	/**
	 * @see SpectrumListener
	 */
	public interface SpectrumLowLevelListener extends DeviceListener {
		public void spectrumLowLevel(int spectrumLength, int spectrumChunkOffset, int[] spectrumChunkData);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletSoundPressureLevel#setSpectrumCallbackConfiguration(long)}.
	 * 
	 * The parameter is the same as {@link BrickletSoundPressureLevel#getSpectrum()}.
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for spectrum.
	 */
	public interface SpectrumListener extends DeviceListener {
		public void spectrum(int[] spectrum);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletSoundPressureLevel(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DECIBEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPECTRUM_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_DECIBEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int decibel = IPConnectionBase.unsignedShort(bb.getShort());

				for (DecibelListener listener: listenerDecibel) {
					listener.decibel(decibel);
				}
			}
		};

		highLevelCallbacks[-CALLBACK_SPECTRUM] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_SPECTRUM_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 72) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int spectrumLength = IPConnectionBase.unsignedShort(bb.getShort());
				int spectrumChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
				int[] spectrumChunkData = new int[30];
				for (int i = 0; i < 30; i++) {
					spectrumChunkData[i] = IPConnectionBase.unsignedShort(bb.getShort());
				}

				IPConnectionBase.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_SPECTRUM];
				int spectrumChunkLength = Math.min(spectrumLength - spectrumChunkOffset, 30);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (spectrumChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[spectrumLength];
						highLevelCallback.length = spectrumChunkLength;

						System.arraycopy(spectrumChunkData, 0, (int[])highLevelCallback.data, 0, spectrumChunkLength);

						if (highLevelCallback.length >= spectrumLength) { // stream complete
							for (SpectrumListener listener: listenerSpectrum) {
								listener.spectrum((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (spectrumChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (SpectrumListener listener: listenerSpectrum) {
							listener.spectrum((int[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(spectrumChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, spectrumChunkLength);
						highLevelCallback.length += spectrumChunkLength;

						if (highLevelCallback.length >= spectrumLength) { // stream complete
							for (SpectrumListener listener: listenerSpectrum) {
								listener.spectrum((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (SpectrumLowLevelListener listener: listenerSpectrumLowLevel) {
					listener.spectrumLowLevel(spectrumLength, spectrumChunkOffset, spectrumChunkData);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the measured sound pressure in decibels.
	 * 
	 * The Bricklet supports the weighting standards dB(A), dB(B), dB(C), dB(D),
	 * dB(Z) and ITU-R 468. You can configure the weighting with {@link BrickletSoundPressureLevel#setConfiguration(int, int)}.
	 * 
	 * By default dB(A) will be used.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletSoundPressureLevel.DecibelListener} listener. You can set the listener configuration
	 * with {@link BrickletSoundPressureLevel#setDecibelCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getDecibel() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DECIBEL, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int decibel = IPConnectionBase.unsignedShort(bb.getShort());

		return decibel;
	}

	/**
	 * The period is the period with which the {@link BrickletSoundPressureLevel.DecibelListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletSoundPressureLevel.DecibelListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setDecibelCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_SET_DECIBEL_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putShort((short)min);
		bb.putShort((short)max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletSoundPressureLevel#setDecibelCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public DecibelCallbackConfiguration getDecibelCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DECIBEL_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 18);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DecibelCallbackConfiguration obj = new DecibelCallbackConfiguration();
		obj.period = IPConnectionBase.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = IPConnectionBase.unsignedShort(bb.getShort());
		obj.max = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the frequency spectrum. The length of the spectrum is between
	 * 512 (FFT size 1024) and 64 (FFT size 128). See {@link BrickletSoundPressureLevel#setConfiguration(int, int)}.
	 * 
	 * Each array element is one bin of the FFT. The first bin is always the
	 * DC offset and the other bins have a size between 40Hz (FFT size 1024) and
	 * 320Hz (FFT size 128).
	 * 
	 * In sum the frequency of the spectrum always has a range from 0 to
	 * 20480Hz (the FFT is applied to samples with a frequency of 40960Hz).
	 * 
	 * The returned data is already equalized, which means that the microphone
	 * frequency response is compensated and the weighting function is applied
	 * (see {@link BrickletSoundPressureLevel#setConfiguration(int, int)} for the available weighting standards). Use
	 * dB(Z) if you need the unaltered spectrum.
	 * 
	 * The values are not in dB form yet. If you want a proper dB scale of the
	 * spectrum you have to apply the formula f(x) = 20*log10(max(1, x/sqrt(2)))
	 * on each value.
	 */
	public SpectrumLowLevel getSpectrumLowLevel() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPECTRUM_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SpectrumLowLevel obj = new SpectrumLowLevel();
		obj.spectrumLength = IPConnectionBase.unsignedShort(bb.getShort());
		obj.spectrumChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 30; i++) {
			obj.spectrumChunkData[i] = IPConnectionBase.unsignedShort(bb.getShort());
		}

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletSoundPressureLevel.SpectrumListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * Every new measured spectrum will be send at most once. Set the period to 1 to
	 * make sure that you get every spectrum.
	 */
	public void setSpectrumCallbackConfiguration(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SPECTRUM_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletSoundPressureLevel#getSpectrumCallbackConfiguration()}.
	 */
	public long getSpectrumCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPECTRUM_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the Sound Pressure Level Bricklet configuration.
	 * 
	 * With different FFT sizes the Bricklet has a different
	 * amount of samples per second and the size of the FFT bins
	 * changes. The higher the FFT size the more precise is the result
	 * of the dB(X) calculation.
	 * 
	 * Available FFT sizes are:
	 * 
	 * * 1024: 512 bins, 10 samples per second, each bin has size 40Hz
	 * * 512: 256 bins, 20 samples per second, each bin has size 80Hz
	 * * 256: 128 bins, 40 samples per second, each bin has size 160Hz
	 * * 128: 64 bins, 80 samples per second, each bin has size 320Hz
	 * 
	 * The Bricklet supports different weighting functions. You can choose
	 * between dB(A), dB(B), dB(C), dB(D), dB(Z) and ITU-R 468.
	 * 
	 * dB(A/B/C/D) are the standard dB weighting curves. dB(A) is
	 * often used to measure volumes at concerts etc. dB(Z) has a
	 * flat response, no weighting is applied. ITU-R 468 is an ITU
	 * weighting standard mostly used in the UK and Europe.
	 */
	public void setConfiguration(int fftSize, int weighting) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)fftSize);
		bb.put((byte)weighting);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletSoundPressureLevel#setConfiguration(int, int)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.fftSize = IPConnectionBase.unsignedByte(bb.get());
		obj.weighting = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletSoundPressureLevel#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletSoundPressureLevel#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletSoundPressureLevel#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletSoundPressureLevel#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the frequency spectrum. The length of the spectrum is between
	 * 512 (FFT size 1024) and 64 (FFT size 128). See {@link BrickletSoundPressureLevel#setConfiguration(int, int)}.
	 * 
	 * Each array element is one bin of the FFT. The first bin is always the
	 * DC offset and the other bins have a size between 40Hz (FFT size 1024) and
	 * 320Hz (FFT size 128).
	 * 
	 * In sum the frequency of the spectrum always has a range from 0 to
	 * 20480Hz (the FFT is applied to samples with a frequency of 40960Hz).
	 * 
	 * The returned data is already equalized, which means that the microphone
	 * frequency response is compensated and the weighting function is applied
	 * (see {@link BrickletSoundPressureLevel#setConfiguration(int, int)} for the available weighting standards). Use
	 * dB(Z) if you need the unaltered spectrum.
	 * 
	 * The values are not in dB form yet. If you want a proper dB scale of the
	 * spectrum you have to apply the formula f(x) = 20*log10(max(1, x/sqrt(2)))
	 * on each value.
	 */
	public int[] getSpectrum() throws TinkerforgeException {
		SpectrumLowLevel ret;
		int[] spectrum = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int spectrumLength;
		int spectrumChunkOffset;
		int spectrumChunkLength;
		boolean spectrumOutOfSync;
		int spectrumCurrentLength;

		synchronized (streamMutex) {
			ret = getSpectrumLowLevel();
			spectrumLength = ret.spectrumLength;
			spectrumChunkOffset = ret.spectrumChunkOffset;
			spectrumOutOfSync = spectrumChunkOffset != 0;

			if (!spectrumOutOfSync) {
				spectrum = new int[spectrumLength];
				spectrumChunkLength = Math.min(spectrumLength - spectrumChunkOffset, 30);

				System.arraycopy(ret.spectrumChunkData, 0, spectrum, 0, spectrumChunkLength);

				spectrumCurrentLength = spectrumChunkLength;

				while (spectrumCurrentLength < spectrumLength) {
					ret = getSpectrumLowLevel();
					spectrumLength = ret.spectrumLength;
					spectrumOutOfSync = ret.spectrumChunkOffset != spectrumCurrentLength;

					if (spectrumOutOfSync) {
						break;
					}

					spectrumChunkLength = Math.min(spectrumLength - ret.spectrumChunkOffset, 30);

					System.arraycopy(ret.spectrumChunkData, 0, spectrum, spectrumCurrentLength, spectrumChunkLength);

					spectrumCurrentLength += spectrumChunkLength;
				}
			}

			if (spectrumOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.spectrumChunkOffset + 30 < spectrumLength) {
					ret = getSpectrumLowLevel();
					spectrumLength = ret.spectrumLength;
				}

				throw new StreamOutOfSyncException("Spectrum stream is out-of-sync");
			}
		}

		return spectrum;
	}

	/**
	 * Adds a Decibel listener.
	 */
	public void addDecibelListener(DecibelListener listener) {
		listenerDecibel.add(listener);
	}

	/**
	 * Removes a Decibel listener.
	 */
	public void removeDecibelListener(DecibelListener listener) {
		listenerDecibel.remove(listener);
	}

	/**
	 * Adds a SpectrumLowLevel listener.
	 */
	public void addSpectrumLowLevelListener(SpectrumLowLevelListener listener) {
		listenerSpectrumLowLevel.add(listener);
	}

	/**
	 * Removes a SpectrumLowLevel listener.
	 */
	public void removeSpectrumLowLevelListener(SpectrumLowLevelListener listener) {
		listenerSpectrumLowLevel.remove(listener);
	}

	/**
	 * Adds a Spectrum listener.
	 */
	public void addSpectrumListener(SpectrumListener listener) {
		listenerSpectrum.add(listener);
	}

	/**
	 * Removes a Spectrum listener.
	 */
	public void removeSpectrumListener(SpectrumListener listener) {
		listenerSpectrum.remove(listener);
	}
}
