/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Java Bindings Version 2.1.31                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 80x60 pixel thermal imaging camera
 */
public class BrickletThermalImaging extends Device {
	public final static int DEVICE_IDENTIFIER = 278;
	public final static String DEVICE_DISPLAY_NAME = "Thermal Imaging Bricklet";

	public final static byte FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_GET_STATISTICS = (byte)3;
	public final static byte FUNCTION_SET_RESOLUTION = (byte)4;
	public final static byte FUNCTION_GET_RESOLUTION = (byte)5;
	public final static byte FUNCTION_SET_SPOTMETER_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_SPOTMETER_CONFIG = (byte)7;
	public final static byte FUNCTION_SET_HIGH_CONTRAST_CONFIG = (byte)8;
	public final static byte FUNCTION_GET_HIGH_CONTRAST_CONFIG = (byte)9;
	public final static byte FUNCTION_SET_IMAGE_TRANSFER_CONFIG = (byte)10;
	public final static byte FUNCTION_GET_IMAGE_TRANSFER_CONFIG = (byte)11;
	public final static byte FUNCTION_SET_FLUX_LINEAR_PARAMETERS = (byte)14;
	public final static byte FUNCTION_GET_FLUX_LINEAR_PARAMETERS = (byte)15;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_HIGH_CONTRAST_IMAGE_LOW_LEVEL = 12;
	private final static int CALLBACK_TEMPERATURE_IMAGE_LOW_LEVEL = 13;
	private final static int CALLBACK_HIGH_CONTRAST_IMAGE = -12;
	private final static int CALLBACK_TEMPERATURE_IMAGE = -13;

	public final static int RESOLUTION_0_TO_6553_KELVIN = 0;
	public final static int RESOLUTION_0_TO_655_KELVIN = 1;
	public final static int FFC_STATUS_NEVER_COMMANDED = 0;
	public final static int FFC_STATUS_IMMINENT = 1;
	public final static int FFC_STATUS_IN_PROGRESS = 2;
	public final static int FFC_STATUS_COMPLETE = 3;
	public final static int IMAGE_TRANSFER_MANUAL_HIGH_CONTRAST_IMAGE = 0;
	public final static int IMAGE_TRANSFER_MANUAL_TEMPERATURE_IMAGE = 1;
	public final static int IMAGE_TRANSFER_CALLBACK_HIGH_CONTRAST_IMAGE = 2;
	public final static int IMAGE_TRANSFER_CALLBACK_TEMPERATURE_IMAGE = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<HighContrastImageLowLevelListener> listenerHighContrastImageLowLevel = new CopyOnWriteArrayList<HighContrastImageLowLevelListener>();
	private List<TemperatureImageLowLevelListener> listenerTemperatureImageLowLevel = new CopyOnWriteArrayList<TemperatureImageLowLevelListener>();
	private List<HighContrastImageListener> listenerHighContrastImage = new CopyOnWriteArrayList<HighContrastImageListener>();
	private List<TemperatureImageListener> listenerTemperatureImage = new CopyOnWriteArrayList<TemperatureImageListener>();

	public class HighContrastImageLowLevel {
		public int imageChunkOffset;
		public int[] imageChunkData = new int[62];

		public String toString() {
			return "[" + "imageChunkOffset = " + imageChunkOffset + ", " + "imageChunkData = " + Arrays.toString(imageChunkData) + "]";
		}
	}

	public class TemperatureImageLowLevel {
		public int imageChunkOffset;
		public int[] imageChunkData = new int[31];

		public String toString() {
			return "[" + "imageChunkOffset = " + imageChunkOffset + ", " + "imageChunkData = " + Arrays.toString(imageChunkData) + "]";
		}
	}

	public class Statistics {
		public int[] spotmeterStatistics = new int[4];
		public int[] temperatures = new int[4];
		public int resolution;
		public int ffcStatus;
		public boolean[] temperatureWarning = new boolean[2];

		public String toString() {
			return "[" + "spotmeterStatistics = " + Arrays.toString(spotmeterStatistics) + ", " + "temperatures = " + Arrays.toString(temperatures) + ", " + "resolution = " + resolution + ", " + "ffcStatus = " + ffcStatus + ", " + "temperatureWarning = " + Arrays.toString(temperatureWarning) + "]";
		}
	}

	public class HighContrastConfig {
		public int[] regionOfInterest = new int[4];
		public int dampeningFactor;
		public int[] clipLimit = new int[2];
		public int emptyCounts;

		public String toString() {
			return "[" + "regionOfInterest = " + Arrays.toString(regionOfInterest) + ", " + "dampeningFactor = " + dampeningFactor + ", " + "clipLimit = " + Arrays.toString(clipLimit) + ", " + "emptyCounts = " + emptyCounts + "]";
		}
	}

	public class FluxLinearParameters {
		public int sceneEmissivity;
		public int temperatureBackground;
		public int tauWindow;
		public int temperaturWindow;
		public int tauAtmosphere;
		public int temperatureAtmosphere;
		public int reflectionWindow;
		public int temperatureReflection;

		public String toString() {
			return "[" + "sceneEmissivity = " + sceneEmissivity + ", " + "temperatureBackground = " + temperatureBackground + ", " + "tauWindow = " + tauWindow + ", " + "temperaturWindow = " + temperaturWindow + ", " + "tauAtmosphere = " + tauAtmosphere + ", " + "temperatureAtmosphere = " + temperatureAtmosphere + ", " + "reflectionWindow = " + reflectionWindow + ", " + "temperatureReflection = " + temperatureReflection + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * @see HighContrastImageListener
	 */
	public interface HighContrastImageLowLevelListener extends DeviceListener {
		public void highContrastImageLowLevel(int imageChunkOffset, int[] imageChunkData);
	}

	/**
	 * @see TemperatureImageListener
	 */
	public interface TemperatureImageLowLevelListener extends DeviceListener {
		public void temperatureImageLowLevel(int imageChunkOffset, int[] imageChunkData);
	}

	/**
	 * This listener is triggered with every new high contrast image if the transfer image
	 * config is configured for high contrast listener (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for image.
	 */
	public interface HighContrastImageListener extends DeviceListener {
		public void highContrastImage(int[] image);
	}

	/**
	 * This listener is triggered with every new temperature image if the transfer image
	 * config is configured for temperature listener (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for image.
	 */
	public interface TemperatureImageListener extends DeviceListener {
		public void temperatureImage(int[] image);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletThermalImaging(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATISTICS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_RESOLUTION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_RESOLUTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_SPOTMETER_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPOTMETER_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_HIGH_CONTRAST_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_HIGH_CONTRAST_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_IMAGE_TRANSFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IMAGE_TRANSFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FLUX_LINEAR_PARAMETERS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FLUX_LINEAR_PARAMETERS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		highLevelCallbacks[-CALLBACK_HIGH_CONTRAST_IMAGE] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_HIGH_CONTRAST_IMAGE_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 72) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int imageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
				int[] imageChunkData = new int[62];
				for (int i = 0; i < 62; i++) {
					imageChunkData[i] = IPConnectionBase.unsignedByte(bb.get());
				}

				IPConnectionBase.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_HIGH_CONTRAST_IMAGE];
				int imageChunkLength = Math.min(4800 - imageChunkOffset, 62);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (imageChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[4800];
						highLevelCallback.length = imageChunkLength;

						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, 0, imageChunkLength);

						if (highLevelCallback.length >= 4800) { // stream complete
							for (HighContrastImageListener listener: listenerHighContrastImage) {
								listener.highContrastImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (imageChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (HighContrastImageListener listener: listenerHighContrastImage) {
							listener.highContrastImage((int[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, imageChunkLength);
						highLevelCallback.length += imageChunkLength;

						if (highLevelCallback.length >= 4800) { // stream complete
							for (HighContrastImageListener listener: listenerHighContrastImage) {
								listener.highContrastImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (HighContrastImageLowLevelListener listener: listenerHighContrastImageLowLevel) {
					listener.highContrastImageLowLevel(imageChunkOffset, imageChunkData);
				}
			}
		};

		highLevelCallbacks[-CALLBACK_TEMPERATURE_IMAGE] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_TEMPERATURE_IMAGE_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				if (packet.length != 72) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int imageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
				int[] imageChunkData = new int[31];
				for (int i = 0; i < 31; i++) {
					imageChunkData[i] = IPConnectionBase.unsignedShort(bb.getShort());
				}

				IPConnectionBase.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_TEMPERATURE_IMAGE];
				int imageChunkLength = Math.min(4800 - imageChunkOffset, 31);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (imageChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[4800];
						highLevelCallback.length = imageChunkLength;

						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, 0, imageChunkLength);

						if (highLevelCallback.length >= 4800) { // stream complete
							for (TemperatureImageListener listener: listenerTemperatureImage) {
								listener.temperatureImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (imageChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (TemperatureImageListener listener: listenerTemperatureImage) {
							listener.temperatureImage((int[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, imageChunkLength);
						highLevelCallback.length += imageChunkLength;

						if (highLevelCallback.length >= 4800) { // stream complete
							for (TemperatureImageListener listener: listenerTemperatureImage) {
								listener.temperatureImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (TemperatureImageLowLevelListener listener: listenerTemperatureImageLowLevel) {
					listener.temperatureImageLowLevel(imageChunkOffset, imageChunkData);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the current high contrast image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between
	 * High Contrast and Temperature Image. If you don't know what to use
	 * the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public HighContrastImageLowLevel getHighContrastImageLowLevel() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		HighContrastImageLowLevel obj = new HighContrastImageLowLevel();
		obj.imageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 62; i++) {
			obj.imageChunkData[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return obj;
	}

	/**
	 * Returns the current temperature image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between High Contrast and Temperature Image.
	 * If you don't know what to use the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public TemperatureImageLowLevel getTemperatureImageLowLevel() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array(), 72);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureImageLowLevel obj = new TemperatureImageLowLevel();
		obj.imageChunkOffset = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 31; i++) {
			obj.imageChunkData[i] = IPConnectionBase.unsignedShort(bb.getShort());
		}

		return obj;
	}

	/**
	 * Returns the spotmeter statistics, various temperatures, current resolution and status bits.
	 * 
	 * The spotmeter statistics are:
	 * 
	 * * Index 0: Mean Temperature.
	 * * Index 1: Maximum Temperature.
	 * * Index 2: Minimum Temperature.
	 * * Index 3: Pixel Count of spotmeter region of interest.
	 * 
	 * The temperatures are:
	 * 
	 * * Index 0: Focal Plain Array temperature.
	 * * Index 1: Focal Plain Array temperature at last FFC (Flat Field Correction).
	 * * Index 2: Housing temperature.
	 * * Index 3: Housing temperature at last FFC.
	 * 
	 * The resolution is either `0 to 6553 Kelvin` or `0 to 655 Kelvin`. If the resolution is the former,
	 * the temperatures are in Kelvin/10, if it is the latter the temperatures are in Kelvin/100.
	 * 
	 * FFC (Flat Field Correction) Status:
	 * 
	 * * FFC Never Commanded: Only seen on startup before first FFC.
	 * * FFC Imminent: This state is entered 2 seconds prior to initiating FFC.
	 * * FFC In Progress: Flat field correction is started (shutter moves in front of lens and back). Takes about 1 second.
	 * * FFC Complete: Shutter is in waiting position again, FFC done.
	 * 
	 * Temperature warning bits:
	 * 
	 * * Index 0: Shutter lockout (if true shutter is locked out because temperature is outside -10°C to +65°C)
	 * * Index 1: Overtemperature shut down imminent (goes true 10 seconds before shutdown)
	 */
	public Statistics getStatistics() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATISTICS, this);


		byte[] response = sendRequest(bb.array(), 27);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Statistics obj = new Statistics();
		for (int i = 0; i < 4; i++) {
			obj.spotmeterStatistics[i] = IPConnectionBase.unsignedShort(bb.getShort());
		}
		for (int i = 0; i < 4; i++) {
			obj.temperatures[i] = IPConnectionBase.unsignedShort(bb.getShort());
		}
		obj.resolution = IPConnectionBase.unsignedByte(bb.get());
		obj.ffcStatus = IPConnectionBase.unsignedByte(bb.get());
		byte[] temperatureWarningBits = new byte[1];
		bb.get(temperatureWarningBits);
		for (int i = 0; i < 2; i++) {
			obj.temperatureWarning[i] = (temperatureWarningBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return obj;
	}

	/**
	 * Sets the resolution. The Thermal Imaging Bricklet can either measure
	 * 
	 * * from 0 to 6553 Kelvin (-273.15°C to +6279.85°C) with 0.1°C resolution or
	 * * from 0 to 655 Kelvin (-273.15°C to +381.85°C) with 0.01°C resolution.
	 * 
	 * The accuracy is specified for -10°C to 450°C in the
	 * first range and -10°C and 140°C in the second range.
	 */
	public void setResolution(int resolution) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_RESOLUTION, this);

		bb.put((byte)resolution);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the resolution as set by {@link BrickletThermalImaging#setResolution(int)}.
	 */
	public int getResolution() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_RESOLUTION, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int resolution = IPConnectionBase.unsignedByte(bb.get());

		return resolution;
	}

	/**
	 * Sets the spotmeter region of interest. The 4 values are
	 * 
	 * * Index 0: Column start (has to be smaller then Column end).
	 * * Index 1: Row start (has to be smaller then Row end).
	 * * Index 2: Column end (has to be smaller then 80).
	 * * Index 3: Row end (has to be smaller then 60).
	 * 
	 * The spotmeter statistics can be read out with {@link BrickletThermalImaging#getStatistics()}.
	 */
	public void setSpotmeterConfig(int[] regionOfInterest) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SPOTMETER_CONFIG, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)regionOfInterest[i]);
		}

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the spotmeter config as set by {@link BrickletThermalImaging#setSpotmeterConfig(int[])}.
	 */
	public int[] getSpotmeterConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPOTMETER_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int[] regionOfInterest = new int[4];
		for (int i = 0; i < 4; i++) {
			regionOfInterest[i] = IPConnectionBase.unsignedByte(bb.get());
		}

		return regionOfInterest;
	}

	/**
	 * Sets the high contrast region of interest, dampening factor, clip limit and empty counts.
	 * This config is only used in high contrast mode (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The high contrast region of interest consists of four values:
	 * 
	 * * Index 0: Column start (has to be smaller or equal then Column end).
	 * * Index 1: Row start (has to be smaller then Row end).
	 * * Index 2: Column end (has to be smaller then 80).
	 * * Index 3: Row end (has to be smaller then 60).
	 * 
	 * The algorithm to generate the high contrast image is applied to this region.
	 * 
	 * Dampening Factor: This parameter is the amount of temporal dampening applied to the HEQ
	 * (history equalization) transformation function. An IIR filter of the form::
	 * 
	 *  (N / 256) * previous + ((256 - N) / 256) * current
	 * 
	 * is applied, and the HEQ dampening factor
	 * represents the value N in the equation, i.e., a value that applies to the amount of
	 * influence the previous HEQ transformation function has on the current function. The
	 * lower the value of N the higher the influence of the current video frame whereas
	 * the higher the value of N the more influence the previous damped transfer function has.
	 * 
	 * Clip Limit Index 0 (AGC HEQ Clip Limit High): This parameter defines the maximum number of pixels allowed
	 * to accumulate in any given histogram bin. Any additional pixels in a given bin are clipped.
	 * The effect of this parameter is to limit the influence of highly-populated bins on the
	 * resulting HEQ transformation function.
	 * 
	 * Clip Limit Index 1 (AGC HEQ Clip Limit Low): This parameter defines an artificial population that is added to
	 * every non-empty histogram bin. In other words, if the Clip Limit Low is set to L, a bin
	 * with an actual population of X will have an effective population of L + X. Any empty bin
	 * that is nearby a populated bin will be given an artificial population of L. The effect of
	 * higher values is to provide a more linear transfer function; lower values provide a more
	 * non-linear (equalized) transfer function.
	 * 
	 * Empty Counts: This parameter specifies the maximum number of pixels in a bin that will be
	 * interpreted as an empty bin. Histogram bins with this number of pixels or less will be
	 * processed as an empty bin.
	 */
	public void setHighContrastConfig(int[] regionOfInterest, int dampeningFactor, int[] clipLimit, int emptyCounts) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)20, FUNCTION_SET_HIGH_CONTRAST_CONFIG, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)regionOfInterest[i]);
		}
		bb.putShort((short)dampeningFactor);
		for (int i = 0; i < 2; i++) {
			bb.putShort((short)clipLimit[i]);
		}
		bb.putShort((short)emptyCounts);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the high contrast config as set by {@link BrickletThermalImaging#setHighContrastConfig(int[], int, int[], int)}.
	 */
	public HighContrastConfig getHighContrastConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HIGH_CONTRAST_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 20);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		HighContrastConfig obj = new HighContrastConfig();
		for (int i = 0; i < 4; i++) {
			obj.regionOfInterest[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.dampeningFactor = IPConnectionBase.unsignedShort(bb.getShort());
		for (int i = 0; i < 2; i++) {
			obj.clipLimit[i] = IPConnectionBase.unsignedShort(bb.getShort());
		}
		obj.emptyCounts = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * The necessary bandwidth of this Bricklet is too high to use getter/listener or
	 * high contrast/temperature image at the same time. You have to configure the one
	 * you want to use, the Bricklet will optimize the internal configuration accordingly.
	 * 
	 * Corresponding functions:
	 * 
	 * * Manual High Contrast Image: {@link BrickletThermalImaging#getHighContrastImage()}.
	 * * Manual Temperature Image: {@link BrickletThermalImaging#getTemperatureImage()}.
	 * * Listener High Contrast Image: {@link BrickletThermalImaging.HighContrastImageListener} listener.
	 * * Listener Temperature Image: {@link BrickletThermalImaging.TemperatureImageListener} listener.
	 */
	public void setImageTransferConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_IMAGE_TRANSFER_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the image transfer config, as set by {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int getImageTransferConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IMAGE_TRANSFER_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Sets the flux linear parameters that can be used for radiometry calibration.
	 * 
	 * See FLIR document 102-PS245-100-01 for more details.
	 * 
	 * .. versionadded:: 2.0.5$nbsp;(Plugin)
	 */
	public void setFluxLinearParameters(int sceneEmissivity, int temperatureBackground, int tauWindow, int temperaturWindow, int tauAtmosphere, int temperatureAtmosphere, int reflectionWindow, int temperatureReflection) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)24, FUNCTION_SET_FLUX_LINEAR_PARAMETERS, this);

		bb.putShort((short)sceneEmissivity);
		bb.putShort((short)temperatureBackground);
		bb.putShort((short)tauWindow);
		bb.putShort((short)temperaturWindow);
		bb.putShort((short)tauAtmosphere);
		bb.putShort((short)temperatureAtmosphere);
		bb.putShort((short)reflectionWindow);
		bb.putShort((short)temperatureReflection);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the flux linear parameters, as set by {@link BrickletThermalImaging#setFluxLinearParameters(int, int, int, int, int, int, int, int)}.
	 * 
	 * .. versionadded:: 2.0.5$nbsp;(Plugin)
	 */
	public FluxLinearParameters getFluxLinearParameters() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FLUX_LINEAR_PARAMETERS, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		FluxLinearParameters obj = new FluxLinearParameters();
		obj.sceneEmissivity = IPConnectionBase.unsignedShort(bb.getShort());
		obj.temperatureBackground = IPConnectionBase.unsignedShort(bb.getShort());
		obj.tauWindow = IPConnectionBase.unsignedShort(bb.getShort());
		obj.temperaturWindow = IPConnectionBase.unsignedShort(bb.getShort());
		obj.tauAtmosphere = IPConnectionBase.unsignedShort(bb.getShort());
		obj.temperatureAtmosphere = IPConnectionBase.unsignedShort(bb.getShort());
		obj.reflectionWindow = IPConnectionBase.unsignedShort(bb.getShort());
		obj.temperatureReflection = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array(), 24);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnectionBase.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnectionBase.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletThermalImaging#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnectionBase.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletThermalImaging#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletThermalImaging#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnectionBase.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletThermalImaging#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnectionBase.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnectionBase.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current high contrast image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between
	 * High Contrast and Temperature Image. If you don't know what to use
	 * the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int[] getHighContrastImage() throws TinkerforgeException {
		HighContrastImageLowLevel ret;
		int[] image = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int imageLength = 4800;
		int imageChunkOffset;
		int imageChunkLength;
		boolean imageOutOfSync;
		int imageCurrentLength;

		synchronized (streamMutex) {
			ret = getHighContrastImageLowLevel();

			if (ret.imageChunkOffset == (1 << 16) - 1) { // maximum chunk offset -> stream has no data
				imageLength = 0;
				imageChunkOffset = 0;
				imageOutOfSync = false;
			} else {
				imageChunkOffset = ret.imageChunkOffset;
				imageOutOfSync = imageChunkOffset != 0;
			}

			if (!imageOutOfSync) {
				image = new int[imageLength];
				imageChunkLength = Math.min(imageLength - imageChunkOffset, 62);

				System.arraycopy(ret.imageChunkData, 0, image, 0, imageChunkLength);

				imageCurrentLength = imageChunkLength;

				while (imageCurrentLength < imageLength) {
					ret = getHighContrastImageLowLevel();
					imageOutOfSync = ret.imageChunkOffset != imageCurrentLength;

					if (imageOutOfSync) {
						break;
					}

					imageChunkLength = Math.min(imageLength - ret.imageChunkOffset, 62);

					System.arraycopy(ret.imageChunkData, 0, image, imageCurrentLength, imageChunkLength);

					imageCurrentLength += imageChunkLength;
				}
			}

			if (imageOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.imageChunkOffset + 62 < imageLength) {
					ret = getHighContrastImageLowLevel();
				}

				throw new StreamOutOfSyncException("Image stream is out-of-sync");
			}
		}

		return image;
	}

	/**
	 * Returns the current temperature image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between High Contrast and Temperature Image.
	 * If you don't know what to use the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int[] getTemperatureImage() throws TinkerforgeException {
		TemperatureImageLowLevel ret;
		int[] image = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int imageLength = 4800;
		int imageChunkOffset;
		int imageChunkLength;
		boolean imageOutOfSync;
		int imageCurrentLength;

		synchronized (streamMutex) {
			ret = getTemperatureImageLowLevel();

			if (ret.imageChunkOffset == (1 << 16) - 1) { // maximum chunk offset -> stream has no data
				imageLength = 0;
				imageChunkOffset = 0;
				imageOutOfSync = false;
			} else {
				imageChunkOffset = ret.imageChunkOffset;
				imageOutOfSync = imageChunkOffset != 0;
			}

			if (!imageOutOfSync) {
				image = new int[imageLength];
				imageChunkLength = Math.min(imageLength - imageChunkOffset, 31);

				System.arraycopy(ret.imageChunkData, 0, image, 0, imageChunkLength);

				imageCurrentLength = imageChunkLength;

				while (imageCurrentLength < imageLength) {
					ret = getTemperatureImageLowLevel();
					imageOutOfSync = ret.imageChunkOffset != imageCurrentLength;

					if (imageOutOfSync) {
						break;
					}

					imageChunkLength = Math.min(imageLength - ret.imageChunkOffset, 31);

					System.arraycopy(ret.imageChunkData, 0, image, imageCurrentLength, imageChunkLength);

					imageCurrentLength += imageChunkLength;
				}
			}

			if (imageOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.imageChunkOffset + 31 < imageLength) {
					ret = getTemperatureImageLowLevel();
				}

				throw new StreamOutOfSyncException("Image stream is out-of-sync");
			}
		}

		return image;
	}

	/**
	 * Adds a HighContrastImageLowLevel listener.
	 */
	public void addHighContrastImageLowLevelListener(HighContrastImageLowLevelListener listener) {
		listenerHighContrastImageLowLevel.add(listener);
	}

	/**
	 * Removes a HighContrastImageLowLevel listener.
	 */
	public void removeHighContrastImageLowLevelListener(HighContrastImageLowLevelListener listener) {
		listenerHighContrastImageLowLevel.remove(listener);
	}

	/**
	 * Adds a TemperatureImageLowLevel listener.
	 */
	public void addTemperatureImageLowLevelListener(TemperatureImageLowLevelListener listener) {
		listenerTemperatureImageLowLevel.add(listener);
	}

	/**
	 * Removes a TemperatureImageLowLevel listener.
	 */
	public void removeTemperatureImageLowLevelListener(TemperatureImageLowLevelListener listener) {
		listenerTemperatureImageLowLevel.remove(listener);
	}

	/**
	 * Adds a HighContrastImage listener.
	 */
	public void addHighContrastImageListener(HighContrastImageListener listener) {
		listenerHighContrastImage.add(listener);
	}

	/**
	 * Removes a HighContrastImage listener.
	 */
	public void removeHighContrastImageListener(HighContrastImageListener listener) {
		listenerHighContrastImage.remove(listener);
	}

	/**
	 * Adds a TemperatureImage listener.
	 */
	public void addTemperatureImageListener(TemperatureImageListener listener) {
		listenerTemperatureImage.add(listener);
	}

	/**
	 * Removes a TemperatureImage listener.
	 */
	public void removeTemperatureImageListener(TemperatureImageListener listener) {
		listenerTemperatureImage.remove(listener);
	}
}
